package CustomGroups;

use strict;
use warnings;

#use Data::Dumper;

my %grp;
my @rawacl;
my @cfggrp;    # array of groups from acl.cfg

my $basedir = $ENV{INPUTDIR} ||= "/home/lpar2rrd/lpar2rrd";

my $cfgdir     = "$basedir/etc/web_config";
my $realcfgdir = "$basedir/etc";
if ( defined $ENV{TMPDIR_LPAR} ) {
  my $tmpdir = $ENV{TMPDIR_LPAR};
}

sub readCfg {
  if ( !open( CFG, "$cfgdir/custom_groups.cfg" ) ) {
    if ( !open( CFG, "$realcfgdir/custom_groups.cfg" ) ) {
      if ( !open( CFG, ">$cfgdir/custom_groups.cfg" ) ) {
        print STDERR "Cannot open file $cfgdir/custom_groups.cfg: $!\n";
        die;
      }
      else {
        close CFG;
        if ( !open( CFG, "$cfgdir/custom_groups.cfg" ) ) {
          print STDERR "Cannot open file $cfgdir/custom_groups.cfg: $!\n";
          die;
        }
      } ## end else [ if ( !open( CFG, ">$cfgdir/custom_groups.cfg"...))]
    } ## end if ( !open( CFG, "$realcfgdir/custom_groups.cfg"...))
  } ## end if ( !open( CFG, "$cfgdir/custom_groups.cfg"...))

  while ( my $line = <CFG> ) {
    chomp($line);
    $line =~ s/\\:/===========doublecoma=========/g;    # workround for lpars/pool/groups with double coma inside the name
    $line =~ s/ *$//g;                                  # delete spaces at the end
    if ( $line =~ m/^$/
      || ( $line !~ m/^POOL/ && $line !~ m/^LPAR/ && $line !~ m/^VM/ && $line !~ m/^XENVM/ && $line !~ m/^OVIRTVM/ && $line !~ m/^SOLARISZONE/  && $line !~ m/^SOLARISLDOM/ )
      || $line =~ m/^#/
      || $line !~ m/:/
      || $line =~ m/:$/
      || $line =~ m/: *$/ )
    {
      next;
    } ## end if ( $line =~ m/^$/ ||...)
    my @val = split( /:/, $line );

    for (@val) {
      &doublecoma($_);
    }

    # my ($group, $cgrp, $srv, $lpar) = @val;
    my ( $type, $server, $name, $group_name, $collection ) = @val;

    push @rawacl, $line;

    push @cfggrp, $group_name;

    push @{ $grp{"$group_name"}{"children"}{$server} }, $name;
    $grp{"$group_name"}{"type"} = $type;
    if ($collection) {
      $grp{"$group_name"}{"collection"} = $collection;
    }

    # print Dumper \%grp;
  } ## end while ( my $line = <CFG> )
} ## end sub readCfg

sub getCfgGroups {
  &readCfg();
  return @cfggrp;
}

sub getGrp {
  &readCfg();
  return %grp;
}

sub getRawCfg {
  &readCfg();
  return @rawacl;
}

sub getCollections {
  &readCfg();
  my %coll;
  foreach my $cgrp ( keys %grp ) {
    my $colname = $grp{$cgrp}{"collection"};
    if ($colname) {
      $coll{collection}{$colname}{$cgrp} = 1;
    }
    else {
      $coll{nocollection}{$cgrp} = 1;
    }
  } ## end foreach my $cgrp ( keys %grp)
  return %coll;
} ## end sub getCollections

sub doublecoma {
  return s/===========doublecoma=========/:/g;
}

sub pipes {
  return s/===pipe===/\|/g;
}
1;
