#!/usr/bin/perl

use strict;
use warnings;

# use Data::Dumper;

use lib "../bin";    # maybe useless, but didn't work for me without that
use Alerting;        # use module

# get URL parameters (could be GET or POST) and put them into hash %PAR
my ( $buffer, @pairs, $pair, $name, $value, %PAR );

if ( !defined $ENV{'REQUEST_METHOD'} ) {
  print "Content-type: text/plain\n\n";
  print "No command specified, exiting...";
  exit;
}

if ( lc $ENV{'REQUEST_METHOD'} eq "post" ) {
  read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
}
else {
  $buffer = $ENV{'QUERY_STRING'};
}

# Split information into name/value pairs
@pairs = split( /&/, $buffer );
foreach $pair (@pairs) {
  ( $name, $value ) = split( /=/, $pair );
  $value =~ tr/+/ /;
  $value =~ s/%(..)/pack("C", hex($1))/eg;
  if ( exists $PAR{$name} ) {
    if ( ref $PAR{$name} eq "ARRAY" ) {
      push @{ $PAR{$name} }, $value;
    }
    else {
      my $firstVal = $PAR{$name};
      $PAR{$name} = [];
      push @{ $PAR{$name} }, $firstVal;
      push @{ $PAR{$name} }, $value;
    } ## end else [ if ( ref $PAR{$name} eq...)]
  } ## end if ( exists $PAR{$name...})
  else {
    $PAR{$name} = $value;
  }
} ## end foreach $pair (@pairs)

# print STDERR Dumper \%PAR;

if ( !defined $PAR{cmd} ) {
  print "Content-type: text/plain\n\n";
  print "No command specified, exiting...";
  exit;
}

if ( $PAR{cmd} eq "test" ) {    ### Get list of credentials
  print "Content-type: text/html\n\n";
  print "<pre>";
  print Dumper \%ENV;
  print Dumper \%PAR;

} ## end if ( $PAR{cmd} eq "test")

elsif ( $PAR{cmd} eq "file") { ### Get raw cfg file
    print "Content-type: text/plain\n\n";
    Alerting::printConfig();
} ## end if ($PAR{cmd} eq "file")

elsif ( $PAR{cmd} eq "form" ) {    ### Get list of credentials

  my %cfg = Alerting::getConfig();

  print "Content-type: text/html\n\n";

  no warnings 'uninitialized';

  # TABs
  print <<_MARKER_;
<div id='tabs' style='text-align: center;'>
  <ul>
    <li><a href='#tabs-1'>Alerts</a></li>
    <li><a href='#tabs-2'>E-mail groups</a></li>
    <li><a href='#tabs-3'>Options</a></li>
    <li><a href='/lpar2rrd-cgi/log-cgi.sh?name=alhist&gui=1'>Alerting log</a></li>
  </ul>

_MARKER_

  print <<_MARKER_;
<div id='tabs-1' style='display: inline-block'>
  <div style='float: left; margin-right: 10px; outline: none'>
    <fieldset class='estimator cggrpnames'>
      <table id="alrttree" class="cfgtree">
        <colgroup>
          <col width="2px">
          <col width="2px">
          <col width="220px">
          <col width="80px">
          <col width="45px">
          <col width="40px">
          <col width="45px">
          <col width="60px">
          <col width="120px">
          <col width="80px">
          <col width="20px">
        </colgroup>
        <thead>
        <tr>
          <th></th>
          <th></th>
          <th><button id="toggle" title="Expand/Collapse toggle" class="ui-icon-arrowthick-2-n-s">&plusmn;</button> <button id="addnewalrt">Add New Alert</button></th>
          <th>Metric</th>
          <th><abbr title="limit value">Limit</abbr></th>
          <th><abbr title="value is in percent (CPU & CPU OS only)">%</abbr></th>
          <th><abbr title="time in minutes for length peak above the limit [10-unlimited]">Peak</abbr></th>
          <th><abbr title="minimum time in minutes between 2 alerts for the same rule [10-unlimited]">Repeat</abbr></th>
          <th><abbr title="time range in hours when the alerting is off [0-24]-[0-24]. Ex. 22-05&nbsp;(excludes alerting from 10pm to 5am)">Exclude hours</abbr></th>
          <th>Mail group</th>
          <th></th>
          <!--th><button id="cgcfg-help-button" title="Help on usage">?</button></th-->
        </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    </fieldset>
    <div style="text-align: center">
      <!--input type='submit' style='font-weight: bold; margin-top: .7em' name='testbtn' id='testalrtcfg' value='Test alerting'-->
      <input type='submit' style='font-weight: bold; margin-top: .7em' name='savegrp' class='savealrtcfg' value='Save configuration'>
    </div>
    <p class="notice">This feature is not supported yet for oVirt/RHV, XenServer, Solaris and MS Windows server/Hyper-V. It will come in future releases.</p>
  </div>

  <br style="clear: both">
  <pre>
  <div id='aclfile' style='text-align: left; margin: auto; background: #fcfcfc; border: 1px solid #c0ccdf; border-radius: 10px; padding: 15px; display: none; overflow: auto'></div>
  </pre>
</div>

<div id='tabs-2' style='display: inline-block'>
  <div style='float: left; margin-right: 10px; outline: none'>
    <fieldset class='estimator cggrpnames'>
      <table id="alrtgrptree" class="cfgtree">
        <colgroup>
          <col width="2px">
          <col width="2px">
          <col width="320px">
          <col width="4px">
          <col width="20px">
        </colgroup>
        <thead>
        <tr>
        <th></th>
        <th></th>
        <th id="addcgrpth">E-mail group &nbsp;<button id="addalrtgrp">Add New</button></th>
        <th></th>
        <!--th><button id="cgcfg-help-button" title="Help on usage">?</button></th-->
        </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    </fieldset>
    <div style="text-align: center">
      <input type='submit' style='font-weight: bold; margin-top: .7em' name='savegrp' class='savealrtcfg' value='Save configuration'>
    </div>
  </div>
</div>
<style>
#optform  {
  display: table;
}
#optform div {
  display: table-row;
}
#optform label {
  display: table-cell;
}
#optform input {
  display: table-cell;
}
</style>
<div id='tabs-3' style='display: inline-block'>
  <div style='float: left; margin-right: 10px; outline: none'>
    <form id="optform" method="post" action="" style="display: table;">
    <fieldset>
    <div>
      <label for="element_2">Nagios alerting &nbsp;</label>
      <input id="element_2" name="NAGIOS" class="alrtoption text medium" type="text" maxlength="255" title="Call this script from nrpe.cfg: bin/check_lpar2rrd<br>More details on <a href='http://www.lpar2rrd.com/nagios.html'>http://www.lpar2rrd.com/nagios.html</a><br>[0/1] on/off" value="$cfg{NAGIOS}">
    </div>
    <div>
    <label for="element_3">External script for alerting &nbsp;</label>
      <input id="element_3" name="EXTERN_ALERT" class="alrtoption text medium" type="text" maxlength="255" title="It will be called once an alarm appears with these 6 parameters:<br>script.sh [SEVERITY] [TYPE] [SERVER] [LPAR_or_POOL] [ACT_UTILIZATION] [MAX_UTLIZATION_LIMIT] <br>- you can use <b>bin/external_alert_example.sh</b> as an example<br>- script must be placed in <b>{LPAR2RRD_HOME}/bin</b> and path start with <b>bin/</b>" value="$cfg{EXTERN_ALERT}">
    </div>
    <div>
    <label for="element_4">Include graphs &nbsp;</label>
      <input id="element_4" name="EMAIL_GRAPH" class="alrtoption text medium" type="text" maxlength="255" title="Include graphs into the email notification.<br>Any positive number gives number of hours which the graph contains. Examples: <br>0 - false<br>8 - last 8 hours in the graph<br>25 - last 25 hours in the graph<br>[0 - 256]" value="$cfg{EMAIL_GRAPH}">
    </div>
    <div>
    <label for="element_5">Default repeat time (min)&nbsp;</label>
      <input id="element_5" name="REPEAT_DEFAULT" class="alrtoption text medium" type="text" maxlength="255" title="Default time in minutes which says how often you should be alerted. You can specify per volume different value in <b>alert repeat time</b> column of each ALERT<br>[5 - 168]" value="$cfg{REPEAT_DEFAULT}">
    </div>
    <div>
    <label for="element_6">Default peak time (min)&nbsp;</label>
      <input id="element_6" name="PEAK_TIME_DEFAULT" class="alrtoption text medium" type="text" maxlength="255" title="The period of time in which avg traffic utilization has to be over the specified limit to generate an alert.<br>You can change it per volume level in <b>time in min</b> column of each ALERT note.<br> [15 - 120]" value="$cfg{PEAK_TIME_DEFAULT}">
    </div>
    <div>
    <label for="element_7">SNMP trap host&nbsp;</label>
      <input id="element_7" name="TRAP" class="alrtoption text medium" type="text" maxlength="80" title="Hostname or IP of SNMP trap receiver.<br> []" value="$cfg{TRAP}">
    </div>
    <div>
    <label for="element_9">Mail from&nbsp;</label>
      <input id="element_9" name="MAILFROM" class="alrtoption text medium" type="text" maxlength="80" title="Mail from" value="$cfg{MAILFROM}">
    </div>
    </fieldset>
    <div style="text-align: center">
      <input type='submit' style='font-weight: bold; margin-top: .7em' name='savegrp' class='savealrtcfg' value='Save configuration'>
    </div>
    </form>
  </div>
</div>

</div>
_MARKER_

} ## end elsif ( $PAR{cmd} eq "form")
elsif ( $PAR{cmd} eq "save" ) {    ### Get list of credentials
  my $basedir = $ENV{INPUTDIR};
  $basedir ||= "..";

  my $cfgdir = "$basedir/etc/web_config";

  my $tmpdir = "$basedir/tmp";
  if ( defined $ENV{TMPDIR_LPAR} ) {
    $tmpdir = $ENV{TMPDIR_LPAR};
  }
  print "Content-type: text/html\n\n";
  if ( $PAR{acl} ) {
    my $cfg    = $PAR{acl};
    my $retstr = "";
    if ( $ENV{'SERVER_NAME'} eq "demo.lpar2rrd.com" ) {
      $cfg =~ s/\n/\\n/g;
      $cfg =~ s/\\:/\\\\:/g;
      $retstr = "\"msg\" : \"<div>This demo site does not allow saving any changes you do in the admin GUI panel.<br />";
      $retstr .= "You can only see the preview of alerting.cfg to be written.</div>\", \"cfg\" : \"";
      print "{ \"status\" : \"success\", $retstr" . "$cfg\" }";
    } ## end if ( $ENV{'SERVER_NAME'...})
    elsif ( open( CFG, ">$cfgdir/alerting.cfg" ) ) {
      $cfg =~ s/\\:/===========doublecoma=========/g;
      print CFG "$cfg\n";
      close CFG;
      $cfg =~ s/\n/\\n/g;
      $cfg =~ s/\\:/\\\\:/g;
      $retstr = "\"msg\" : \"<div>Alerting configuration file has been succesfuly saved!<br /><br /></div>\", \"cfg\" : \"";
      print "{ \"status\" : \"success\", $retstr" . "$cfg\" }";
    } ## end elsif ( open( CFG, ">$cfgdir/alerting.cfg"...))
    else {
      print "{ \"status\" : \"fail\", \"msg\" : \"<div>File $cfgdir/alerting.cfg cannot be written by webserver, check apache user permissions: <span style='color: red'>$!</span></div>\" }";
    }
  } ## end if ( $PAR{acl} )
  else {
    print "{ \"status\" : \"fail\", \"msg\" : \"<div>No data was written to alerting.cfg</div>\" }";
  }

} ## end elsif ( $PAR{cmd} eq "save")

sub urldecode {
  my $s = shift;
  $s =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
  $s =~ s/\+/ /g;
  return $s;
} ## end sub urldecode
