#!/usr/bin/perl
# generates JSON data structures
use strict;
use warnings;
use File::Basename;
use RRDp;
use Xorux_lib qw(read_json);

# use CGI::Carp qw(fatalsToBrowser);

my $DEBUG                  = $ENV{DEBUG};
my $GUIDEBUG               = $ENV{GUIDEBUG};
my $DEMO                   = $ENV{DEMO};
my $BETA                   = $ENV{BETA};
my $version                = $ENV{version};
my $errlog                 = $ENV{ERRLOG};
my $basedir                = $ENV{INPUTDIR};
my $webdir                 = $ENV{WEBDIR};
my $inputdir               = $ENV{INPUTDIR};
my $dashb_rrdheight        = $ENV{DASHB_RRDHEIGHT};
my $dashb_rrdwidth         = $ENV{DASHB_RRDWIDTH};
my $legend_height          = $ENV{LEGEND_HEIGHT};
my $alturl                 = $ENV{WWW_ALTERNATE_URL};
my $alttmp                 = $ENV{WWW_ALTERNATE_TMP};
my $rrdtool                = $ENV{RRDTOOL};
my $LPAR_HEATMAP_UTIL_TIME = $ENV{LPAR_HEATMAP_UTIL_TIME};
my $HEATMAP_EXCLUDE_CPU    = $ENV{HEATMAP_EXCLUDE_CPU};
my $HEATMAP_MEM_PAGING_MAX;
my $wrkdir = "$basedir/data";
my @pool;
my @test;
my $end_time   = time();
my $start_time = $end_time - 3600;    # last hour
my $count_lpars;
my $count_lpars_vm;
my $height = 150;
my $width  = 600;
my $count_pools;
my $count_pools_vm;
my $count_mem_lpars_power;
my @pool_list;
my %heatmap_exclude;
my %ovirt;
my $count_server_ovirt = 0;
my $count_vm_ovirt = 0;
my %xen;
my $count_server_xen = 0;
my $count_vm_xen = 0;
my %class_color;

#my $HEATMAP_PANIC = 80;       # Setting a default values for colors
#my $HEATMAP_WARNING = 60;     # you can change setting values in etc/.magic

### set up utilization last x hour from variable LPAR_HEATMAP_UTIL_TIME
if ( defined $LPAR_HEATMAP_UTIL_TIME && isdigit($LPAR_HEATMAP_UTIL_TIME) ) {
  $start_time = $end_time - ( 3600 * $LPAR_HEATMAP_UTIL_TIME );

}
else {
  $LPAR_HEATMAP_UTIL_TIME = 1;
}

###

### in kB/s ###
if ( defined $ENV{HEATMAP_MEM_PAGING_MAX} ) {
  $HEATMAP_MEM_PAGING_MAX = $ENV{HEATMAP_MEM_PAGING_MAX};
}

else {
  $HEATMAP_MEM_PAGING_MAX = 50;
}

my %vmware;

my $style_html = "td.clr0 {background-color:#737a75;} td.clr1 {background-color:#008000;} td.clr2 {background-color:#29f929;} td.clr3 {background-color:#81fa51;} td.clr4 {background-color:#c9f433;} td.clr5 {background-color:#FFFF66;} td.clr6 {background-color:#ffff00;} td.clr7 {background-color:#FFCC00;} td.clr8 {background-color:#ffa500;} td.clr9 {background-color:#fa610e;} td.clr10 {background-color:#ff0000;}  table.center {margin-left:auto; margin-right:auto;} table {border-spacing: 1px;} .content_legend { height:" . "15" . "px" . "; width:" . "15" . "px" . ";}";

$class_color{clr0} = "#737a75";
$class_color{clr1} = "#008000";
$class_color{clr2} = "#29f929";
$class_color{clr3} = "#81fa51";
$class_color{clr4} = "#c9f433";
$class_color{clr5} = "#FFFF66";
$class_color{clr6} = "#ffff00";
$class_color{clr7} = "#FFCC00";
$class_color{clr8} = "#ffa500";
$class_color{clr9} = "#fa610e";
$class_color{clr10} = "#ff0000";


my @replace_file;
my %pools;
my %stree;        # Serverr
my %vclusters;    # Servers nested by clusters
my %lstree;       # LPARs by Server
my %lhtree;       # LPARs by HMC
my %vtree;        # VMware vCenter
my %cluster;      # VMware Cluster
my %respool;      # VMware Resource Pool
my @lnames;       # LPAR name (for autocomplete)
my %inventory;    # server / type / name
my %times;        # server timestamps
my $free;         # 1 -> free / 0 -> full
my $hasPower;     # flag for IBM Power presence
my $hasVMware;    # flag for WMware presence


print "heatmap        : start " . localtime() . "\n";

if ( !defined $ENV{INPUTDIR} ) {
  print STDERR "Not defined INPUTDIR, probably not read etc/lpar2rrd.cfg\n";
  exit(0);
}

if ( !-f "$rrdtool" ) {
  error("Set correct path to rrdtool binary, it does not exist here: $rrdtool");
  exit;
}

RRDp::start "$rrdtool";

my $cpu_max_filter = 100;    # my $cpu_max_filter = 100;  # max 10k peak in % is allowed (in fact it cannot by higher than 1k now when 1 logical CPU == 0.1 entitlement)
if ( defined $ENV{CPU_MAX_FILTER} ) {
  $cpu_max_filter = $ENV{CPU_MAX_FILTER};
}

# set unbuffered stdout
#$| = 1;

# open( OUT, ">> $errlog" ) if $DEBUG == 2;

# get QUERY_STRING
use Env qw(QUERY_STRING);

# print OUT "-- $QUERY_STRING\n" if $DEBUG == 2;

#`echo "QS $QUERY_STRING " >> /tmp/xx32`;
my ( $type, $par1, $par2 );
if ( defined $QUERY_STRING ) {
  ( $type, $par1, $par2 ) = split( /&/, $QUERY_STRING );
}

if ( !defined $type || $type eq "" ) {
  if (@ARGV) {
    $type = "type=" . $ARGV[0];

    #$basedir  = "..";
  }
  else {
    $type = "type=test";
  }
} ## end if ( !defined $type ||...)

$type =~ s/type=//;
$type = "test";

if ( $type eq "test" ) {

  #$basedir = "..";
  #$wrkdir = "/home/lpar2rrd/lpar2rrd/data";
  &test();
  RRDp::end;    # close RRD pipe
  exit;
} ## end if ( $type eq "test" )

#if ( $type eq "dump" ) {
#    &dumpHTML();
#    RRDp::end; # close RRD pipe
#    exit;
#}

RRDp::end;    # close RRD pipe

sub test {

  #print "Content-type: text/plain\n\n";
  use Data::Dumper;

  #print "heatmap        : start ". time() . "\n";
  #	print Dumper @aclServ;
  # print Dumper \%aclLpars;
  &readMenu();

  # print Dumper \%lhtree;
  # print Dumper \%vtree;
  # print Dumper \%vclusters;
  # print Dumper \%lstree;
  #print Dumper \%pools;
  #print Dumper \%inventory;
  #%vmware = %inventory;

  ### customer requirement
  my $file = "$basedir/etc/heatmap_exclude.cfg";
  my @data_exclude = ();
  if (-e $file && !-z $file){
    open( FH, "< $file" ) || error( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ ) && next;
    @data_exclude = <FH>;
    close(FH);
  }
  foreach my $line (@data_exclude){
    chomp $line;
    $line =~ s/^\s+|\s+$//g;
    if ($line eq ""){next;}
    if ($line =~ m/^LPAR/i){
      $line =~ s/^LPAR://i;
      $line =~ s/^\s+|\s+$//g;
      if (!defined $line || $line eq ""){next;}
      $heatmap_exclude{POWER}{LPAR}{$line} = $line;
    }
    if ($line =~ m/^CPUPOOL:/i){
      $line =~ s/^CPUPOOL://i;
      $line =~ s/^\s+|\s+$//g;
      if (!defined $line || $line eq ""){next;}
      if ($line eq "cpupool"){
        $line = "CPU pool";
      }
      $heatmap_exclude{POWER}{POOL}{$line} = $line;
    }
    if ($line =~ m/^VM:/i){
      $line =~ s/^VM://i;
      $line =~ s/^\s+|\s+$//g;
      if (!defined $line || $line eq ""){next;}
      $heatmap_exclude{VMWARE}{LPAR}{$line} = $line;
    }
    if ($line =~ m/^ESXI:/i){
      $line =~ s/^ESXI://i;
      $line =~ s/^\s+|\s+$//g;
      if (!defined $line || $line eq ""){next;}
      $heatmap_exclude{VMWARE}{SERVER}{$line} = $line;
    }
  }


  #print Dumper \%heatmap_exclude;
  foreach my $server (keys %inventory){
    my $type = $inventory{$server}{TYPE};
    if (!defined $type || $type ne "P"){next;}
    foreach my $pool (keys %{$inventory{$server}{POOL}}){
      my $name = $inventory{$server}{POOL}{$pool}{NAME};
      if (!defined $name || $name eq ""){
        $name = $pool;
      }
      if (defined $heatmap_exclude{POWER}{POOL}{$name}){
        delete $inventory{$server}{POOL}{$pool};
      }
    }
    foreach my $lpar (keys %{$inventory{$server}{LPAR}}){
      my $name = $inventory{$server}{LPAR}{$lpar}{NAME};
      if (!defined $name || $name eq ""){
        $name = $lpar;
      }
      if (defined $heatmap_exclude{POWER}{LPAR}{$name}){
        delete $inventory{$server}{LPAR}{$lpar};
      }
    }
  }


  foreach my $server (keys %inventory){
    my $type = $inventory{$server}{TYPE};
    if (!defined $type || $type ne "V"){next;}
    if (defined $heatmap_exclude{VMWARE}{SERVER}{$server}){
      delete $inventory{$server};
      next;
    }
    foreach my $lpar (keys %{$inventory{$server}{LPAR}}){
      my $name = $inventory{$server}{LPAR}{$lpar}{NAME};
      if (!defined $name || $name eq ""){
        $name = $lpar;
      }
      if (defined $heatmap_exclude{VMWARE}{LPAR}{$name}){
        delete $inventory{$server}{LPAR}{$lpar};
      }
    }
  }
  #print Dumper \%inventory;
  ###
  %vmware = %inventory;

  my $system_machine = "";
  if ( defined $ARGV[0] && $ARGV[0] eq "power" ) {
    $system_machine = "power";
  }
  if ( defined $ARGV[0] && $ARGV[0] eq "vmware" ) {
    $system_machine = "vmware";
  }
  if ( defined $ARGV[0] && $ARGV[0] eq "ovirt" ) {
    $system_machine = "ovirt";
  }

  if ( $system_machine eq "power" ) {
    set_live_inventory();
    set_curr_procs();
    set_utilization_cpu_power();
    set_utilization_pool_power();
    set_utilization_mem_power();
    set_html_power();

    if (-f "$basedir/tmp/menu_ovirt.json"){

      set_structure_ovirt();
      set_utilization_ovirt("SERVER","CPU");
      set_utilization_ovirt("SERVER","MEMORY");
      set_utilization_ovirt("VM","CPU");
      set_utilization_ovirt("VM","MEMORY");
      print "heatmap        : (Ovirt) set cpu utilization for $count_vm_ovirt vms\n";
      print "heatmap        : (Ovirt) set memory utilization for $count_vm_ovirt vms\n";
      print "heatmap        : (Ovirt) set cpu utilization for $count_server_ovirt servers\n";
      print "heatmap        : (Ovirt) set memory utilization for $count_server_ovirt servers\n";
      set_html_ovirt();
    } ## end if ( $system_machine eq...)
    if (-f "$basedir/tmp/menu_xenserver.json"){
      set_structure_xen();
      set_utilization_xen("SERVER","CPU");
      set_utilization_xen("SERVER","MEMORY");
      set_utilization_xen("VM","CPU");
      set_utilization_xen("VM","MEMORY");
      print "heatmap        : (XEN) set cpu utilization for $count_vm_xen vms\n";
      print "heatmap        : (XEN) set memory utilization for $count_vm_xen vms\n";
      print "heatmap        : (XEN) set cpu utilization for $count_server_xen servers\n";
      print "heatmap        : (XEN) set memory utilization for $count_server_xen servers\n";
      set_html_xen();

    }
  }

  if ( $system_machine eq "vmware" ) {
    set_live_vmware();
    set_utilization_cpu_vm();
    set_utilization_mem_vm();
    set_utilization_pool_vm();
    set_utilization_mem_pool_vm();
    set_html_vm();

  } ## end if ( $system_machine eq...)
  if ($system_machine eq "ovirt" && -f "$basedir/tmp/menu_ovirt.json"){
    ### ovirt
    set_structure_ovirt();
    set_utilization_ovirt("SERVER","CPU");
    set_utilization_ovirt("SERVER","MEMORY");
    set_utilization_ovirt("VM","CPU");
    set_utilization_ovirt("VM","MEMORY");
    print "heatmap        : (Ovirt) set cpu utilization for $count_vm_ovirt vms\n";
    print "heatmap        : (Ovirt) set memory utilization for $count_vm_ovirt vms\n";
    print "heatmap        : (Ovirt) set cpu utilization for $count_server_ovirt servers\n";
    print "heatmap        : (Ovirt) set memory utilization for $count_server_ovirt servers\n";
    set_html_ovirt();
  }
  if ($system_machine eq "xen" && -f "$basedir/tmp/menu_xenserver.json"){
      set_structure_xen();
      set_utilization_xen("SERVER","CPU");
      set_utilization_xen("SERVER","MEMORY");
      set_utilization_xen("VM","CPU");
      set_utilization_xen("VM","MEMORY");
      print "heatmap        : (XEN) set cpu utilization for $count_vm_xen vms\n";
      print "heatmap        : (XEN) set memory utilization for $count_vm_xen vms\n";
      print "heatmap        : (XEN) set cpu utilization for $count_server_xen servers\n";
      print "heatmap        : (XEN) set memory utilization for $count_server_xen servers\n";
      set_html_xen();

  }
  if ( $system_machine eq "" ) {

    set_live_inventory();
    set_curr_procs();
    set_utilization_cpu_power();
    set_utilization_pool_power();
    set_utilization_mem_power();
    set_live_vmware();
    set_utilization_cpu_vm();
    set_utilization_mem_vm();
    set_utilization_pool_vm();
    set_utilization_mem_pool_vm();
    set_html_power();
    set_html_vm();

    ### ovirt
    set_structure_ovirt();
    set_utilization_ovirt("SERVER","CPU");
    set_utilization_ovirt("SERVER","MEMORY");
    set_utilization_ovirt("VM","CPU");
    set_utilization_ovirt("VM","MEMORY");
    print "heatmap        : (Ovirt) set cpu utilization for $count_vm_ovirt vms\n";
    print "heatmap        : (Ovirt) set memory utilization for $count_vm_ovirt vms\n";
    print "heatmap        : (Ovirt) set cpu utilization for $count_server_ovirt servers\n";
    print "heatmap        : (Ovirt) set memory utilization for $count_server_ovirt servers\n";
    set_html_ovirt();
    ###

    set_structure_xen();
    set_utilization_xen("SERVER","CPU");
    set_utilization_xen("SERVER","MEMORY");
    set_utilization_xen("VM","CPU");
    set_utilization_xen("VM","MEMORY");
    print "heatmap        : (XEN) set cpu utilization for $count_vm_xen vms\n";
    print "heatmap        : (XEN) set memory utilization for $count_vm_xen vms\n";
    print "heatmap        : (XEN) set cpu utilization for $count_server_xen servers\n";
    print "heatmap        : (XEN) set memory utilization for $count_server_xen servers\n";
    set_html_xen();


  } ## end if ( $system_machine eq...)
  print "heatmap        : end " . localtime() . "\n";

  #print encode_json( \%lstree );
  #	print (@ctree > 0 ? "true" : "false" );
} ## end sub test

sub readMenu {
  my $alt     = shift;
  my $tmppath = "tmp";
  if ($alturl) {
    my @parts = split( /\//, $ENV{HTTP_REFERER} );
    if ( $ENV{HTTP_REFERER}
      && ( $parts[-1] ne $alturl )
      && ( $parts[-2] ne $alturl ) )
    {    # URL doesn't match WWW_ALTERNATE_URL
      $tmppath = $alttmp;    # use menu from WWW_ALTERNATE_TMP
    } ## end if ( $ENV{HTTP_REFERER...})
    if ($alt) {
      $tmppath = $alttmp;
    }
  } ## end if ($alturl)

  my $skel = "$basedir/$tmppath/menu.txt";
  if (! -f "$skel"){
    return;
  }

  #my $skel = "/home/lpar2rrd/lpar2rrd/$tmppath/menu.txt";
  my $last_hmc    = "";
  my $last_server = "";
  my $index       = 1;
  my %hmc_server_del;

  #print "$skel\n";
  open( SKEL, $skel ) or error_die("Cannot open file: $skel : $!");

  while ( my $line = <SKEL> ) {
    my ( $hmc, $srv, $txt, $url );
    chomp $line;
    my @val = split( ':', $line );
    for (@val) {
      &colons($_);
    }
    {
      "O" eq $val[0] && do {
        $free = ( $val[1] == 1 ) ? 1 : 0;
        last;
      };
      "D" eq $val[0] && do {

        #$server_del = $val[2];
        if ( $val[1] eq $last_hmc && $val[2] eq $last_server ) {
          last;
        }
        $hmc_server_del{$index}{HMC}    = $val[1];
        $hmc_server_del{$index}{SERVER} = $val[2];
        $last_hmc                       = $val[1];
        $last_server                    = $val[2];
        $index++;
        last;
      };

      #S:ahmc11:BSRV21:CPUpool-pool:CPU pool:ahmc11/BSRV21/pool/gui-cpu.html::1399967748
      "S" eq $val[0] && do {
        my ( $hmc, $srv, $pool, $txt, $url, $timestamp, $type ) = ( $val[1], $val[2], $val[3], $val[4], $val[5], $val[7], $val[8] );
        if (1) {
          if ( !$timestamp ) {
            $timestamp = 999;
          }
          if ( $type eq "V" ) {
            $hasVMware ||= 1;
            $vclusters{$hmc}{$srv} = 1;
            if ( $pool eq "hreports" ) {
              $hmc = ( $url =~ /^([^\/]*)/ )[0];
            }
            else {
              $hmc = ( $url =~ /host=([^&]*)/ )[0];
            }
          } ## end if ( $type eq "V" )
          elsif ( !exists $times{$srv}{timestamp}{$hmc} ) {
            $times{$srv}{timestamp}{$hmc} = $timestamp;
          }
          if ( $type eq "P" ) {
            $hasPower ||= 1;
          }
          if ( !$times{$srv}{"active"} ) {
            $times{$srv}{"active"} = 1;
          }
          $times{$srv}{"removed"}{$hmc} = 0;
          if ($type) {
            $times{$srv}{type} = $type;
          }
          if ( $pool =~ /^CPUpool/ ) {
            $pool = substr( $pool, 8 );
          }
          elsif ( $pool eq "pagingagg" || $pool eq "mem" ) {
            $pool = "cod";
          }
          elsif ( $pool eq "hea" ) {
            $pool = "hea";
          }
          else {
            $pool = "";
          }
          push @{ $stree{$srv}{$hmc} }, [ $txt, $url, $pool ];
          if ( $url =~ /item=(sh)?pool/ ) {
            my $poolname = ( split " : ", $txt )[1];
            $poolname ||= "CPU pool";

            #$pools{$poolname} = $url;
            #my %poolname = $poolname{$url};
            #print "$url\n";
            my $pools = $url;
            $pools =~ s/.*lpar=//g;
            $pools =~ s/&item.*//g;
            $inventory{$srv}{"POOL"}{$pools}{"NAME"} = $poolname;
            $inventory{$srv}{"POOL"}{$pools}{"URL"}  = $url;

            #push @{ $inventory{$srv}{"POOL"} }, %pools;
            #$inventory{$srv}{"POOL"}[-1]{$poolname} = $url;
            $inventory{$srv}{TIMESTAMP}{$timestamp} = $hmc;
            $inventory{$srv}{TYPE} = $type;
          } ## end if ( $url =~ /item=(sh)?pool/)
        } ## end if (1)
        last;
      };
      "L" eq $val[0] && do {
        my ( $hmc, $srv, $atxt, $txt, $url ) =
          ( $val[1], $val[2], $val[3], $val[4], $val[5] );
        my $jump = 0;
        foreach my $i ( keys %hmc_server_del ) {
          if ( $hmc_server_del{$i}{HMC} eq $val[1] && $hmc_server_del{$i}{SERVER} eq $val[2] ) {
            $jump = 1;
            last;
          }
        } ## end foreach my $i ( keys %hmc_server_del)
        if ( $jump == 1 ) { last; }
        if (1) {
          $atxt = urldecode($atxt);
          push @{ $lstree{$srv}{$hmc} }, [ $txt, $url, $atxt ];
          if ( $hmc eq "no_hmc" ) {
            $times{$srv}{timestamp}{$hmc}    = 999;
            $inventory{$srv}{TIMESTAMP}{999} = $hmc;
            $inventory{$srv}{TYPE}           = 'L';
          }
          else {
            push @{ $lhtree{$hmc}{$srv} }, [ $txt, $url, $atxt ];
          }
          if ( $hmc eq "no_hmc" && !$times{$srv}{"active"} ) {
            $times{$srv}{"active"} = 1;
          }
          push @lnames, $txt;
          if ( $hmc =~ /cluster_/ ) {

            #print "$hmc\n";
            #print "$url\n";
            $url =~ s/server=.*&lpar/server=$hmc&lpar/g;
          } ## end if ( $hmc =~ /cluster_/)
          $inventory{$srv}{"LPAR"}{ urldecode( $val[3] ) }{URL}  = $url;
          $inventory{$srv}{"LPAR"}{ urldecode( $val[3] ) }{NAME} = $txt;
        } ## end if (1)
        last;
      };
    };
  } ## end while ( my $line = <SKEL>)
  close(SKEL);
} ## end sub readMenu

sub urlencode {
  my $s = shift;

  #$s =~ s/ /+/g;
  #$s =~ s/([^A-Za-z0-9\+-_])/sprintf("%%%02X", ord($1))/seg;
  $s =~ s/([^a-zA-Z0-9_.!~*()'\''-])/sprintf("%%%02X", ord($1))/ge;
  return $s;
} ## end sub urlencode

sub urldecode {
  my $s = shift;

  #$s =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
  #$s =~ s/\+/ /g;
  $s =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
  return $s;
} ## end sub urldecode

sub colons {
  return s/===double-col===/:/g;
}

sub uniq {
  my %seen;
  return grep { !$seen{$_}++ } @_;
}

# error handling
sub error {
  my $text     = shift;
  my $act_time = localtime();
  chomp($text);

  #print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text : $!\n";

  return 1;
} ## end sub error

sub boolean {
  my $val = shift;
  if ($val) {
    return "true";
  }
  else {
    return "false";
  }
} ## end sub boolean

###################################################### POWER start !!!

sub get_live_lpars {

  my @wrkdir_all = <$wrkdir/*>;

  #print "@wrkdir_all\n";
  foreach my $server_all (@wrkdir_all) {
    my $server = basename($server_all);
    if ( -l $server_all )        { next; }
    if ( !-d $server_all )       { next; }
    if ( $server =~ /^--HMC--/ ) { next; }
    my $server_space = $server;
    if ( $server =~ m/ / ) {
      $server_space = "\"" . $server . "\"";    # it must be here to support space with server names
    }

    my @hmcdir_all = <$wrkdir/$server_space/*>;

    #print "@hmcdir_all\n";
    foreach my $hmc_all (@hmcdir_all) {

      #my $server_space = $server;
      #if ( $server =~ m/ / ) {
      #$server_space = "\"".$server."\""; # it must be here to support space with server names
      #}
      my $no_name   = "";
      my $hmc       = basename($hmc_all);
      my $hmc_space = $hmc;
      if ( $hmc =~ m/ / ) {
        $hmc_space = "\"" . $hmc . "\"";    # it must be here to support space with server names
      }
      my @lpars_dir_all = <$wrkdir/$server_space/$hmc_space/*>;

      #print "@lpars_dir_all\n";
      my $cpu_cfg = "$hmc_all/cpu.cfg";

      if ( -e "$hmc_all/pool_list.txt" && -e "$hmc_all/cpu-pools-mapping.txt" ) {
        my $find_pool_list = grep {/$hmc_all/} @pool_list;
        if ( !$find_pool_list ) {
          push( @pool_list, "$hmc_all/pool_list.txt,$hmc_all/cpu-pools-mapping.txt,$server\n" );    ### list pool_list.txt
        }
      } ## end if ( -e "$hmc_all/pool_list.txt"...)

      my @lines_config;
      if ( -e $cpu_cfg ) {
        open( FH, "< $cpu_cfg" ) || error( "Cannot read $cpu_cfg: $!" . __FILE__ . ":" . __LINE__ ) && next;
        @lines_config = <FH>;
        close(FH);
      }
      else { next; }

      if ( -z $cpu_cfg ) { next; }

      foreach my $lpars_dir (@lpars_dir_all) {

        #print $lpars_dir . "\n";
        my $lpar = basename($lpars_dir);
        if ( -l $lpars_dir ) { next; }
        if ( -d $lpars_dir ) { next; }
        if ( $lpar !~ /\.rrm$/ && $lpar !~ /\.rrh$/ ) { next; }
        if ( $lpar =~ /^pool\.rrm/ || $lpar =~ /^pool\.rrh/ ) {
          my $lpar_mtimestamp = ( stat("$lpars_dir") )[9];
          my $lpar_name       = $lpar;
          $lpar =~ s/.rrm$//g;
          $lpar =~ s/.rrh$//g;
          push( @pool, "$server_all/XORUX/$lpar/$lpar_mtimestamp, $server, $hmc, $lpar_mtimestamp, $hmc_all, $lpar_name\n" );
          next;
        } ## end if ( $lpar =~ /^pool\.rrm/...)
        if ( $lpar =~ /pool/ || $lpar =~ /Pool/ || $lpar =~ /^mem\.rrm$/ ) { next; }
        my $lpar_mtimestamp = ( stat("$lpars_dir") )[9];

        #if ( $lpar_mtimestamp < $start_time ) { next; }    ## last modified time of lpar must be higher then start time of report
        #$lpar =~ s/&&1/\//g;
        my $lpar_name = $lpar;

        #print "$lpar_name\n";
        $lpar =~ s/.rrm$//g;
        $lpar =~ s/.rrh$//g;

        #print "$lpar\n";
        if ( $lpar =~ /&&1/ ) {
          my $replace = $lpar;
          chomp $replace;
          $replace =~ s/^\s+//;
          $replace =~ s/\s+$//;
          $replace =~ s/&&1/\//g;

          #print "$replace\n";
          push( @replace_file, "$replace" );
          $lpar = $replace;
        } ## end if ( $lpar =~ /&&1/ )

        #print "$lpar\n";
        my $v_cpu = "";    ## virtual cpu
        my $lpar_line;
        if ( ($lpar_line) = grep {/^lpar_name=$lpar,/} @lines_config ) {
          $lpar_line =~ s/.+curr_procs=//g;
          my @curr_procs = split( ",", $lpar_line );
          $v_cpu = $curr_procs[0];
        }
        else {
          next;
          $v_cpu = "NA";
        }

        #print "$lpar\n";
        my $replace_lpar = $lpar;
        $replace_lpar =~ s/\//&&1/g;
        my $special_name = 0;
        if ( $replace_lpar =~ /&&1/ ) {
          $special_name = 1;
        }
        if ( -f "$wrkdir/$server/$hmc/cpu.cfg-$replace_lpar" ) {
          my $file = "$wrkdir/$server/$hmc/cpu.cfg-$replace_lpar";
          open( FH, "< $file" ) || error( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ ) && next;
          my @data = <FH>;
          close(FH);

          my $test_running = grep {/[Rr]unning/} @data;
          if ( !$test_running ) {
            if ($special_name) {
              pop @replace_file;
            }
            next;    ### rules for version 5.00
          } ## end if ( !$test_running )
        } ## end if ( -f "$wrkdir/$server/$hmc/cpu.cfg-$replace_lpar")
        push( @test, "$server_all/XORUX/$lpar/$lpar_mtimestamp, $v_cpu, $server, $hmc, $lpar_mtimestamp, $hmc_all, $lpar_name\n" );

        #print "$lpar\n";
      } ## end foreach my $lpars_dir (@lpars_dir_all)
    } ## end foreach my $hmc_all (@hmcdir_all)
  } ## end foreach my $server_all (@wrkdir_all)
  ##### testing latest rrd file #####
  my @rrd_files_s;
  my @test_s = reverse sort @test;

  #print "@test_s";
  my $last_found = "";

  #print $last_found . "\n";
  #my $test_pom = 0; # test variable
  foreach my $line (@test_s) {
    my ( $rrd_file, $virtual_cpu, $server, $hmc, $timestamp, $hmc_path, $lpar ) = split( ", ", $line );
    $rrd_file =~ s/$timestamp//g;
    my $found = "$rrd_file";

    #print $line ."\n";
    #print "$rrd_file\n";
    if ( $found eq $last_found ) {
      next;
    }

    #if ($test_pom==10){
    #  last;
    #}
    #$test_pom++;
    $last_found = $found;
    push( @rrd_files_s, $line );
    chomp $lpar;
  } ## end foreach my $line (@test_s)
  my @rrd_files = sort @rrd_files_s;
  return @rrd_files;
} ## end sub get_live_lpars

sub set_live_inventory {
  $count_lpars = 0;
  my @name_lpars;
  my @name_servers;
  my @inventory_server;
  my $check = 0;
  foreach my $line ( get_live_lpars() ) {
    chomp $line;

    #print $line . "\n";
    my ( $rrd_file, $virtual_cpu, $server, $hmc, $timestamp, $hmc_path, $lpar ) = split( ", ", $line );
    $rrd_file =~ s/XORUX.+/$hmc\/$lpar/g;
    my $rrd_name = basename($rrd_file);
    $rrd_name =~ s/.rrm$//g;
    $rrd_name =~ s/.rrh$//g;
    push( @name_servers, $server );

    #$count_lpars++;
    #print "$rrd_name\n";
    push( @name_lpars, "$rrd_name,$server\n" );
  } ## end foreach my $line ( get_live_lpars...)

  #if ($count_lpars == 0){
  #  error("Set correct path to rrdtool binary, it does not exist here: $rrdtool");
  #  exit;

  #}
  foreach my $server ( keys %inventory ) {
    foreach my $name (@name_servers) {
      if ( "$name" eq "$server" ) {

        #print $server . "\n";
        $check = 1;
        last;
      } ## end if ( "$name" eq "$server")

    } ## end foreach my $name (@name_servers)
    if ( $check == 0 ) {
      delete $inventory{$server};
      next;
    }

    foreach my $lpar ( keys %{ $inventory{$server}{LPAR} } ) {
      foreach my $name (@name_lpars) {
        my ( $lpar_name, $server_name ) = split( ",", $name );
        chomp $lpar_name;
        chomp $server_name;

        #print "$inventory{$server}{LPAR}{$lpar}{NAME}\n";
        #print $name . "\n";
        if ( "$lpar" eq "$lpar_name" ) {

          #print $lpar. " " .$lpar_name . "\n";
          #print "$server a $server_name\n";
          if ( "$server" eq "$server_name" ) {

            #print "$lpar\n";
            #print "$name\n";
            $check = 2;
            last;
          } ## end if ( "$server" eq "$server_name")
        } ## end if ( "$lpar" eq "$lpar_name")
      } ## end foreach my $name (@name_lpars)
      foreach my $special_name (@replace_file) {
        if ( "$lpar" eq "$special_name" ) {
          $check = 2;
          last;
        }
      } ## end foreach my $special_name (@replace_file)
      if ( !( $check == 2 ) ) {
        delete( $inventory{$server}{LPAR}{$lpar} );

        #$check = 0;
        next;
      } ## end if ( !( $check == 2 ) )
      $check = 0;
    } ## end foreach my $lpar ( keys %{ ...})
    $check = 0;
  } ## end foreach my $server ( keys %inventory)
} ## end sub set_live_inventory

sub get_table_cpu_lpar_power {
  use POSIX qw(ceil);

  #my $const = 2.6;
  my $count_row = 1;
  my $nasob     = 1;
  if ( $count_lpars == 0 ) { return "" }
  my $cell_size = ( $height * $width ) / $count_lpars;
  my $table_values = "<table class =\" lparsearch tablesorter\" data-sortby=\"3\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Lpar\" nowrap=\"\">Lpar</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

  #my $td_height = ceil(sqrt($cell_size/$const));
  #my $td_width = ceil($td_height * $const);
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  #my $i = 0;
  my $style = " .content_power { height:" . "$td_height" . "px" . "; width:" . "$td_height" . "px" . ";} h3 {text-align:center;}";
  my $table = "<table>\n<tbody>\n<tr>\n";

  foreach my $server ( sort keys %inventory ) {
    foreach my $lpar ( sort { lc $inventory{$server}{LPAR}{$a}{NAME} cmp lc $inventory{$server}{LPAR}{$b}{NAME} || $inventory{$server}{LPAR}{$a}{NAME} cmp $inventory{$server}{LPAR}{$b}{NAME} } keys %{ $inventory{$server}{LPAR} } ) {
      if ( defined $inventory{$server}{LPAR}{$lpar}{CPU} && defined $inventory{$server}{LPAR}{$lpar}{CURR_PROCS} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util;
        my $util = $inventory{$server}{LPAR}{$lpar}{CPU};
        my $curr = $inventory{$server}{LPAR}{$lpar}{CURR_PROCS};
        if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || $curr eq 0 || !isdigit($util) || !isdigit($curr) ) {
          $percent_util = "nan";
        }
        else {
          $percent_util = ceil( ( $util / $inventory{$server}{LPAR}{$lpar}{CURR_PROCS} ) * 100 ) . "%";
        }
        my $class = get_class( $inventory{$server}{LPAR}{$lpar}{CPU}, $inventory{$server}{LPAR}{$lpar}{CURR_PROCS} );
        my $color = $class_color{$class};
        $table = $table . "<td class=\"$class\">\n<a href=" . '"' . "$inventory{$server}{LPAR}{$lpar}{URL}" . '"' . "><div title =" . '"' . "$server : $inventory{$server}{LPAR}{$lpar}{NAME}" . " : " . $percent_util . '"' . "class=" . '"' . "content_power" . '"' . "></div>\n</a>\n</td>\n";
        $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=" . '"' . "$inventory{$server}{LPAR}{$lpar}{URL}" . '"' . ">"  . $inventory{$server}{LPAR}{$lpar}{NAME} . "</a></td><td>" . ceil( ( $util / $inventory{$server}{LPAR}{$lpar}{CURR_PROCS} ) * 100 ) . "</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";
        $new_row = $td_width + $new_row;
      } ## end if ( defined $inventory...)
      else {
        next;
      }
    } ## end foreach my $lpar ( sort { lc...})
  } ## end foreach my $server ( sort keys...)

  #print $table_power . "\n";
  $table_values = $table_values . "</tbody></table>";
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";

  #$print "$table_power\n";
  #print "$count_lpars\n";
  my $tb_and_style = "$table" . "@" . "$style" . "@" . $table_values;
  return "$tb_and_style";
} ## end sub get_table_cpu_lpar_power

sub get_table_mem_lpar_power {
  use POSIX qw(ceil);
  my $count_row = 1;
  my $nasob     = 1;
  if ( $count_mem_lpars_power == 0 ) { return "" }
  $count_mem_lpars_power = $count_lpars;
  my $cell_size    = ( $height * $width ) / $count_mem_lpars_power;
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  my $table = "<table>\n<tbody>\n<tr>\n";
  my $table_values = "<table class =\"lparsearch tablesorter\" data-sortby=\"5\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Lpar\" nowrap=\"\">Lpar</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Paging IN kb/s\" nowrap=\"\">Paging IN kb/s</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Paging OUT kb/s\" nowrap=\"\">Paging OUT kb/s</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

  foreach my $server ( sort keys %inventory ) {
    foreach my $lpar ( sort { lc $inventory{$server}{LPAR}{$a}{NAME} cmp lc $inventory{$server}{LPAR}{$b}{NAME} || $inventory{$server}{LPAR}{$a}{NAME} cmp $inventory{$server}{LPAR}{$b}{NAME} } keys %{ $inventory{$server}{LPAR} } ) {
      if ( defined $inventory{$server}{LPAR}{$lpar}{MEMORY} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util;
        my $paging     = "";
        my $util       = $inventory{$server}{LPAR}{$lpar}{MEMORY};
        my $url        = $inventory{$server}{LPAR}{$lpar}{URL};
        my $paging_in  = "";
        my $paging_out = "";
        my $paging_red = "";

        #$url =~ s/item=lpar/item=mem/g;
        if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || !isdigit($util) ) {
          $percent_util = "nan";
        }

        else {
          $percent_util = ceil( $inventory{$server}{LPAR}{$lpar}{MEMORY} ) . "%";
          if ( defined $inventory{$server}{LPAR}{$lpar}{PAGING_IN} && defined $inventory{$server}{LPAR}{$lpar}{PAGING_OUT} ) {
            if ( $inventory{$server}{LPAR}{$lpar}{PAGING_IN} > $HEATMAP_MEM_PAGING_MAX || $inventory{$server}{LPAR}{$lpar}{PAGING_OUT} > $HEATMAP_MEM_PAGING_MAX ) {
              $paging_red = 1;
            }
            else { $paging_red = 0; }
            $paging_in  = "paging in ";
            $paging_in  = "$paging_in" . "$inventory{$server}{LPAR}{$lpar}{PAGING_IN}" . "kB/s";
            $paging_out = "paging out ";
            $paging_out = "$paging_out" . "$inventory{$server}{LPAR}{$lpar}{PAGING_OUT}" . "kB/s";
            $paging     = " : $paging_in : $paging_out";
          } ## end if ( defined $inventory...)
        } ## end else [ if ( "$util" eq "-nan"...)]
        if (!defined $inventory{$server}{LPAR}{$lpar}{PAGING_IN}){ $inventory{$server}{LPAR}{$lpar}{PAGING_IN} = ""; }
        if (!defined $inventory{$server}{LPAR}{$lpar}{PAGING_OUT}){ $inventory{$server}{LPAR}{$lpar}{PAGING_OUT} = ""; }
        my $class = get_percent_to_color( $inventory{$server}{LPAR}{$lpar}{MEMORY}, $paging_red );
        my $color = $class_color{$class};
        $table = $table . "<td class=\"$class\">\n<a href=" . '"' . "$url" . '"' . "><div title =" . '"' . "$server : $inventory{$server}{LPAR}{$lpar}{NAME}" . " : " . $percent_util . "$paging" . '"' . "class=" . '"' . "content_power" . '"' . "></div>\n</a>\n</td>\n";
      $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=" . '"' . "$inventory{$server}{LPAR}{$lpar}{URL}" . '"' . ">"  . $inventory{$server}{LPAR}{$lpar}{NAME} . "</a></td><td>$inventory{$server}{LPAR}{$lpar}{PAGING_IN}</td><td>$inventory{$server}{LPAR}{$lpar}{PAGING_OUT}</td><td>" . ceil( $inventory{$server}{LPAR}{$lpar}{MEMORY} ) . "</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";
        $new_row = $td_width + $new_row;
      } ## end if ( defined $inventory...)
      else { next; }
    } ## end foreach my $lpar ( sort { lc...})
  } ## end foreach my $server ( sort keys...)
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";
  return "$table" . "@" . "$table_values";
} ## end sub get_table_mem_lpar_power

sub get_table_cpu_pool_power {
  use POSIX qw(ceil);
  my $count_row = 1;
  my $nasob     = 1;

  #print "$count_pools\n";
  if ( $count_pools == 0 ) { return "" }
  my $cell_size    = ( $height * $width ) / $count_pools;
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  #my $i = 0;


  ## check NAME POOL EMPTY
  foreach my $server ( keys %inventory ) {
    foreach my $pool ( keys %{ $inventory{$server}{POOL} } ) {
      if ( !defined $inventory{$server}{POOL}{$pool}{NAME} ) {
        $inventory{$server}{POOL}{$pool}{NAME} = "$pool";
      }
    }
  } ## end foreach my $server ( keys %inventory)

  my $table = "<table>\n<tbody>\n<tr>\n";
  my $style = " .content_pool_power { height:" . "$td_height" . "px" . "; width:" . "$td_height" . "px" . ";} h3 {text-align:center;}";
  my $table_values = "<table class =\"lparsearch tablesorter\" data-sortby=\"3\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Pool\" nowrap=\"\">Pool</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

  foreach my $server ( sort keys %inventory ) {
    foreach my $pool ( sort { lc $inventory{$server}{POOL}{$a}{NAME} cmp lc $inventory{$server}{POOL}{$b}{NAME} || $inventory{$server}{POOL}{$a}{NAME} cmp $inventory{$server}{POOL}{$b}{NAME} } keys %{ $inventory{$server}{POOL} } ) {
      if ( defined $inventory{$server}{POOL}{$pool}{CPU} && defined $inventory{$server}{POOL}{$pool}{URL} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util;
        my $util = $inventory{$server}{POOL}{$pool}{CPU};
        if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || !isdigit($util) ) {
          $percent_util = "nan";
        }
        else {
          $percent_util = ceil( $inventory{$server}{POOL}{$pool}{CPU} ) . "%";
        }
        my $class = get_percent_to_color($util);
        my $color = $class_color{$class};
        $table   = $table . "<td class=\"$class\">\n<a href=" . '"' . "$inventory{$server}{POOL}{$pool}{URL}" . '"' . "><div title =" . '"' . "$server : $inventory{$server}{POOL}{$pool}{NAME}" . " : " . $percent_util . '"' . "class=" . '"' . "content_pool_power" . '"' . "></div>\n</a>\n</td>\n";
        $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=" . '"' . "$inventory{$server}{POOL}{$pool}{URL}" . '"' . ">"  . $inventory{$server}{POOL}{$pool}{NAME} . "</a></td><td>" . ceil($inventory{$server}{POOL}{$pool}{CPU}) . "</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";
        $new_row = $td_width + $new_row;
      } ## end if ( defined $inventory...)
      else { next; }
    } ## end foreach my $pool ( sort { lc...})
  } ## end foreach my $server ( sort keys...)
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";
  my $tb_and_style = "$table" . "@" . "$style" . "@" . "$table_values";
  return "$tb_and_style";
} ## end sub get_table_cpu_pool_power

sub set_curr_procs {
  foreach my $line ( get_live_lpars() ) {
    chomp $line;

    #print "$line\n";
    my ( $rrd_file, $virtual_cpu, $server, $hmc, $timestamp, $hmc_path, $lpar ) = split( ", ", $line );
    $rrd_file =~ s/XORUX.+/$hmc\/$lpar/g;
    my $rrd_name = basename($rrd_file);
    $rrd_name =~ s/.rrm$//g;
    $rrd_name =~ s/.rrh$//g;
    $rrd_name =~ s/&&1/\//g;

    #print "$rrd_name\n";
    foreach my $Server ( keys %inventory ) {
      if ( "$server" eq "$Server" ) {
        foreach my $Lpar ( keys %{ $inventory{$Server}{LPAR} } ) {
          if ( "$rrd_name" eq "$Lpar" ) {

            #print "$rrd_name\n";
            $inventory{$Server}{LPAR}{$Lpar}{CURR_PROCS} = $virtual_cpu;
          }

          #foreach my $special_name (@replace_file){
          #  if ("$Lpar" eq "$special_name"){
          #    $inventory{$Server}{LPAR}{$Lpar}{CURR_PROCS} = $virtual_cpu;
          #    last;
          #  }
          #}
        } ## end foreach my $Lpar ( keys %{ ...})
      } ## end if ( "$server" eq "$Server")
    } ## end foreach my $Server ( keys %inventory)
  } ## end foreach my $line ( get_live_lpars...)
} ## end sub set_curr_procs

sub set_utilization_cpu_power {

  #print get_live_lpars();
  #print Dumper \%inventory;
  foreach my $line ( get_live_lpars() ) {
    chomp $line;
    my $exclude = 0;
    my ( $rrd_file, $virtual_cpu, $server, $hmc, $timestamp, $hmc_path, $lpar ) = split( ", ", $line );

    #print "$rrd_file\n";
    #print "$rrd_file\n";
    $rrd_file =~ s/XORUX.+/$hmc\/$lpar/g;
    my $rrd_name = basename($rrd_file);
    $rrd_name =~ s/.rrm$//;
    $rrd_name =~ s/.rrh$//;
    $rrd_name =~ s/&&1/\//g;
    if ( defined $HEATMAP_EXCLUDE_CPU ) {
      my @exlude_lpar = split( ":", $HEATMAP_EXCLUDE_CPU );
      foreach my $exludes_lpar (@exlude_lpar) {
        chomp $exludes_lpar;
        $exludes_lpar =~ s/^\s+|\s+$//g;
        if ( $rrd_name eq $exludes_lpar && defined $inventory{$server}{LPAR}{$rrd_name} ) {

          #$inventory{$server}{LPAR}{$rrd_name}{CPU} = "NaN";
          $exclude = 1;
          last;
        } ## end if ( $rrd_name eq $exludes_lpar...)
      } ## end foreach my $exludes_lpar (@exlude_lpar)
    } ## end if ( defined $HEATMAP_EXCLUDE_CPU)
    if ( $exclude == 1 ) { next; }

    #print $rrd_name . "\n";
    $rrd_file =~ s/:/\\:/g;
    my $rrd_out_name = "graph.png";
    my $answer;
    eval {
      RRDp::cmd qq(graph "$rrd_out_name"
    "--start" "$start_time"
    "--end" "$end_time"
    "--step=60"
    "DEF:cur=$rrd_file:curr_proc_units:AVERAGE"
    "DEF:ent=$rrd_file:entitled_cycles:AVERAGE"
    "DEF:cap=$rrd_file:capped_cycles:AVERAGE"
    "DEF:uncap=$rrd_file:uncapped_cycles:AVERAGE"
    "CDEF:tot=cap,uncap,+"
    "CDEF:util=tot,ent,/,$cpu_max_filter,GT,UNKN,tot,ent,/,IF"
    "CDEF:utiltot=util,cur,*"
    "PRINT:utiltot:AVERAGE:Utilization in CPU cores %2.2lf"
    );
      $answer = RRDp::read;
    };
    if ($@) {
      if ( $@ =~ "ERROR" ) {
        error("Rrrdtool error : $@");
        next;
      }
    } ## end if ($@)
    my $aaa = $$answer;

    #if ( $aaa =~ /NaNQ/ ) { next; }
    ( undef, my $utilization_in_cores ) = split( "\n", $aaa );
    $utilization_in_cores =~ s/Utilization in CPU cores\s+//;

    #print $utilization_in_cores . "\n";
    foreach my $Server ( keys %inventory ) {
      if ( $server eq $Server ) {
        foreach my $Lpar ( keys %{ $inventory{$Server}{LPAR} } ) {
          if ( "$Lpar" eq "$rrd_name" ) {
            $inventory{$Server}{LPAR}{$Lpar}{CPU} = $utilization_in_cores;
            $count_lpars++;
          }

          #foreach my $special_name (@replace_file){
          #  if ("$Lpar" eq "$special_name"){
          #    if (defined $inventory{$Server}{LPAR}{$Lpar}{CPU}){next;}
          #    $inventory{$Server}{LPAR}{$Lpar}{CPU} = $utilization_in_cores;
          #    $count_lpars++;
          #    last;
          #  }
          #}
        } ## end foreach my $Lpar ( keys %{ ...})
      } ## end if ( $server eq $Server)
    } ## end foreach my $Server ( keys %inventory)
  } ## end foreach my $line ( get_live_lpars...)
  print "heatmap        : (Power) set cpu utilization for $count_lpars lpars\n";
} ## end sub set_utilization_cpu_power

sub get_live_mem_lpars_power {
  my @wrkdir_all = <$wrkdir/*>;
  my @mem;    # os agent
  my @test_mem;
  my $last_lpar      = "";
  my $last_server    = "";
  my $last_timestamp = 0;
  foreach my $server_all (@wrkdir_all) {
    my $server = basename($server_all);

    #print "$server\n";
    if ( -l $server_all )        { next; }
    if ( !-d $server_all )       { next; }
    if ( $server =~ /^--HMC--/ ) { next; }
    my $server_space = $server;
    if ( $server =~ m/ / ) {
      $server_space = "\"" . $server . "\"";    # it must be here to support space with server names
    }
    my @hmcdir_all = <$wrkdir/$server_space/*>;
    foreach my $hmc_all (@hmcdir_all) {
      my $hmc = basename($hmc_all);

      #print "$hmc_all\n";
      my $hmc_space = $hmc;
      if ( $hmc =~ m/ / ) {
        $hmc_space = "\"" . $hmc . "\"";        # it must be here to support space with server names
      }
      my @lpars_dir_all = <$wrkdir/$server_space/$hmc_space/*>;
      foreach my $lpars_dir (@lpars_dir_all) {
        if ( -d $lpars_dir && !( $lpars_dir =~ /NMON/ ) ) {

          #print $lpars_dir . "\n";
          my $lpar = basename($lpars_dir);

          #print "$lpar\n";
          $lpar =~ s/ /\\ /g;

          #print "$lpar\n";
          my @os_agent = <$wrkdir/$server_space/$hmc_space/$lpar/*>;

          #print "@os_agent\n";
          my $find_file = grep {/mem.mmm/} @os_agent;
          if ($find_file) {
            foreach my $file (@os_agent) {

              #print "$file\n";
              my $mem_file = basename($file);
              if ( "$mem_file" eq "mem.mmm" ) {
                my $mem_timestamp = ( stat("$file") )[9];
                $lpar =~ s/&&1/\//g;

                #print "$file\n";
                push( @mem, "$server,$lpar,$mem_file,$mem_timestamp,$file" );
              } ## end if ( "$mem_file" eq "mem.mmm")
            } ## end foreach my $file (@os_agent)
          } ## end if ($find_file)
          else {
            my $nmon = "";
            $nmon = "$lpars_dir--NMON--";

            #print $nmon . "\n";
            my $name_nmon = basename($nmon);
            $name_nmon =~ s/ /\\ /g;

            #print $name_nmon . "\n";
            my @os_agent_nmon = <$wrkdir/$server_space/$hmc_space/$name_nmon/*>;
            my $test = grep {/mem.mmm/} @os_agent_nmon;
            if ($test) {

              #my $name_nmon = basename($nmon);
              #$name_nmon =~ s/ /\\ /g;
              #my @os_agent_nmon = <$wrkdir/$server/$hmc/$name_nmon/*>;
              #print "ahoj\n";
              foreach my $file (@os_agent_nmon) {
                my $mem_file = basename($file);

                #print $mem_file . "\n";
                if ( "$mem_file" eq "mem.mmm" ) {
                  my $mem_timestamp = ( stat("$file") )[9];
                  $name_nmon =~ s/&&1/\//g;
                  $name_nmon =~ s/--NMON--//g;
                  push( @mem, "$server,$name_nmon,$mem_file,$mem_timestamp,$file" );
                } ## end if ( "$mem_file" eq "mem.mmm")
              } ## end foreach my $file (@os_agent_nmon)
            } ## end if ($test)

          } ## end else [ if ($find_file) ]
        } ## end if ( -d $lpars_dir && ...)
      } ## end foreach my $lpars_dir (@lpars_dir_all)
    } ## end foreach my $hmc_all (@hmcdir_all)
  } ## end foreach my $server_all (@wrkdir_all)
  my @sort_array = sort @mem;
  foreach my $line (@sort_array) {

    #print "$line\n";
    my ( $server, $lpar, $mem, $mem_timestamp, $path ) = split( ",", $line );

    #print "$server a $mem a $mem_timestamp a $path\n";
    if ( $server eq $last_server ) {
      if ( $last_lpar eq $lpar ) {

        #print "$last_mem $last_timestamp a $mem $mem_timestamp\n";
        if ( $last_timestamp == $mem_timestamp ) {

          #print "$server a $path\n";
          #print "odstranil\n";
          pop(@test_mem);
        } ## end if ( $last_timestamp ==...)
        else {
          next;
        }
      } ## end if ( $last_lpar eq $lpar)
    } ## end if ( $server eq $last_server)
    $last_lpar      = $lpar;
    $last_server    = $server;
    $last_timestamp = $mem_timestamp;

    #print "$path,$server,$mem pridal\n";
    push( @test_mem, "$path,$server,$mem,$lpar" );
  } ## end foreach my $line (@sort_array)
  return @test_mem;
} ## end sub get_live_mem_lpars_power

sub set_utilization_mem_power {
  $count_mem_lpars_power = 0;
  my @lpar = get_live_mem_lpars_power();
  foreach my $line (@lpar) {
    my ( $path, $server_name, $mem, $lpar ) = split( ",", $line );
    my $mem_name = $mem;

    #print $path . "\n";
    #my $lpar = $line;
    $mem_name =~ s/.mmm//g;

    #print $server_name . "\n";
    $lpar =~ s/\\//g;
    foreach my $server ( keys %inventory ) {
      if ( "$server_name" eq "$server" ) {
        foreach my $lpar_name ( keys %{ $inventory{$server}{LPAR} } ) {

          #print "$lpar_name a $lpar\n";
          if ( "$lpar_name" eq "$lpar" ) {
            $path =~ s/:/\\:/g;

            #print $path . "\n";
            my $rrd_out_name = "graph.png";
            my $answer;
            eval {
              RRDp::cmd qq(graph "$rrd_out_name"
            "--start" "$start_time"
            "--end" "$end_time"
            "--step=60"
            "DEF:used=$path:nuse:AVERAGE"
            "DEF:free=$path:free:AVERAGE"
            "DEF:in_use_clnt=$path:in_use_clnt:AVERAGE"
            "CDEF:usedg=used,1048576,/"
            "CDEF:in_use_clnt_g=in_use_clnt,1048576,/"
            "CDEF:used_realg=usedg,in_use_clnt_g,-"
            "CDEF:free_g=free,1048576,/"
            "CDEF:sum=used_realg,in_use_clnt_g,+,free_g,+"
            "CDEF:memper=used_realg,sum,/,100,*"
            "PRINT:memper:AVERAGE:Utilization MEM in percent  %2.2lf"
            );
              $answer = RRDp::read;
            };
            if ($@) {
              if ( $@ =~ "ERROR" ) {
                error("Rrrdtool error : $@");
                next;
              }
            } ## end if ($@)
            my $aaa = $$answer;

            #if ( $aaa =~ /NaNQ/ ) { next; }
            ( undef, my $utilization_in_per ) = split( "\n", $aaa );
            $utilization_in_per =~ s/Utilization MEM in percent\s+//g;
            $count_mem_lpars_power++;

            #print "$utilization_in_per\n";
            #print "$lpar_name\n";
            my $check = check_mem_lpar_red($utilization_in_per);

            #print "$check\n";
            if ($check) {
              my $paging = get_paging_in_out($line);
              if ( $paging eq 0 ) {
                $inventory{$server}{LPAR}{$lpar_name}{MEMORY} = $utilization_in_per;
              }
              else {
                ( my $paging_in, my $paging_out ) = split( ",", $paging );

                #$paging_in = 130;
                #$paging_out = 120;
                $inventory{$server}{LPAR}{$lpar_name}{MEMORY}     = $utilization_in_per;
                $inventory{$server}{LPAR}{$lpar_name}{PAGING_IN}  = $paging_in;
                $inventory{$server}{LPAR}{$lpar_name}{PAGING_OUT} = $paging_out;
              } ## end else [ if ( $paging eq 0 ) ]
            } ## end if ($check)
            else {
              $inventory{$server}{LPAR}{$lpar_name}{MEMORY} = $utilization_in_per;
            }
          } ## end if ( "$lpar_name" eq "$lpar")
        } ## end foreach my $lpar_name ( keys...)
      } ## end if ( "$server_name" eq...)
    } ## end foreach my $server ( keys %inventory)
  } ## end foreach my $line (@lpar)

  print "heatmap        : (Power) set memory utilization for $count_mem_lpars_power lpars\n";
} ## end sub set_utilization_mem_power

sub check_mem_lpar_red {
  my $percent = shift;
  if ( "$percent" eq "-nan" || "$percent" eq "nan" || $percent =~ /nan/ || "$percent" eq "NaNQ" || $percent =~ /NAN/ || $percent =~ /NaN/ || !isdigit($percent) ) {
    return 0;
  }
  my $rounded = ceil($percent);
  $percent = $rounded;
  if ( $percent >= 91 ) {
    return 1;
  }
  else {
    return 0;
  }

} ## end sub check_mem_lpar_red

sub get_paging_in_out {
  my $line       = shift;
  my $filter_max = 100000000;
  my ( $path, $server_name, $mem, $lpar ) = split( ",", $line );
  $path =~ s/mem.mmm/pgs.mmm/g;
  $mem = "mem.mmm";
  my $mem_name = $mem;

  #print $path . "\n";
  #my $lpar = $line;
  $mem_name =~ s/.mmm//g;

  #print $server_name . "\n";
  $lpar =~ s/\\//g;
  $path =~ s/:/\\:/g;

  #print $path . "\n";
  my $answer;
  eval {
    RRDp::cmd qq(graph "$mem_name"
    "--start" "$start_time"
    "--end" "$end_time"
    "--step=60"
    "DEF:pagein=$path:page_in:AVERAGE"
    "DEF:pageout=$path:page_out:AVERAGE"
    "DEF:percent=$path:percent:AVERAGE"
    "DEF:paging_space=$path:paging_space:AVERAGE"
    "CDEF:pagein_b_nf=pagein,4096,*"
    "CDEF:pageout_b_nf=pageout,4096,*"
    "CDEF:pagein_b=pagein_b_nf,$filter_max,GT,UNKN,pagein_b_nf,IF"
    "CDEF:pageout_b=pageout_b_nf,$filter_max,GT,UNKN,pageout_b_nf,IF"
    "CDEF:pagein_kb=pagein_b,1024,/"
    "CDEF:pageout_kb=pageout_b,1024,/"
    "PRINT:pagein_kb:AVERAGE:Pagein MEM in kb  %4.2lf"
    "PRINT:pageout_kb:AVERAGE:Pageout MEM in kb  %4.2lf"
    );
    $answer = RRDp::read;
  };
  if ($@) {
    if ( $@ =~ "ERROR" ) {
      error("Rrrdtool error : $@");
      return 0;
    }
  } ## end if ($@)
  my $aaa = $$answer;

  #if ( $aaa =~ /NaNQ/ ) { next; }
  ( undef, my $pagein, my $pageout ) = split( "\n", $aaa );
  $pagein =~ s/Pagein MEM in kb\s+//g;
  $pageout =~ s/Pageout MEM in kb\s+//g;

  #print "$pagein\n";
  #print "$pageout\n";
  return "$pagein,$pageout";
} ## end sub get_paging_in_out

sub get_dead_pool_power {
  my @dead_pool;
  my %mapping_pool;

  foreach my $list (@pool_list) {
    chomp $list;
    $list =~ s/^\s+|\s+$//g;
    ( my $file, my $file_map, my $server ) = split( ",", $list );
    chomp $file;
    $file =~ s/^\s+|\s+$//g;
    chomp $server;
    $server =~ s/^\s+|\s+$//g;
    chomp $file_map;
    $file_map =~ s/^\s+|\s+$//g;

    open( FH, "< $file_map" ) || error( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ ) && next;
    my @mapping_cpu_pool = <FH>;
    close(FH);

    foreach my $line (@mapping_cpu_pool) {
      chomp $line;
      if ( $line eq "" ) { next; }
      $line =~ s/^\s+|\s+$//g;
      ( my $num, my $name ) = split( ",", $line );
      if ( defined $num && defined $name && $name ne "DefaultPool" ) {
        $mapping_pool{$num} = $name;
      }
    } ## end foreach my $line (@mapping_cpu_pool)

    #print Dumper \%mapping_pool;

    open( FH, "< $file" ) || error( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ ) && next;
    my @lines_config = <FH>;
    close(FH);
    foreach my $line (@lines_config) {
      chomp $line;
      if ( $line eq "" ) { next; }
      $line =~ s/^\s+|\s+$//g;
      my @check_dead = split( ",", $line );
      my $size = scalar @check_dead;
      if ( $size == 1 ) {
        if ( defined $mapping_pool{ $check_dead[0] } ) {
          push( @dead_pool, "$server,$mapping_pool{$check_dead[0]}\n" );
        }
      }
    } ## end foreach my $line (@lines_config)

  } ## end foreach my $list (@pool_list)

  return @dead_pool;

} ## end sub get_dead_pool_power

sub set_live_pool_power {

  #remove sharedpool0
  my @dead_pool = get_dead_pool_power();

  foreach my $server ( keys %inventory ) {
    foreach my $pool ( keys %{ $inventory{$server}{POOL} } ) {
      if ( "$pool" eq "SharedPool0" ) {
        delete $inventory{$server}{POOL}{SharedPool0};
      }
      else {
        foreach my $line (@dead_pool) {
          chomp $line;
          if ( $line eq "" ) { next; }
          $line =~ s/^\s+|\s+$//g;
          ( my $srv, my $name ) = split( ",", $line );
          chomp $name;
          $name =~ s/^\s+|\s+$//g;
          chomp $srv;
          $srv =~ s/^\s+|\s+$//g;

          if ( defined $inventory{$server}{POOL}{$pool}{NAME} ) {
            if ( $inventory{$server}{POOL}{$pool}{NAME} eq "$name" && "$server" eq "$srv" ) {
              delete $inventory{$server}{POOL}{$pool};
            }
          }
          else {
            delete $inventory{$server}{POOL}{$pool};
          }
        } ## end foreach my $line (@dead_pool)
      } ## end else [ if ( "$pool" eq "SharedPool0")]


    } ## end foreach my $pool ( keys %{ ...})
  } ## end foreach my $server ( keys %inventory)

  #print Dumper \%inventory;
} ## end sub set_live_pool_power

sub get_live_pool_power {
  my @test_pool;
  my $last_pool      = "";
  my $last_server    = "";
  my $last_timestamp = 0;
  set_live_pool_power();
  my @pool;
  my @wrkdir_all = <$wrkdir/*>;
  foreach my $server_all (@wrkdir_all) {
    my $server = basename($server_all);
    if ( -l $server_all )        { next; }
    if ( !-d $server_all )       { next; }
    if ( $server =~ /^--HMC--/ ) { next; }
    my $server_space = $server;
    if ( $server =~ m/ / ) {
      $server_space = "\"" . $server . "\"";    # it must be here to support space with server names
    }
    my @hmcdir_all = <$wrkdir/$server_space/*>;
    foreach my $hmc_all (@hmcdir_all) {
      my $hmc       = basename($hmc_all);
      my $hmc_space = $hmc;
      if ( $hmc =~ m/ / ) {
        $hmc_space = "\"" . $hmc . "\"";        # it must be here to support space with server names
      }
      my @lpars_dir_all = <$wrkdir/$server_space/$hmc_space/*>;
      foreach my $lpars_dir (@lpars_dir_all) {
        my $pool = basename($lpars_dir);

        #print "$lpar\n";
        if ( -l $lpars_dir ) { next; }
        if ( -d $lpars_dir ) { next; }
        if ( $pool !~ /\.rrm$/ && $pool !~ /\.rrh$/ ) { next; }
        if ( $pool =~ /^pool\.rrm/ || $pool =~ /^pool\.rrh/ || $pool =~ /^SharedPool[1-9]+\.rrh/ || $pool =~ /^SharedPool[1-9]+\.rrm/ ) {
          my $pool_timestamp = ( stat("$lpars_dir") )[9];
          if ($pool =~ /^pool\.rrm|^SharedPool[1-9]+\.rrm/){
            my $time_update_check = time();
            my $diff = $time_update_check - $pool_timestamp;
            my $ten_days = 3600 * 24 * 10;
            if ($diff > $ten_days){next;}
          }
          push( @pool, "$server,$pool,$pool_timestamp,$lpars_dir" );
        }
      } ## end foreach my $lpars_dir (@lpars_dir_all)
    } ## end foreach my $hmc_all (@hmcdir_all)
  } ## end foreach my $server_all (@wrkdir_all)
  my @sort_array = sort @pool;
  foreach my $line (@sort_array) {

    #print "$line\n";
    my ( $server, $pool, $pool_timestamp, $path ) = split( ",", $line );
    if ( $server eq $last_server ) {
      if ( $last_pool eq $pool ) {

        #print "$last_pool $last_timestamp a $pool $pool_timestamp\n";
        if ( $last_timestamp < $pool_timestamp ) {

          #print "$server a $pool\n";
          pop(@test_pool);
        }
        else {
          next;
        }
      } ## end if ( $last_pool eq $pool)
    } ## end if ( $server eq $last_server)
    $last_pool      = $pool;
    $last_server    = $server;
    $last_timestamp = $pool_timestamp;
    push( @test_pool, "$path,$server,$pool" );
  } ## end foreach my $line (@sort_array)
  return @test_pool;
} ## end sub get_live_pool_power

sub set_utilization_pool_power {
  $count_pools = 0;
  my @pool = get_live_pool_power();
  foreach my $line (@pool) {

    #print $line . "\n";
    my ( $path, $server_name, $pool ) = split( ",", $line );
    my $pool_name = $pool;
    $pool_name =~ s/.rrm//g;
    $pool_name =~ s/.rrh//g;
    $path =~ s/:/\\:/g;

    #print $server_name . "\n";
    foreach my $server ( keys %inventory ) {
      if ( "$server_name" eq "$server" ) {
        foreach my $pool ( keys %{ $inventory{$server}{POOL} } ) {
          if ( "$pool_name" eq "$pool" ) {
            if ( $pool_name =~ /SharedPool/ ) {
              my $answer;

              #"CDEF:cpurange=cpuutil,max,/"
              eval {
                RRDp::cmd qq(graph "$pool_name"
              "--start" "$start_time"
              "--end" "$end_time"
              "--step=60"
              "DEF:max=$path:max_pool_units:AVERAGE"
              "DEF:totcyc=$path:total_pool_cycles:AVERAGE"
              "DEF:uticyc=$path:utilized_pool_cyc:AVERAGE"
              "CDEF:cpuutil=uticyc,totcyc,GT,UNKN,uticyc,totcyc,/,IF"
              "CDEF:cpuutilper=cpuutil,100,*"
              "PRINT:cpuutilper:AVERAGE:Utilization POOL in percent  %2.2lf"
              );
                $answer = RRDp::read;
              };
              if ($@) {
                if ( $@ =~ "ERROR" ) {
                  error("Rrrdtool error : $@");
                  next;
                }
              } ## end if ($@)
              my $aaa = $$answer;

              #if ( $aaa =~ /NaNQ/ ) { next; }
              ( undef, my $utilization_in_per ) = split( "\n", $aaa );
              $utilization_in_per =~ s/Utilization POOL in percent\s+//g;
              $inventory{$server}{POOL}{$pool}{CPU} = $utilization_in_per;
              $count_pools++;
            } ## end if ( $pool_name =~ /SharedPool/)
            else {
              my $answer;

              #print "$pool_name\n";
              eval {
                RRDp::cmd qq(graph "$pool_name"
              "--start" "$start_time"
              "--end" "$end_time"
              "--step=60"
              "DEF:cpu=$path:conf_proc_units:AVERAGE"
              "DEF:totcyc=$path:total_pool_cycles:AVERAGE"
              "DEF:uticyc=$path:utilized_pool_cyc:AVERAGE"
              "DEF:cpubor=$path:bor_proc_units:AVERAGE"
              "CDEF:totcpu=cpu,cpubor,+"
              "CDEF:cpuutil=uticyc,totcyc,GT,UNKN,uticyc,totcyc,/,IF"
              "CDEF:cpuutilper=cpuutil,100,*"
              "PRINT:cpuutilper:AVERAGE:Utilization POOL in percent  %2.2lf"
              );
                $answer = RRDp::read;
              };
              if ($@) {
                if ( $@ =~ "ERROR" ) {
                  error("Rrrdtool error : $@");
                  next;
                }
              } ## end if ($@)
              my $aaa = $$answer;
              ( undef, my $utilization_in_per ) = split( "\n", $aaa );
              $utilization_in_per =~ s/Utilization POOL in percent\s+//g;
              $inventory{$server}{POOL}{$pool}{CPU} = $utilization_in_per;
              $count_pools++;
            } ## end else [ if ( $pool_name =~ /SharedPool/)]
          } ## end if ( "$pool_name" eq "$pool")
        } ## end foreach my $pool ( keys %{ ...})
      } ## end if ( "$server_name" eq...)
    } ## end foreach my $server ( keys %inventory)
  } ## end foreach my $line (@pool)

  print "heatmap        : (Power) set cpu utilization for $count_pools pools\n";
} ## end sub set_utilization_pool_power

sub get_class {
  my $utilization = shift;
  my $curr_procs  = shift;

  #print $utilization . "\n";
  if ( "$utilization" eq "-nan" || "$utilization" eq "NaNQ" || "$utilization" eq "nan" || $utilization =~ /nan/ || $utilization =~ /NAN/ || $utilization =~ /NaN/ || $curr_procs eq 0 || !isdigit($utilization) || !isdigit($curr_procs)  ) {
    return "clr0";
  }

  else {
    my $utilization_percent = ( $utilization / $curr_procs ) * 100;
    return get_percent_to_color($utilization_percent);
  }
} ## end sub get_class

sub get_percent_to_color {
  use POSIX qw(ceil);
  my $percent      = shift;
  my $mem_pading   = shift;
  my $ready_string = shift;
  my $cpu_ready    = 0;
  if ( "$percent" eq "-nan" || "$percent" eq "nan" || $percent =~ /nan/ || "$percent" eq "NaNQ" || $percent =~ /NAN/ || $percent =~ /NaN/ || !isdigit($percent) ) {
    return "clr0";
  }
  my $pom = ceil($percent);
  $percent = $pom;
  if ( defined $mem_pading && $mem_pading eq 1 && !defined $ready_string ) {
    return "clr10";
  }
  if ( defined $mem_pading && $mem_pading eq 0 && !defined $ready_string ) {
    return "clr9";
  }
  if ( defined $ready_string && $ready_string eq "ready" ) {
    if ( defined $mem_pading && isdigit($mem_pading) && $mem_pading > 5 ) {
      return "clr10";
    }
  }
  if ( $percent >= 0 && $percent <= 10 ) {
    return "clr1";
  }
  if ( $percent >= 11 && $percent <= 20 ) {
    return "clr2";
  }
  if ( $percent >= 21 && $percent <= 30 ) {
    return "clr3";
  }
  if ( $percent >= 31 && $percent <= 40 ) {
    return "clr4";
  }
  if ( $percent >= 41 && $percent <= 50 ) {
    return "clr5";
  }
  if ( $percent >= 51 && $percent <= 60 ) {
    return "clr6";
  }
  if ( $percent >= 61 && $percent <= 70 ) {
    return "clr7";
  }
  if ( $percent >= 71 && $percent <= 80 ) {
    return "clr8";
  }
  if ( $percent >= 81 && $percent <= 90 ) {
    return "clr9";
  }
  if ( $percent >= 91 ) {
    return "clr10";
  }
  return "clr0";
} ## end sub get_percent_to_color

sub isdigit {

  my $digit = shift;
  if ( !defined($digit) ) {
    return 0;
  }

  if ( $digit eq '' ) {
    return 0;
  }

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;
  $digit_work =~ s/^-//;
  $digit_work =~ s/e//;
  $digit_work =~ s/\+//;
  $digit_work =~ s/\-//;

  if ( length($digit_work) == 0 ) {

    # is a number
    return 1;
  }

  # NOT a number
  return 0;
} ## end sub isdigit

####################################################################### Power end
#
#
#
#
######################################################################## VMWARE start

# select only VM

sub set_live_vmware {
  foreach my $server ( keys %vmware ) {
    if ( defined $vmware{$server}{TYPE} ) {
      if ( "$vmware{$server}{TYPE}" eq "V" ) {
      }
      else {
        delete $vmware{$server};
      }
    } ## end if ( defined $vmware{$server...})
  } ## end foreach my $server ( keys %vmware)
} ## end sub set_live_vmware

sub get_live_lpars_vm {
  my @rrd_files;
  my @wrkdir_all = <$wrkdir/*>;
  my @lpars_vm;
  my @server_vm;

  #print "@wrkdir_all\n";
  foreach my $server_all (@wrkdir_all) {
    my $server = basename($server_all);

    #print $server . "\n";
    if ( -l $server_all )        { next; }
    if ( !-d $server_all )       { next; }
    if ( $server =~ /^--HMC--/ ) { next; }
    my $server_space = $server;
    if ( $server =~ m/ / ) {
      $server_space = "\"" . $server . "\"";    # it must be here to support space with server names
    }
    my @hmcdir_all = <$wrkdir/$server_space/*>;

    #print "@hmcdir_all\n\n";
    #print $server . "\n";

    # find vm_servers
    foreach my $vmware_all (@hmcdir_all) {

      #  #print "$vmware_all\n";
      #  my $vcenter = basename($vmware_all);
      #  #print $vcenter . "\n";
      #  if (-d $vmware_all){
      #    if ($vmware_all =~ /vcenter/){
      #       push(@server_vm, $vmware_all );
      #       #print $server . "\n";
      #       #print "$vmware_all\n";
      #       next;
      #    }
      #
      #  }
      if ( -l $vmware_all ) { next; }
      if ( -d $vmware_all ) { next; }
      my $lpar = basename($vmware_all);
      if ( $lpar !~ /\.rrm$/ && $lpar !~ /\.rrh$/ ) { next; }
      push( @lpars_vm, $vmware_all );

      #print "$vmware_all\n";

    } ## end foreach my $vmware_all (@hmcdir_all)
  } ## end foreach my $server_all (@wrkdir_all)

  return @lpars_vm;
} ## end sub get_live_lpars_vm

sub set_utilization_cpu_vm {
  $count_lpars_vm = 0;

  foreach my $lpar ( get_live_lpars_vm() ) {
    chomp $lpar;

    #print $lpar . "\n";
    my $lpar_name = basename($lpar);

    #print "$lpar_name\n";
    $lpar_name =~ s/.rrm$//;
    $lpar_name =~ s/.rrh$//;
    $lpar_name =~ s/&&1/\//g;
    $lpar =~ s/:/\\:/g;
    my $answer;
    eval {
      RRDp::cmd qq(graph "$lpar_name"
    "--start" "$start_time"
    "--end" "$end_time"
    "--step=60"
    "DEF:cpu_usage_pric=$lpar:CPU_usage_Proc:AVERAGE"
    "DEF:host_hz=$lpar:host_hz:AVERAGE"
    "DEF:vCPU=$lpar:vCPU:AVERAGE"
    "DEF:CPU_usage=$lpar:CPU_usage:AVERAGE"
    "DEF:CPU_ready_ms=$lpar:CPU_ready_ms:AVERAGE"
    "CDEF:cpu_usage_proc=cpu_usage_pric,100,/"
    "CDEF:host_MHz=host_hz,1000,/,1000,/"
    "CDEF:CPU_usage_res=CPU_usage,host_MHz,/,vCPU,/,100,*"
    "CDEF:pagein_b_raw=cpu_usage_proc,UN,CPU_usage_res,cpu_usage_proc,IF"
    "CDEF:pagein_b=pagein_b_raw,UN,pagein_b_raw,pagein_b_raw,100,GT,100,pagein_b_raw,IF,IF"
    "CDEF:CPU_ready_leg=CPU_ready_ms,200,/,vCPU,/"
    "PRINT:pagein_b:AVERAGE:Utilization CPU in percent %2.2lf"
    "PRINT:CPU_ready_leg:AVERAGE:CPU ready %2.2lf"
    );
      $answer = RRDp::read;
    };
    if ($@) {
      if ( $@ =~ "ERROR" ) {
        error("Rrrdtool error : $@");
        next;
      }
    } ## end if ($@)
    my $aaa = $$answer;

    #if ( $aaa =~ /NaNQ/ ) { next; }
    ( undef, my $utilization_in_per, my $cpu_ready ) = split( "\n", $aaa );
    $utilization_in_per =~ s/Utilization CPU in percent\s+//;
    $cpu_ready =~ s/CPU ready\s+//;

    #print $utilization_in_per . "\n";
    foreach my $server ( keys %vmware ) {
      foreach my $Lpar ( keys %{ $vmware{$server}{LPAR} } ) {

        #print "$vmware{$server}{LPAR}{$Lpar}\n";
        if ( "$Lpar" eq "$lpar_name" ) {

          #print "$rrd_name\n";
          $count_lpars_vm++;
          $vmware{$server}{LPAR}{$Lpar}{CPU}       = $utilization_in_per;
          $vmware{$server}{LPAR}{$Lpar}{CPU_READY} = $cpu_ready;
        } ## end if ( "$Lpar" eq "$lpar_name")
      } ## end foreach my $Lpar ( keys %{ ...})
    } ## end foreach my $server ( keys %vmware)
  } ## end foreach my $lpar ( get_live_lpars_vm...)

  print "heatmap        : (VMware) set cpu utilization for $count_lpars_vm vm\n";
} ## end sub set_utilization_cpu_vm

sub set_utilization_mem_vm {
  my $mem_vm = 0;
  foreach my $lpar ( get_live_lpars_vm() ) {
    chomp $lpar;

    #print $lpar . "\n";
    my $lpar_name = basename($lpar);

    #print "$lpar_name\n";
    $lpar_name =~ s/.rrm$//;
    $lpar_name =~ s/.rrh$//;
    $lpar_name =~ s/&&1/\//g;
    $lpar =~ s/:/\\:/g;
    my $answer;
    eval {
      RRDp::cmd qq(graph "$lpar_name"
    "--start" "$start_time"
    "--end" "$end_time"
    "--step=60"
    "DEF:memory_granted=$lpar:Memory_granted:AVERAGE"
    "DEF:memory_active=$lpar:Memory_active:AVERAGE"
    "CDEF:ratio=memory_active,memory_granted,/"
    "CDEF:utilization_mem=ratio,100,*"
    "PRINT:utilization_mem:AVERAGE:Utilization Memory in percent %2.2lf"
    );
      $answer = RRDp::read;
    };
    if ($@) {
      if ( $@ =~ "ERROR" ) {
        error("Rrrdtool error : $@");
        next;
      }
    } ## end if ($@)
    my $aaa = $$answer;

    #if ( $aaa =~ /NaNQ/ ) { next; }
    ( undef, my $utilization_in_per ) = split( "\n", $aaa );
    $utilization_in_per =~ s/Utilization Memory in percent\s+//;

    #print $utilization_in_per . "\n";
    foreach my $server ( keys %vmware ) {
      foreach my $Lpar ( keys %{ $vmware{$server}{LPAR} } ) {

        #print "$vmware{$server}{LPAR}{$Lpar}\n";
        if ( "$Lpar" eq "$lpar_name" ) {

          #print "$rrd_name\n";
          $vmware{$server}{LPAR}{$Lpar}{MEMORY} = $utilization_in_per;
          $mem_vm++;
        } ## end if ( "$Lpar" eq "$lpar_name")
      } ## end foreach my $Lpar ( keys %{ ...})
    } ## end foreach my $server ( keys %vmware)
  } ## end foreach my $lpar ( get_live_lpars_vm...)
  print "heatmap        : (VMware) set memory utilization for $mem_vm vm\n";
} ## end sub set_utilization_mem_vm

sub set_utilization_pool_vm {
  $count_pools_vm = 0;
  my @pool = get_live_pool_power();
  foreach my $line (@pool) {

    #print $line . "\n";
    my ( $path, $server_name, $pool ) = split( ",", $line );
    my $pool_name = $pool;
    $pool_name =~ s/.rrm//g;
    $pool_name =~ s/.rrh//g;
    $path =~ s/:/\\:/g;
    my $answer;

    #print $server_name . "\n";
    foreach my $server ( keys %vmware ) {
      if ( "$server_name" eq "$server" ) {
        foreach my $pool ( keys %{ $vmware{$server}{POOL} } ) {
          if ( "$pool_name" eq "$pool" ) {
            if ( $pool_name =~ /^pool$/ ) {

              #print "$pool_name a $server\n";
              eval {
                RRDp::cmd qq(graph "$pool_name"
              "--start" "$start_time"
              "--end" "$end_time"
              "--step=60"
              "DEF:ent=$path:CPU_Alloc:AVERAGE"
              "DEF:utl=$path:CPU_usage:AVERAGE"
              "DEF:hz=$path:host_hz:AVERAGE"
              "CDEF:utiltot=utl,hz,/,1000000,*"
              "CDEF:total=ent,hz,/,1000000,*"
              "CDEF:utilper=utiltot,total,/,100,*"
              "PRINT:utilper:AVERAGE:Utilization POOL in percent  %2.2lf"
              );
                $answer = RRDp::read;
              };
              if ($@) {
                if ( $@ =~ "ERROR" ) {
                  error("Rrrdtool error : $@");
                  next;
                }
              } ## end if ($@)
              my $aaa = $$answer;

              #if ( $aaa =~ /NaNQ/ ) { next; }
              ( undef, my $utilization_in_per ) = split( "\n", $aaa );
              $utilization_in_per =~ s/Utilization POOL in percent\s+//g;
              $vmware{$server}{POOL}{$pool}{CPU} = $utilization_in_per;
              $count_pools_vm++;

              #print $utilization_in_per . "\n";
            } ## end if ( $pool_name =~ /^pool$/)
          } ## end if ( "$pool_name" eq "$pool")
        } ## end foreach my $pool ( keys %{ ...})
      } ## end if ( "$server_name" eq...)
    } ## end foreach my $server ( keys %vmware)
  } ## end foreach my $line (@pool)

  print "heatmap        : (VMware) set cpu utilization for $count_pools_vm pools\n";
} ## end sub set_utilization_pool_vm

sub set_utilization_mem_pool_vm {
  my $count_pools_mem_vm = 0;
  my @pool               = get_live_pool_power();
  foreach my $line (@pool) {

    #print $line . "\n";
    my ( $path, $server_name, $pool ) = split( ",", $line );
    my $pool_name = $pool;
    $pool_name =~ s/.rrm//g;
    $pool_name =~ s/.rrh//g;
    $path =~ s/:/\\:/g;
    my $answer;

    #print $server_name . "\n";
    foreach my $server ( keys %vmware ) {
      if ( "$server_name" eq "$server" ) {
        foreach my $pool ( keys %{ $vmware{$server}{POOL} } ) {
          if ( "$pool_name" eq "$pool" ) {
            if ( $pool_name =~ /^pool$/ ) {

              #print "$pool_name a $server\n";
              eval {
                RRDp::cmd qq(graph "$pool_name"
              "--start" "$start_time"
              "--end" "$end_time"
              "--step=60"
              "DEF:memory_granted=$path:Memory_granted:AVERAGE"
              "DEF:memory_active=$path:Memory_active:AVERAGE"
              "CDEF:ratio=memory_active,memory_granted,/"
              "CDEF:utilization_mem=ratio,100,*"
              "PRINT:utilization_mem:AVERAGE:Utilization Memory in percent %2.2lf"
              );
                $answer = RRDp::read;
              };
              if ($@) {
                if ( $@ =~ "ERROR" ) {
                  error("Rrrdtool error : $@");
                  next;
                }
              } ## end if ($@)
              my $aaa = $$answer;

              #if ( $aaa =~ /NaNQ/ ) { next; }
              ( undef, my $utilization_in_per ) = split( "\n", $aaa );
              $utilization_in_per =~ s/Utilization Memory in percent\s+//g;
              $vmware{$server}{POOL}{$pool}{MEMORY} = $utilization_in_per;
              $count_pools_mem_vm++;

              #print $utilization_in_per . "\n";
            } ## end if ( $pool_name =~ /^pool$/)
          } ## end if ( "$pool_name" eq "$pool")
        } ## end foreach my $pool ( keys %{ ...})
      } ## end if ( "$server_name" eq...)
    } ## end foreach my $server ( keys %vmware)
  } ## end foreach my $line (@pool)

  print "heatmap        : (VMware) set memory utilization for $count_pools_mem_vm pools\n";
} ## end sub set_utilization_mem_pool_vm

sub get_table_cpu_lpar_vm {
  use POSIX qw(ceil);
  my $count_row = 1;
  my $nasob     = 0;

  #print "$count_lpars_vm\n";
  #$count_lpars_vm = $count_lpars_vm*20;
  #print "$count_lpars_vm\n";
  if ( $count_lpars_vm == 0 ) { return "" }
  my $cell_size    = ( $height * $width ) / $count_lpars_vm;
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  my $style_vm = " .content_vm { height:" . "$td_height" . "px" . "; width:" . "$td_height" . "px" . ";} h3 {text-align:center;}";
  my $table    = "<table>\n<tbody>\n<tr>\n";

  my $table_values = "<table class =\"lparsearch tablesorter tablesortercfgsum\" data-sortby=\"4\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"VM\" nowrap=\"\">VM</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"CPU ready\" nowrap=\"\">CPU ready</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";


  foreach my $server ( sort keys %vmware ) {
    foreach my $lpar ( sort { lc $vmware{$server}{LPAR}{$a}{NAME} cmp lc $vmware{$server}{LPAR}{$b}{NAME} || $vmware{$server}{LPAR}{$a}{NAME} cmp $vmware{$server}{LPAR}{$b}{NAME} } keys %{ $vmware{$server}{LPAR} } ) {
      if ( defined $vmware{$server}{LPAR}{$lpar}{CPU} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util = $vmware{$server}{LPAR}{$lpar}{CPU};
        my $cpu_ready    = $vmware{$server}{LPAR}{$lpar}{CPU_READY};
        if ( !defined $cpu_ready || !isdigit($cpu_ready) ) {
          $cpu_ready = "nan";
        }
        else {
          my $ceil = ceil($cpu_ready);
          $cpu_ready = $ceil;
          $cpu_ready = $cpu_ready . "%";
        }
        if ( "$percent_util" eq "-nan" || "$percent_util" eq "nan" || $percent_util =~ /nan/ || "$percent_util" eq "NaNQ" || $percent_util =~ /NAN/ || $percent_util =~ /NaN/ || !isdigit($percent_util) ) {
          $percent_util = "nan";
        }
        else {
          my $ceil = ceil($percent_util);
          $percent_util = $ceil;
          $percent_util = $percent_util . "%";
        }
        my $url      = $vmware{$server}{LPAR}{$lpar}{URL};
        my $name     = $vmware{$server}{LPAR}{$lpar}{NAME};
        my $url_name = $name;

        #$url_name =~ s/([^A-Za-z0-9\+-_])/sprintf("%%%02X", ord($1))/seg;
        #$url_name =~ s/ /+/g;
        #$url_name =~ s/\#/%23/g;
        $url_name =~ s/([^a-zA-Z0-9_.!~*()'\''-])/sprintf("%%%02X", ord($1))/ge;

        #print "$url_name\n";
        $url =~ s/lpar=.*&item/lpar=$url_name&item/g;
        my $class = get_percent_to_color( $vmware{$server}{LPAR}{$lpar}{CPU}, $vmware{$server}{LPAR}{$lpar}{CPU_READY}, "ready" );
        my $color = $class_color{$class};

        $table = $table . "<td class=\"$class\">\n<a href=" . '"' . "$url" . '"' . "><div title =" . '"' . "$server : $name" . " : " . $percent_util . " : CPU ready $cpu_ready" . '"' . "class=" . '"' . "content_vm" . '"' . "></div>\n</a>\n</td>\n";
        $percent_util =~ s/\%//g;
        $cpu_ready =~ s/\%//g;

        $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=\"$url\">$name</a></td><td>$cpu_ready</td><td>$percent_util</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";


        $new_row = $td_width + $new_row;
      } ## end if ( defined $vmware{$server...})
      else { next; }
    } ## end foreach my $lpar ( sort { lc...})
  } ## end foreach my $server ( sort keys...)
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";
  my $tb_and_styl = "$table" . "@" . "$style_vm" . "@" . "$table_values";
  return ($tb_and_styl);

  #print "$table_vm\n";
  #print "$count_lpars\n";
} ## end sub get_table_cpu_lpar_vm

#sub set_html {
#  my $style = "<style>"."$style_power" . "$style_vm" . "td.red {background-color:#fb4949;} td.green {background-color:#1ba935;} td.orange {background-color:#f97525;} td.gray {background-color:#737a75;} table {border-spacing: 1px;}</style>";
#print $style . "\n";
#  my $html = "<!DOCTYPE html>\n<html>\n<head>".$style."</head><body>"."$table_power" . "$table_vm" . "</body></html>";
#  print $html . "\n";
#}

sub get_table_mem_lpar_vm {
  use POSIX qw(ceil);
  my $count_row = 1;

  #my $pom = $count_lpars_vm;
  #$pom = 0;
  if ( $count_lpars_vm == 0 ) { return "" }
  my $cell_size    = ( $height * $width ) / $count_lpars_vm;
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  my $table = "<table>\n<tbody>\n<tr>\n";
  my $table_values = "<table class =\"lparsearch tablesorter tablesortercfgsum\" data-sortby=\"3\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"VM\" nowrap=\"\">VM</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";


  foreach my $server ( sort keys %vmware ) {
    foreach my $lpar ( sort { lc $vmware{$server}{LPAR}{$a}{NAME} cmp lc $vmware{$server}{LPAR}{$b}{NAME} || $vmware{$server}{LPAR}{$a}{NAME} cmp $vmware{$server}{LPAR}{$b}{NAME} } keys %{ $vmware{$server}{LPAR} } ) {
      if ( defined $vmware{$server}{LPAR}{$lpar}{MEMORY} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util = $vmware{$server}{LPAR}{$lpar}{MEMORY};
        if ( "$percent_util" eq "-nan" || "$percent_util" eq "nan" || $percent_util =~ /nan/ || "$percent_util" eq "NaNQ" || $percent_util =~ /NAN/ || $percent_util =~ /NaN/ || !isdigit($percent_util) ) {
          $percent_util = "nan";
        }
        else {
          my $ceil = ceil($percent_util);
          $percent_util = $ceil;
          $percent_util = $percent_util . "%";
        }
        my $url      = $vmware{$server}{LPAR}{$lpar}{URL};
        my $name     = $vmware{$server}{LPAR}{$lpar}{NAME};
        my $url_name = $name;

        #$url_name =~ s/([^A-Za-z0-9\+-_])/sprintf("%%%02X", ord($1))/seg;
        #$url_name =~ s/ /+/g;
        #$url_name =~ s/\#/%23/g;
        $url_name =~ s/([^a-zA-Z0-9_.!~*()'\''-])/sprintf("%%%02X", ord($1))/ge;

        #print $name . "\n";
        $url =~ s/lpar=.*&item/lpar=$url_name&item/g;
        my $class = get_percent_to_color( $vmware{$server}{LPAR}{$lpar}{MEMORY});
        my $color = $class_color{$class};

        $table   = $table . "<td class=\"$class\">\n<a href=" . '"' . "$url" . '"' . "><div title =" . '"' . "$server : $name" . " : " . $percent_util . '"' . "class=" . '"' . "content_vm" . '"' . "></div>\n</a>\n</td>\n";

        $percent_util =~ s/\%//g;

        $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=\"$url\">$name</a></td><td>$percent_util</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";

        $new_row = $td_width + $new_row;
      } ## end if ( defined $vmware{$server...})
      else { next; }
    } ## end foreach my $lpar ( sort { lc...})
  } ## end foreach my $server ( sort keys...)
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";
  my $tb = $table . "@" . $table_values;
  return $tb;

  #print "$table_vm\n";
  #print "$count_lpars\n";
} ## end sub get_table_mem_lpar_vm

sub get_table_cpu_pool_vm {
  use POSIX qw(ceil);
  my $count_row = 1;
  my $nasob     = 1;

  #print "$count_pools\n";
  if ( $count_pools_vm == 0 ) { return "" }
  my $cell_size    = ( $height * $width ) / $count_pools_vm;
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  #my $i = 0;
  my $table = "<table>\n<tbody>\n<tr>\n";
  my $style = " .content_pool_vm { height:" . "$td_height" . "px" . "; width:" . "$td_height" . "px" . ";}  h3 {text-align:center;}";

  my $table_values = "<table class =\"lparsearch tablesorter\" data-sortby=\"3\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Pool\" nowrap=\"\">Pool</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

  foreach my $server ( sort keys %vmware ) {
    foreach my $pool ( sort { lc $vmware{$server}{POOL}{$a}{NAME} cmp lc $vmware{$server}{POOL}{$b}{NAME} || $vmware{$server}{POOL}{$a}{NAME} cmp $vmware{$server}{POOL}{$b}{NAME} } keys %{ $vmware{$server}{POOL} } ) {
      if ( defined $vmware{$server}{POOL}{$pool}{CPU} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util;
        my $util = $vmware{$server}{POOL}{$pool}{CPU};
        if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || !isdigit($util) ) {
          $percent_util = "nan";
        }
        else {
          $percent_util = ceil( $vmware{$server}{POOL}{$pool}{CPU} ) . "%";
        }
        my $class = get_percent_to_color($util);
        my $color = $class_color{$class};
        $table   = $table . "<td class=\"$class\">\n<a href=" . '"' . "$vmware{$server}{POOL}{$pool}{URL}" . '"' . "><div title =" . '"' . "$server : CPU" . " : " . $percent_util . '"' . "class=" . '"' . "content_pool_vm" . '"' . "></div>\n</a>\n</td>\n";
        $percent_util =~ s/\%//g;

        $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=" . '"' . "$vmware{$server}{POOL}{$pool}{URL}" . '"' . ">CPU</a></td><td>$percent_util</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";

        $new_row = $td_width + $new_row;
      } ## end if ( defined $vmware{$server...})
      else { next; }
    } ## end foreach my $pool ( sort { lc...})
  } ## end foreach my $server ( sort keys...)
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";
  my $tb_and_style = "$table" . "@" . "$style" . "@". "$table_values";
  return "$tb_and_style";
} ## end sub get_table_cpu_pool_vm

sub get_table_mem_pool_vm {
  use POSIX qw(ceil);
  my $count_row = 1;
  my $nasob     = 1;

  #print "$count_pools\n";
  if ( $count_pools_vm == 0 ) { return "" }
  my $cell_size    = ( $height * $width ) / $count_pools_vm;
  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  #my $i = 0;
  my $table = "<table>\n<tbody>\n<tr>\n";

  my $table_values = "<table class =\"lparsearch tablesorter\" data-sortby=\"3\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Pool\" nowrap=\"\">Pool</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

  foreach my $server ( sort keys %vmware ) {
    foreach my $pool ( sort { lc $vmware{$server}{POOL}{$a}{NAME} cmp lc $vmware{$server}{POOL}{$b}{NAME} || $vmware{$server}{POOL}{$a}{NAME} cmp $vmware{$server}{POOL}{$b}{NAME} } keys %{ $vmware{$server}{POOL} } ) {
      if ( defined $vmware{$server}{POOL}{$pool}{MEMORY} ) {
        if ( ( $new_row + $td_width ) > $width ) {
          $table   = $table . "</tr>\n<tr>\n";
          $new_row = 0;
        }
        my $percent_util;
        my $util = $vmware{$server}{POOL}{$pool}{MEMORY};
        if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || !isdigit($util) ) {
          $percent_util = "nan";
        }
        else {
          $percent_util = ceil( $vmware{$server}{POOL}{$pool}{MEMORY} ) . "%";
        }
        my $url = $vmware{$server}{POOL}{$pool}{URL};
        $url =~ s/lpar=pool/lpar=cod/g;
        $url =~ s/item=memalloc/lpar=memalloc/g;

        my $class = get_percent_to_color($util);
        my $color = $class_color{$class};

        $table   = $table . "<td class=\"$class\">\n<a href=" . '"' . "$url" . '"' . "><div title =" . '"' . "$server : MEM" . " : " . $percent_util . '"' . "class=" . '"' . "content_pool_vm" . '"' . "></div>\n</a>\n</td>\n";

        $percent_util =~ s/\%//g;


        $table_values = $table_values . "<tr><td>$server</td><td>" . "<a href=" . '"' . "$vmware{$server}{POOL}{$pool}{URL}" . '"' . ">MEM</a></td><td>$percent_util</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";

        $new_row = $td_width + $new_row;
      } ## end if ( defined $vmware{$server...})
      else { next; }
    } ## end foreach my $pool ( sort { lc...})
  } ## end foreach my $server ( sort keys...)
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";
  return "$table" . "@" . $table_values;
} ## end sub get_table_mem_pool_vm

sub get_html_lpar_power {
  my $memory = "Memory";
  my $check  = get_table_cpu_lpar_power();
  if ( $check eq "" ) {
    return 0;
  }
  else {
    set_wrap_html_power();
    my ( $table_cpu, $style_power, $table_values ) = split( "@", get_table_cpu_lpar_power() );
    my ($table_mem, $table_values_mem) = split ("@", get_table_mem_lpar_power());
    if ( $table_mem eq "" ) {
      $memory = "";
    }
    my $style = "<style>" . "$style_power" . "$style_html" . "</style>";

    #print get_legend();
    my $html = "<!DOCTYPE html>\n<html>\n<head>" . $style . "</head><body>\n<table class=" . '"' . "center" . '"' . ">\n<tbody>\n<tr><td><h3>CPU</h3></td></tr><tr>\n<td>" . "$table_cpu" . "</td></tr>\n<tr><td><h3>$memory</h3></td></tr><tr>\n<td>" . "$table_mem" . "</td></tr><tr><td>" . get_report() . "</td>\n</tr><tr><td>&nbsp;</td></tr><tr><td><b>LEGEND</b>:<tr><td>" . get_legend($memory) . "</td></tr>\n</tbody>\n</table>\n</body></html>";
    open( DATA, ">$webdir/heatmap-power-cpu.html" ) or error_die("Cannot open file: $webdir/heatmap-power-cpu.html : $!");
    print DATA $html;
    close DATA;
    my $html2 = "<!DOCTYPE html>\n<html>\n<head>".$style . "</head><body><center>$table_values</center></body></html>";
    open( DATA, ">$webdir/heatmap-power-cpu-lpar-values.html" ) or error_die("Cannot open file: $webdir/heatmap-power-cpu-lpar-values.html : $!");
    print DATA $html2;
    close DATA;
    my $html3 = "<!DOCTYPE html>\n<html>\n<head>".$style . "</head><body><center>$table_values_mem</center></body></html>";
    open( DATA, ">$webdir/heatmap-power-mem-lpar-values.html" ) or error_die("Cannot open file: $webdir/heatmap-power-mem-lpar-values.html : $!");
    print DATA $html3;
    close DATA;

    #print $html . "\n";
  } ## end else [ if ( $check eq "" ) ]
} ## end sub get_html_lpar_power

sub get_html_pool_power {
  my $check = get_table_cpu_pool_power();
  if ( $check eq "" ) {
    return 0;
  }
  else {
    set_wrap_html_power();
    my ( $table_cpu, $style_power, $table_values ) = split( "@", get_table_cpu_pool_power() );

    #my $table_mem = get_table_mem_lpar_power();
    my $style = "<style>" . "$style_power" . "$style_html" . "</style>";
    my $html  = "<!DOCTYPE html>\n<html>\n<head>" . $style . "</head><body>\n<table class=" . '"' . "center" . '"' . ">\n<tbody>\n<tr><td><h3>CPU</h3></td></tr><tr>\n<td>" . "$table_cpu" . "</td></tr>\n<tr><td>" . get_report() . "</td>\n</tr><tr><td>&nbsp;</td></tr><tr><td><b>LEGEND</b>:<tr><td>" . get_legend() . "</td></tr>\n</tbody>\n</table>\n</body></html>";
    open( DATA, ">$webdir/heatmap-power-server.html" ) or error_die("Cannot open file: $webdir/heatmap-power-server.html : $!");
    print DATA $html;
    close DATA;
    my $html2 = "<!DOCTYPE html>\n<html>\n<head>". $style . "</head><body><center>$table_values</center></body></html>";
    open( DATA, ">$webdir/heatmap-power-cpu-pool-values.html" ) or error_die("Cannot open file: $webdir/heatmap-power-cpu-pool-values.html : $!");
    print DATA $html2;
    close DATA;

    #print $html . "\n";
  } ## end else [ if ( $check eq "" ) ]

} ## end sub get_html_pool_power

sub set_html_power {
  get_html_lpar_power();
  get_html_pool_power();

}

sub set_wrap_html_power() {
  my $html = "<div id=" . '"' . "tabs" . '"' . ">\n<ul>\n<li><a href=" . '"' . "heatmap-power-cpu.html" . '"' . ">LPAR</a></li><li><a href=" . '"' . "heatmap-power-server.html" . '"' . ">Server</a></li>\n <li><a href=" . '"' . "heatmap-power-cpu-lpar-values.html" . '"' . ">LPAR CPU Table</a></li>\n <li><a href=" . '"' . "heatmap-power-mem-lpar-values.html" . '"' . ">LPAR MEM Table</a></li>\n  <li><a href=" . '"' . "heatmap-power-cpu-pool-values.html" . '"' . ">Server CPU Table</a></li> \n</ul>\n</div>";
  if ( -e "$webdir/heatmap-power.html" ) {
  }
  else {
    open( DATA, ">$webdir/heatmap-power.html" ) or error_die("Cannot open file: $webdir/heatmap-power.html : $!");
    print DATA $html;
    close DATA;
  }

} ## end sub set_wrap_html_power

sub get_html_lpar_vm {
  my $memory = "Memory";
  my $check  = get_table_cpu_lpar_vm();
  if ( $check eq "" ) {
    return 0;
  }
  else {
    set_wrap_html_vm();
    my ( $table_cpu, $style_vm, $table_values ) = split( "@", get_table_cpu_lpar_vm() );
    my ($table_mem, $table_mem_values) = split ( "@", get_table_mem_lpar_vm());
    if ( $table_mem eq "" ) {
      $memory = "";
    }
    my $style = "<style>" . "$style_vm" . "$style_html" . "</style>";

    #print $style . "\n";
    my $html = "<!DOCTYPE html>\n<html>\n<head>" . $style . "</head><body>\n<table class=" . '"' . "center" . '"' . ">\n<tbody><tr><td><h3>CPU</h3></td></tr>\n<tr>\n<td>" . $table_cpu . "</td></tr>\n<tr>\n<td>&nbsp;</td>\n</tr><tr><td><h3>$memory</h3></td></tr>\n<tr><td>" . $table_mem . "</td></tr><tr><td>" . get_report() . "\n</td></tr><tr><td>&nbsp;</td></tr><tr><td><b>LEGEND</b>:<tr><td>" . get_legend("cpu_ready") . "</td></tr>\n</tbody>\n</table>\n</body></html>";
    open( DATA, ">$webdir/heatmap-vmware-cpu.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware-cpu.html : $!");
    print DATA $html;
    close DATA;
    my $html2 = "<!DOCTYPE html>\n<html>\n<head>".$style . "</head><body><center>$table_values</center></body></html>";
    open( DATA, ">$webdir/heatmap-vmware-cpu-vm-values.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware-cpu-vm-values.html : $!");
    print DATA $html2;
    close DATA;
    my $html3 = "<!DOCTYPE html>\n<html>\n<head>".$style . "</head><body><center>$table_mem_values</center></body></html>";
    open( DATA, ">$webdir/heatmap-vmware-mem-vm-values.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware-mem-vm-values.html : $!");
    print DATA $html3;
    close DATA;

    #print $html . "\n";
  } ## end else [ if ( $check eq "" ) ]
} ## end sub get_html_lpar_vm

sub get_html_pool_vm {
  my $check = get_table_cpu_pool_vm();
  if ( $check eq "" ) {
    return 0;
  }
  else {
    set_wrap_html_vm();
    my ( $table_cpu, $style_vm, $table_values ) = split( "@", get_table_cpu_pool_vm() );
    my ($table_mem, $table_mem_values) = split( "@", get_table_mem_pool_vm());
    my $style     = "<style>" . "$style_vm" . "$style_html" . "</style>";

    #print $style . "\n";
    my $html = "<!DOCTYPE html>\n<html>\n<head>" . $style . "</head><body>\n<table class=" . '"' . "center" . '"' . ">\n<tbody><tr><td><h3>CPU</h3></td></tr>\n<tr>\n<td>" . $table_cpu . "</td></tr>\n<tr>\n<td>&nbsp;</td>\n</tr><tr><td><h3>Memory</h3></td></tr>\n<tr><td>" . $table_mem . "</td></tr><tr><td>" . get_report() . "</td></tr><tr><td>&nbsp;</td></tr><tr><td><b>LEGEND</b>:<tr><td>" . get_legend() . "</td></tr>\n</tbody>\n</table>\n</body></html>";
    open( DATA, ">$webdir/heatmap-vmware-server.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware-server.html : $!");
    print DATA $html;
    close DATA;

    my $html2 = "<!DOCTYPE html>\n<html>\n<head>". $style . "</head><body><center>$table_values</center></body></html>";
    open( DATA, ">$webdir/heatmap-vmware-cpu-server-values.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware-cpu-server-values.html : $!");
    print DATA $html2;
    close DATA;

    my $html3 = "<!DOCTYPE html>\n<html>\n<head>". $style . "</head><body><center>$table_mem_values</center></body></html>";
    open( DATA, ">$webdir/heatmap-vmware-mem-server-values.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware-mem-server-values.html : $!");
    print DATA $html3;
    close DATA;

    #print $html . "\n";
  } ## end else [ if ( $check eq "" ) ]

} ## end sub get_html_pool_vm

sub set_html_vm {
  get_html_lpar_vm();
  get_html_pool_vm();

}

sub set_wrap_html_vm {
  my $html = "<div id=" . '"' . "tabs" . '"' . ">\n <ul>\n<li><a href=" . '"' . "heatmap-vmware-cpu.html" . '"' . ">VM</a></li>\n<li><a href=" . '"' . "heatmap-vmware-server.html" . '"' . ">Server</a></li>\n<li><a href=" . '"' . "heatmap-vmware-cpu-vm-values.html" . '"' . ">VM CPU Table</a></li>\n<li><a href=" . '"' . "heatmap-vmware-mem-vm-values.html" . '"' . ">VM MEM Table</a></li>\n<li><a href=" . '"' . "heatmap-vmware-cpu-server-values.html" . '"' . ">Server CPU Table</a></li>\n<li><a href=" . '"' . "heatmap-vmware-cpu-server-values.html" . '"' . ">Server MEM Table</a></li>\n </ul>\n</div>";
  if ( -e "$webdir/heatmap-vmware.html" ) {
  }
  else {
    open( DATA, ">$webdir/heatmap-vmware.html" ) or error_die("Cannot open file: $webdir/heatmap-vmware.html : $!");
    print DATA $html;
    close DATA;
  }

} ## end sub set_wrap_html_vm

sub get_report {
  my $time  = localtime;
  my $table = "<table>\n<tbody>\n<tr>\n<td>Heat map has been created at: " . "$time" . "</td>\n</tr>\n<tr>\n<td>Heat map shows average utilization from last $LPAR_HEATMAP_UTIL_TIME hour.</td>\n</tr>\n</tbody>\n</table>";
  return $table;

} ## end sub get_report

sub get_note {
  my $table = "<table>\n<tbody>\n<tr>\n<td>It is being developed.</td>\n</tr>\n</tbody>\n</table>";
  return $table;
}

sub get_legend {
  my $memory = shift;
  my $table  = "<table>\n<tbody><tr>";
  my $i      = 0;
  my $from   = 0;
  my $to     = 10;
  my $title  = "";
  my $paging = "";
  while ( $i < 11 ) {

    if ( $i == 0 ) {
      $title = "nan";
    }
    if ( defined $memory && $memory eq "Memory" && $i == 10 ) {
      $title = $title . " and paging in > $HEATMAP_MEM_PAGING_MAX kB/s or paging out > $HEATMAP_MEM_PAGING_MAX kB/s";
    }
    if ( defined $memory && $memory eq "cpu_ready" && $i == 10 ) {
      $title = $title . " or CPU ready > 5%";
    }

    #print "$title\n";
    $table = $table . "\n<td title=" . '"' . "$title" . '"' . "class=" . '"' . "clr$i" . '"' . "><div class =" . '"' . "content_legend" . '"' . "></div></td>";
    $i++;
    $title = "$from-$to " . "%";
    $from  = $to + 1;
    $to    = $to + 10;
  } ## end while ( $i < 11 )
  $table = $table . "</tr>\n</tbody>\n</table>";
  return $table;
} ## end sub get_legend

sub error_die {
  my $message = shift;

  print STDERR "$message\n";
  RRDp::end;    # close RRD pipe
  exit(1);
} ## end sub error_die


sub set_structure_xen{
  my $file = "$basedir/tmp/menu_xenserver.json";
  if (!-f $file){return 1;}
  my $data = get_json($file);
  if (!defined $data->{children} || ref($data->{children}) ne "ARRAY"){return 1;}
  foreach my $element (@{$data->{children}}){
    if (!defined $element->{children} || ref($element->{children}) ne "ARRAY" ){next;}
    my $title = $element->{title};
    if (!defined $title){next;}
    $xen{$title}{NAME} = $title;
    foreach my $cluster (@{$element->{children}}){
      if (!defined $cluster->{children} || ref($cluster->{children}) ne "ARRAY" ){next;}
      my $title_cluster = $cluster->{title};
      if (!defined $title_cluster || $title_cluster eq "Totals" || $title_cluster eq "Storage"){next;}
      if ($title_cluster ne "VM"){
        $xen{$title}{SERVER}{$title_cluster}{NAME} = $title_cluster;
        foreach my $server (@{$cluster->{children}}){
          my $title_server = $server->{title};
          if (!defined $title_server || $title_server ne $title_cluster){next;}
          my $href = $server->{href};
          if (!defined $href){next;}
          my (undef, undef, $host) = split ("&",$href);
          if (defined $host && $host =~ m/^host=/){
            $host =~ s/host=//g;
            $xen{$title}{SERVER}{$title_cluster}{ID} = $host;
            $xen{$title}{SERVER}{$title_cluster}{URL} = $href;
          }
        }
      }
      else{
        foreach my $server (@{$cluster->{children}}){
          my $title_server = $server->{title};
          if (!defined $title_server){next;}
          my $href = $server->{href};
          if (!defined $href){next;}
          my (undef, undef, $host) = split ("&",$href);
          if (defined $host && $host =~ m/^vm=/){
            $host =~ s/vm=//g;
            $xen{$title}{VM}{$title_server}{ID} = $host;
            $xen{$title}{VM}{$title_server}{URL} = $href;
            $xen{$title}{VM}{$title_server}{NAME} = $title_server;
          }
        }
      }
    }
  }
}


sub set_structure_ovirt{
  my $file = "$basedir/tmp/menu_ovirt.json";

  if (!-f $file){
    return 1;
  }
  my $data = get_json($file);
  #print Dumper \$data;
  if (!defined $data->{children} || ref($data->{children}) ne "ARRAY"){return 1;}
  foreach my $element (@{$data->{children}}){
    if (!defined $element->{children} || ref($element->{children}) ne "ARRAY" ){next;}
    my $title = $element->{title};
    if (!defined $title){next;}
    $ovirt{DATACENTER}{$title}{NAME} = $title;
    foreach my $cluster (@{$element->{children}}){
      if (!defined $cluster->{children} || ref($cluster->{children}) ne "ARRAY" ){next;}
      my $title_cluster = $cluster->{title};
      if (!defined $title_cluster || $title_cluster eq "Storage domain"){next;}
      $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{NAME} = $title_cluster;
      foreach my $server (@{$cluster->{children}}){
        if (!defined $server->{children} || ref($server->{children}) ne "ARRAY" ){next;}
        my $title_server = $server->{title};
        if (!defined $title_server){next;}
        foreach my $test (@{$server->{children}}){
          my $href = $test->{href};
          if (!defined $href){next;}
          #/lpar2rrd-cgi/detail.sh?platform=oVirt&type=host_nic_aggr&host=be4602f0-8548-44c2-ac30-5a81e91cb3d8
          my (undef, undef, $host) = split ("&",$href);
          if (defined $host && $host =~ m/^host=/){
            $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{SERVER}{$title_server}{NAME} = $title_server;
            $host =~ s/^host=//;
            $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{SERVER}{$title_server}{ID} = $host;
            $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{SERVER}{$title_server}{URL} = $href;
          }
        }
        if ($title_server eq "VM"){
          foreach my $test (@{$server->{children}}){
            my $href = $test->{href};
            my $title_vm = $test->{title};
            if (!defined $href || !defined $title){next;}
            my (undef, undef, $host) = split ("&",$href);
            $host =~ s/^vm=//;
            $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{VM}{$title_vm}{NAME} = $title_vm;
            $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{VM}{$title_vm}{ID} = $host;
            $ovirt{DATACENTER}{$title}{CLUSTER}{$title_cluster}{VM}{$title_vm}{URL} = $href;
          }
        }
        #print Dumper \$server;
      }
    }
  }
  #print Dumper \%ovirt;
  return 1;
}

sub set_utilization_xen{
  my $type = shift;
  my $item = shift;

  foreach my $cluster (keys %xen){
    foreach my $server (keys %{$xen{$cluster}{$type}}){
      my $id = $xen{$cluster}{$type}{$server}{ID};
      if (!defined $id){next;}
      my $file = "";
      if ($type eq "SERVER"){
        $file = "$basedir/data/XEN/$id/sys.rrd";
      }
      if ($type eq "VM"){
        $file = "$basedir/data/XEN_VMs/$id.rrd";
      }
      if (! -f $file){next;}
      if ($item eq "MEMORY"){
        my ($cpu_util) = get_utilization_ovirt($file,$type,"MEMORY-XEN");
        if (defined $cpu_util){
          $xen{$cluster}{$type}{$server}{$item} = $cpu_util;
        }
        next;
      }
      my ($cpu_util) = get_utilization_ovirt($file,$type,$item,"XEN");
      if (defined $cpu_util){
        if ($type eq "SERVER" && $item eq "CPU"){
          $count_server_xen++;
        }
        if ($type eq "VM" && $item eq "CPU"){
          $count_vm_xen++;
        }
        $xen{$cluster}{$type}{$server}{$item} = $cpu_util;
      }
    }
  }
}

sub set_utilization_ovirt{
  my $type = shift;
  my $item = shift;

  foreach my $datacenter (keys %{$ovirt{DATACENTER}}){
    foreach my $cluster (keys %{$ovirt{DATACENTER}{$datacenter}{CLUSTER}}){
      #### server ###
      foreach my $server (keys %{$ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}}){
        my $id = $ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}{$server}{ID};
        if (!defined $id){next;}
        my $file = "";
        if ($type eq "SERVER"){
          $file = "$basedir/data/oVirt/host/$id/sys.rrd";
        }
        if ($type eq "VM"){
          $file = "$basedir/data/oVirt/vm/$id/sys.rrd";
        }
        if (! -f $file){next;}
        my ($cpu_util) = get_utilization_ovirt($file,$type,$item);
        if (defined $cpu_util){
          $ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}{$server}{$item} = $cpu_util;
          if ($type eq "SERVER" && $item eq "CPU"){
            $count_server_ovirt++;
          }
          if ($type eq "VM" && $item eq "CPU"){
            $count_vm_ovirt++;
          }
        }
      }
      ####
    }
  }
  #print Dumper \%ovirt;
}

sub set_html_ovirt{

  get_html_ovirt("SERVER",$count_server_ovirt,"CPU","OVIRT");
  get_html_ovirt("SERVER",$count_server_ovirt,"MEMORY","OVIRT");
  get_html_ovirt("VM",$count_vm_ovirt,"CPU","OVIRT");
  get_html_ovirt("VM",$count_vm_ovirt,"MEMORY", "OVIRT");

}


sub set_html_xen{

  get_html_ovirt("SERVER",$count_server_xen,"CPU", "XEN");
  get_html_ovirt("SERVER",$count_server_xen,"MEMORY", "XEN");
  get_html_ovirt("VM",$count_vm_xen,"CPU", "XEN");
  get_html_ovirt("VM",$count_vm_xen,"MEMORY", "XEN");

}




sub get_html_ovirt {
  my $type = shift;
  my $count = shift;
  my $item = shift;
  my $tech = shift;
  my $lc_type = lc($type);
  my $lc_tech = lc($tech);

  my $check = "";


  if ($tech eq "XEN"){
    $check = get_table_xen($type, $count, $item);
  }
  else{
    $check = get_table_ovirt($type, $count, $item);
  }
  if ( $check eq "" ) {
    return 0;
  }
  else {
    set_wrap_html_ovirt($lc_tech);
    my $table = "";
    my $style = "";
    my $table_values = "";
    if ($tech eq "XEN"){
    ( $table, $style, $table_values ) = split( "@", get_table_xen($type, $count, $item) );
    }
    else{
      ( $table, $style, $table_values ) = split( "@", get_table_ovirt($type, $count, $item) );
    }
    #my $table_mem = get_table_mem_lpar_power();
    #if ( $table_mem eq "" ) {
    #  $memory = "";
    #}
    $style = "<style>" . "$style" . "$style_html" . "</style>";

    #print get_legend();
    my $table_mem = "";
    my $memory = "";
    #my $html = "<!DOCTYPE html>\n<html>\n<head>" . $style . "</head><body>\n<table class=" . '"' . "center" . '"' . ">\n<tbody>\n<tr><td><h3>$item</h3></td></tr><tr>\n<td>" . "$table" . "</td></tr><tr><td>" . get_report() . "</td>\n</tr><tr><td>&nbsp;</td></tr><tr><td><b>LEGEND</b>:<tr><td>" . get_legend() . "</td></tr>\n</tbody>\n</table>\n</body></html>";
    if ($item eq "CPU"){
      my $html = "<!DOCTYPE html>\n<html>\n<head>" . $style . "</head><body>\n<table class=" . '"' . "center" . '"' . ">\n<tbody>\n<tr><td><h3>$item</h3></td></tr><tr>\n<td>" . "$table" . "</td></tr><tr><td>&nbsp;</td></tr>\n";
      open( DATA, ">$webdir/heatmap-$lc_tech-$lc_type.html" ) or error_die("Cannot open file: $webdir/heatmap-$lc_tech-$lc_type.html : $!");
      print DATA $html;
      close DATA;

      my $html2 = "<!DOCTYPE html>\n<html>\n<head>".$style . "</head><body><center>$table_values</center></body></html>";
      open( DATA, ">$webdir/heatmap-$lc_tech-$lc_type-cpu-values.html" ) or error_die("Cannot open file: $webdir/heatmap-$lc_tech-$lc_type-cpu-values.html : $!");
      print DATA $html2;
      close DATA;
    }
    else{
      my $html = "<tr><td><h3>$item</h3></td></tr><tr>\n<td>" . "$table" . "</td></tr><tr><td>&nbsp;</td></tr><tr><td>" . get_report() . "</td>\n</tr><tr><td>&nbsp;</td></tr><tr><td><b>LEGEND</b>:<tr><td>" . get_legend() . "</td></tr>\n</tbody>\n</table>\n</body></html>\n";
      open( DATA, ">>$webdir/heatmap-$lc_tech-$lc_type.html" ) or error_die("Cannot open file: $webdir/heatmap-$lc_tech-$lc_type.html : $!");
      print DATA $html;
      close DATA;

      my $html2 = "<!DOCTYPE html>\n<html>\n<head>".$style . "</head><body><center>$table_values</center></body></html>";
      open( DATA, ">$webdir/heatmap-$lc_tech-$lc_type-mem-values.html" ) or error_die("Cannot open file: $webdir/heatmap-$lc_tech-$lc_type-mem-values.html : $!");
      print DATA $html2;
      close DATA;

    }

    #print $html . "\n";
  } ## end else [ if ( $check eq "" ) ]
} ## end sub get_html_lpar_power

sub get_utilization_ovirt{
  my $file = shift;
  my $type = shift;
  my $item = shift;
  my $technology = shift;
  my $item_rrd = "cpu_usage_p";
  my $b2gib       = 1024**3;
  my $kib2gib     = 1024**2;
  if (defined $technology && $technology eq "XEN" && $item eq "CPU"){
    if ($type eq "SERVER"){
      $item_rrd = "cpu_avg";
    }
    else{
      $item_rrd = "cpu";
    }
  }

  $file =~ s/:/\\:/g;
  my $rrd_out_name = "graph.png";
  my $answer;

  if ( defined $technology && $technology eq "XEN" && $item eq "CPU" ){
    eval {
      RRDp::cmd qq(graph "$rrd_out_name"
      "--start" "$start_time"
      "--end" "$end_time"
      "--step=60"
      "DEF:cpu_usage_p=$file:$item_rrd:AVERAGE"
      "CDEF:cpu_util=cpu_usage_p,100,*"
      "PRINT:cpu_util:AVERAGE:Utilization $type %2.2lf"
    );
    $answer = RRDp::read;
    };
  }

  if ($item eq "CPU" && (!defined $technology || $technology ne "XEN")){
    eval {
      RRDp::cmd qq(graph "$rrd_out_name"
      "--start" "$start_time"
      "--end" "$end_time"
      "--step=60"
      "DEF:cpu_usage_p=$file:$item_rrd:AVERAGE"
      "PRINT:cpu_usage_p:AVERAGE:Utilization $type %2.2lf"
    );
    $answer = RRDp::read;
    };
  }
  if ($item eq "MEMORY"){
    eval {
      RRDp::cmd qq(graph "$rrd_out_name"
      "--start" "$start_time"
      "--end" "$end_time"
      "--step=60"
      "DEF:memory_used=$file:memory_used:AVERAGE"
      "DEF:memory_free=$file:memory_free:AVERAGE"
      "CDEF:total=memory_used,memory_free,+"
      "CDEF:util=memory_used,total,/,100,*"
      "PRINT:util:AVERAGE:Utilization $type %2.2lf"
    );
    $answer = RRDp::read;
    };
  }
  if ($item eq "MEMORY-XEN" && $type eq "SERVER"){
    eval {
      RRDp::cmd qq(graph "$rrd_out_name"
      "--start" "$start_time"
      "--end" "$end_time"
      "--step=60"
      "DEF:memory_total=$file:memory_total:AVERAGE"
      "CDEF:mem_total=memory_total,$kib2gib,/"
      "DEF:memory_free=$file:memory_free:AVERAGE"
      "CDEF:free=memory_free,$kib2gib,/"
      "CDEF:used=mem_total,free,-"
      "CDEF:util=used,mem_total,/,100,*"
      "PRINT:util:AVERAGE:Utilization $type %2.2lf"
    );
    $answer = RRDp::read;
    };
  }
  if ($item eq "MEMORY-XEN" && $type eq "VM"){
    eval {
      RRDp::cmd qq(graph "$rrd_out_name"
      "--start" "$start_time"
      "--end" "$end_time"
      "--step=60"
      "DEF:memory_total=$file:memory:AVERAGE"
      "CDEF:mem_total=memory_total,$b2gib,/"
      "DEF:memory_free=$file:memory_int_free:AVERAGE"
      "CDEF:free=memory_free,$kib2gib,/"
      "CDEF:used=mem_total,free,-"
      "CDEF:util=used,mem_total,/,100,*"
      "PRINT:util:AVERAGE:Utilization $type %2.2lf"
    );
    $answer = RRDp::read;
    };
  }
  if ($@) {
    if ( $@ =~ "ERROR" ) {
      error("Rrrdtool error : $@");
      return;
    }
  } ## end if ($@)
  my $aaa = $$answer;

  ( undef, my $util ) = split( "\n", $aaa );
  $util =~ s/Utilization $type\s+//;
  return $util;

}

sub get_table_xen {
  my $type = shift;
  my $count = shift;
  my $item = shift;
  use POSIX qw(ceil);

  #my $const = 2.6;
  my $count_row = 1;
  my $nasob     = 1;
  if ( $count == 0 ) { return "" }
  my $cell_size = ( $height * $width ) / $count;

  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  #my $i = 0;
  my $style = " .content_xen { height:" . "$td_height" . "px" . "; width:" . "$td_height" . "px" . ";} h3 {text-align:center;}";
  my $table = "<table>\n<tbody>\n<tr>\n";

  my $table_values = "<table class =\" lparsearch tablesorter\" data-sortby=\"3\">";
  $table_values = $table_values . "<thead><tr><th class = \"sortable\" title=\"Pool\" nowrap=\"\">Pool</th>\n";
  if ($type eq "VM"){
    $table_values = $table_values . "<th class = \"sortable\" title=\"VM\" nowrap=\"\">VM</th>\n";
  }
  else{
    $table_values = $table_values . "<th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  }
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

    foreach my $cluster (sort keys %xen){
      foreach my $server ( sort keys %{$xen{$cluster}{$type}} ) {
        if ( defined $xen{$cluster}{$type}{$server}{$item}) {
          if ( ( $new_row + $td_width ) > $width ) {
            $table   = $table . "</tr>\n<tr>\n";
            $new_row = 0;
          }
          my $url = $xen{$cluster}{$type}{$server}{URL};
          if (!defined $url){$url = "#";}
          my $percent_util;
          my $util = $xen{$cluster}{$type}{$server}{$item};
          if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || !isdigit($util) ) {
            $percent_util = "nan";
          }
          else {
            $percent_util = $xen{$cluster}{$type}{$server}{$item} . "%";
          }
          my $class = get_percent_to_color($util);
          my $color = $class_color{$class};
          $table = $table . "<td class=\"$class\">\n<a href=" . '"' . "$url" . '"' . "><div title =" . '"' . "$cluster : $server" . " : " . $percent_util . '"' . "class=" . '"' . "content_xen" . '"' . "></div>\n</a>\n</td>\n";

          $table_values = $table_values . "<tr><td>$cluster</td><td><a href=\"$url\">$server</a></td><td>$util</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";

          $new_row = $td_width + $new_row;
        } ## end if ( defined $inventory...)
        else {
          next;
        }
      } ## end foreach my $lpar ( sort { lc...})
    } ## end foreach my $server ( sort keys...)

  #print $table_power . "\n";
  $table_values = $table_values . "</tbody></table>";
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";

  #$print "$table_power\n";
  #print "$count_lpars\n";
  my $tb_and_style = "$table" . "@" . "$style" . "@" . $table_values;
  return "$tb_and_style";
} ## end sub get_table_cpu_lpar_power



sub get_table_ovirt {
  my $type = shift;
  my $count = shift;
  my $item = shift;
  use POSIX qw(ceil);

  #my $const = 2.6;
  my $count_row = 1;
  my $nasob     = 1;
  if ( $count == 0 ) { return "" }
  my $cell_size = ( $height * $width ) / $count;

  my $td_width     = ceil( sqrt($cell_size) );
  my $td_height    = $td_width;
  my $new_row      = 0;
  my $count_column = 1;

  if ( $td_width < 10 ) {
    $td_width  = 10;
    $td_height = 10;
  }
  if ( $td_width > 42 ) {
    $td_width  = 42;
    $td_height = 42;
  }

  $td_height = $td_height - 2;
  ################
  #my $i = 0;
  my $style = " .content_ovirt { height:" . "$td_height" . "px" . "; width:" . "$td_height" . "px" . ";} h3 {text-align:center;}";
  my $table = "<table>\n<tbody>\n<tr>\n";

  my $table_values = "<table class =\" lparsearch tablesorter\" data-sortby=\"4\">";
  $table_values = $table_values .  "<thead><tr><th class = \"sortable\" title=\"Datacenter\" nowrap=\"\">Datacenter</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Cluster\" nowrap=\"\">Cluster</th>\n";
  if ($type eq "VM"){
    $table_values = $table_values . "<th class = \"sortable\" title=\"VM\" nowrap=\"\">VM</th>\n";
  }
  else{
    $table_values = $table_values . "<th class = \"sortable\" title=\"Server\" nowrap=\"\">Server</th>\n";
  }
  $table_values = $table_values . "<th class = \"sortable\" title=\"Utilization %\" nowrap=\"\">Utilization %</th>\n";
  $table_values = $table_values . "<th class = \"sortable\" title=\"Color\" nowrap=\"\"><center>Color</center></th></tr></thead><tbody>\n";

  foreach my $datacenter ( sort keys %{$ovirt{DATACENTER}}) {
    foreach my $cluster (sort keys %{$ovirt{DATACENTER}{$datacenter}{CLUSTER}}){
      foreach my $server ( sort keys %{$ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}} ) {
        if ( defined $ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}{$server}{$item}) {
          if ( ( $new_row + $td_width ) > $width ) {
            $table   = $table . "</tr>\n<tr>\n";
            $new_row = 0;
          }
          my $url = $ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}{$server}{URL};
          if (!defined $url){$url = "#";}
          my $percent_util;
          my $util = $ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}{$server}{$item};
          if ( "$util" eq "-nan" || "$util" eq "nan" || $util =~ /nan/ || "$util" eq "NaNQ" || $util =~ /NAN/ || $util =~ /NaN/ || !isdigit($util) ) {
            $percent_util = "nan";
          }
          else {
            $percent_util = $ovirt{DATACENTER}{$datacenter}{CLUSTER}{$cluster}{$type}{$server}{$item} . "%";
          }
          my $class = get_percent_to_color($util);
          my $color = $class_color{$class};
          $table = $table . "<td class=\"$class\">\n<a href=" . '"' . "$url" . '"' . "><div title =" . '"' . "$datacenter : $cluster : $server" . " : " . $percent_util . '"' . "class=" . '"' . "content_ovirt" . '"' . "></div>\n</a>\n</td>\n";

          $table_values = $table_values . "<tr><td>$datacenter</td><td>$cluster</td><td><a href=\"$url\">$server</a></td><td>$util</td><td><div style=\"height:15px;width:15px;background-color:$color; margin: auto;\"></div></td></tr>\n";

          $new_row = $td_width + $new_row;
        } ## end if ( defined $inventory...)
        else {
          next;
        }
      } ## end foreach my $lpar ( sort { lc...})
    } ## end foreach my $server ( sort keys...)
  }

  #print $table_power . "\n";
  $table = $table . "</tr>\n</tbody>\n</table><br>\n";
  $table_values = $table_values . "</tbody></table>";

  #$print "$table_power\n";
  #print "$count_lpars\n";
  my $tb_and_style = "$table" . "@" . "$style" ."@". "$table_values";
  return "$tb_and_style";
} ## end sub get_table_cpu_lpar_power

sub set_wrap_html_ovirt {
  my $tech = shift;
  my $html = "<div id=" . '"' . "tabs" . '"' . ">\n<ul>\n<li><a href=" . '"' . "heatmap-$tech-vm.html" . '"' . ">VM</a></li>\n<li><a href=" . '"' . "heatmap-$tech-server.html" . '"' . ">Server</a></li>\n<li><a href=" . '"' . "heatmap-$tech-vm-cpu-values.html" . '"' . ">VM CPU Table</a></li>\n<li><a href=" . '"' . "heatmap-$tech-vm-mem-values.html" . '"' . ">VM MEM Table</a></li>\n<li><a href=" . '"' . "heatmap-$tech-server-cpu-values.html" . '"' . ">Server CPU Table</a></li>\n<li><a href=" . '"' . "heatmap-$tech-server-mem-values.html" . '"' . ">Server MEM Table</a></li></ul>\n</div>";
  if ( -e "$webdir/heatmap-$tech.html" ) {
  }
  else {
    open( DATA, ">$webdir/heatmap-$tech.html" ) or error_die("Cannot open file: $webdir/heatmap-$tech.html : $!");
    print DATA $html;
    close DATA;
  }

} ## end sub set_wrap_html_power


sub get_json {
  my $metadata_file = shift;
  my %dictionary;

  if ( -f $metadata_file ) {
    my ( $code, $ref ) = Xorux_lib::read_json( $metadata_file );
    %dictionary = $code ? %{ $ref } : ();
  }
  else {
    %dictionary = ();
  }
  return \%dictionary;
}

