
#use strict;
# no strict as definition of @inp does not work with it, o idea why ....

#use lib qw (/opt/freeware/lib/perl/5.8.0);
# no longer need to use "use lib qw" as the library PATH is already in PERL5LIB (lpar2rrd.cfg)

use Env qw(QUERY_STRING);
use Date::Parse;

# print CGI-BIN HTML header
print "Content-type: text/html\n\n";

#$QUERY_STRING .= ":.";

my $inputdir = $ENV{INPUTDIR};
my $webdir   = $ENV{WEBDIR};
my $wrkdir   = "$inputdir/data";
my $DEBUG    = $ENV{DEBUG};
my $errlog   = $ENV{ERRLOG};

my $bindir = $ENV{BINDIR};

open( OUT, ">> $errlog" ) if $DEBUG == 2;

( my $ftype, my $gui ) = split( /&/, $QUERY_STRING );

$ftype =~ s/name=//;
$ftype =~ s/:\.$//;
$gui =~ s/gui=//;
if ( $gui eq '' ) {
  $gui = 0;
}

if ( $gui == 0 ) {
  print_header();
}

my $done = 0;

if ( $ftype =~ m/maincfg/ ) { print_plain( $ftype, "lpar2rrd.cfg", "LPAR2RRD configuration file: ", "", ); $done = 1; }
if ( $ftype =~ m/favcfg/ )  { print_valid( $ftype, "favourites.cfg",               "Favourites configuration file: ",   "", ); $done = 1; }
if ( $ftype =~ m/custcfg/ ) { print_valid( $ftype, "web_config/custom_groups.cfg", "Custom Groups configuration file:", "", ); $done = 1; }
if ( $ftype =~ m/alrtcfg/ ) { print_valid( $ftype, "web_config/alerting.cfg",      "Alert configuration file:",         "", ); $done = 1; }
if ( $ftype =~ m/alhist/ )   { print_log( $ftype, "alert_history.log",        "Alert history log (last 500 rows):",              "",                                                                                    1, 500 );  $done = 1; }
if ( $ftype =~ m/loadout/ )  { print_log( $ftype, "load.out",                 "LPAR2RRD last run time log:",                     "",                                                                                    0, 0 );    $done = 1; }
if ( $ftype =~ m/apache/ )   { print_log( $ftype, "/var/log/httpd/error_log", "Apache error log (last 500 rows):",               "",                                                                                    1, 500 );  $done = 1; }
if ( $ftype =~ m/errlogvm/ )   { print_log( $ftype, "error.log-vmware",                "LPAR2RRD error vmware log (last 500 rows):",             "",                                                                                    1, 500 );  $done = 1; }

if ( $ftype =~ m/errlog$/ )   { print_log( $ftype, "error.log",                "LPAR2RRD error log (last 500 rows):",             "",                                                                                    1, 500 );  $done = 1; }
if ( $ftype =~ m/errcgi/ )   { print_log( $ftype, "error-cgi.log",            "LPAR2RRD cgi-bin error log (last 500 rows):",     "",                                                                                    1, 500 );  $done = 1; }
if ( $ftype =~ m/entitle/ )  { print_log( $ftype, "entitle-check.log",        "CPU Configuration Advisor log (last 1000 rows):", "<a href=\"http://www.lpar2rrd.com/cpu_configuration_advisor.html\">How it works</a>", 1, 1000 ); $done = 1; }
if ( $ftype =~ m/counters/ ) { print_log( $ftype, "counter-info.txt",         "VMWARE counters log:",                            "",                                                                                    0, 0 );    $done = 1; }

if ( $done == 0 ) {
  error("wrong parameter: $ftype : $QUERY_STRING");
}

if ( $gui == 0 ) {
  print_trailer();
}

exit 0;

sub print_plain {
  my $ftype     = shift;
  my $file_base = shift;
  my $text      = shift;
  my $file      = $inputdir . "/etc/web_config/" . $file_base;

  if ( !-f "$file" ) {
    $file = $inputdir . "/etc/" . $file_base;
  }

  if ( !-f "$file" ) {
    print "<CENTER><B>$text $file</B></CENTER>";
    print "<B>File: $file does not exist</B>";
    return 0;
  }

  open( FH, "< $file" ) || error("$0: Can't open $file") && return 0;
  print "<CENTER><B>$text $file</B></CENTER><PRE>";
  foreach my $line (<FH>) {
    if ( $line =~ m/^export / ) {
      next;    # exclude exporting variables lines
    }
    print "$line";
  } ## end foreach my $line (<FH>)
  return 1;
} ## end sub print_plain

sub print_valid {
  my $ftype     = shift;
  my $file_base = shift;
  my $text      = shift;
  my $file      = $inputdir . "/etc/" . $file_base;
  my $file_org  = $file;

  if ( !-f "$file" ) {
    $file =~ s/alerting.cfg/alert.cfg/ if $file =~ /alerting.cfg/;
    $file =~ s/web_config\///;    # try once more with the GUI cfg (old way)

    if ( !-f "$file" ) {
      print "<B>$text $file_org</B><br>";
      print "<B>File: $file or $file_org does not exist</B>";
      return 0;
    }
  } ## end if ( !-f "$file" )

  open( FH, "< $file" ) || error("$0: Can't open $file") && return 0;
  print "<CENTER><B>$text $file</B></CENTER><PRE>";
  foreach my $line (<FH>) {
    if ( $line =~ m/^#LPAR/ || $line =~ m/^#POOL/ ) {
      next;    # print only valid lines
    }
    if ( $ftype =~ m/custcfg/ || $ftype =~ m/favcfg/ ) {
      if ( $line =~ m/^LPAR/ || $line =~ m/^POOL/ ) {
        my $group = "";
        ( my $type, my $server, my $lpar, $group ) = split( /:/, $line );
        if ( $group =~ m/^$/ ) {
          next;    # print only valid lines
        }
      } ## end if ( $line =~ m/^LPAR/...)
    } ## end if ( $ftype =~ m/custcfg/...)
    print "$line";
  } ## end foreach my $line (<FH>)
  return 1;
} ## end sub print_valid

sub print_log {
  my $ftype     = shift;
  my $file_base = shift;
  my $text      = shift;
  my $text_tail = shift;
  my $reverse   = shift;
  my $max_rows  = shift;
  my $file      = $inputdir . "/logs/" . $file_base;

  if ( $file_base =~ m/^\// ) {

    # absolute path
    $file = $file_base;
  }

  if ( !-f "$file" ) {
    print "<CENTER><B>$text $file $text_tail</B></CENTER>";
    print "<B>File: $file does not exist</B>";
    return 0;
  }
  print "<CENTER><B>$text $file $text_tail</B></CENTER><PRE>";

  my @lines;
  if ( $max_rows > 0 ) {
    @lines = `tail -$max_rows $file`;
  }
  else {
    @lines = `cat $file`;
  }
  if ( $reverse == 1 ) {
    print reverse @lines;
  }
  else {
    print @lines;
  }
  return 1;
} ## end sub print_log

sub print_trailer {

  print "</pre></body></html>\n";

  return 1;
} ## end sub print_trailer

sub print_header {

  print "
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">
<HTML>
<HEAD>
<TITLE>LPAR2RRD old GUI </TITLE>
<META HTTP-EQUIV=\"pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"NOW\">
<META HTTP-EQUIV=\"last modified\" CONTENT=\"NOW\">
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR=\"#D3D2D2\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" ALINK=\"#FF0000\" >
";

  return 0;
} ## end sub print_header

# error handling
sub error {
  my $text     = shift;
  my $act_time = localtime();
  chomp($text);

  print "<pre>\n\nERROR          : $text : $!\n</pre>";
  print STDERR "$act_time: $text : $!\n";

  return 1;
} ## end sub error

