package LoadDataModule;    #
use strict;
use Date::Parse;
use RRDp;
use File::Copy;
use Xorux_lib;
use Math::BigInt;
use Data::Dumper;
use JSON;
use POSIX;
use File::Copy qw(copy);

my $rrdtool = $ENV{RRDTOOL};
# standard data retentions
my $one_minute_sample     = 86400;
my $five_mins_sample      = 25920;
my $one_hour_sample       = 4320;
my $five_hours_sample     = 1734;
my $one_day_sample        = 1080;
my $one_minute_sample_mem = 86400;
my $five_mins_sample_mem  = 25920;
my $one_hour_sample_mem   = 4320;
my $five_hours_sample_mem = 1734;
my $one_day_sample_mem    = 1080;

my $JUMP_DETECT = 900;

my $DEBUG_REST_API; if (defined $ENV{DEBUG_REST_API}) {$DEBUG_REST_API = $ENV{DEBUG_REST_API};}else{$DEBUG_REST_API=0;};

my $rename_once = 0;
my @rename      = "";

sub load_data {
  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $no_time, $SSH, $hmc_user, $json_configured, $save_files) = @_;
  my @lpar_trans  = @{$trans_tmp};
  my $counter     = 0;
  my $counter_tot = 0;
  my $counter_ins = 0;
  my $last_rec    = "";
  my $rrd         = "";
  my $time        = "";
  my $t           = "";
  my $answer      = "";
  my $utime       = time() + 3600;
  $rename_once = 0;
  my $keep_virtual = 0;
  my $jump = 0;

  if ( $ENV{KEEP_VIRTUAL} ) {
    $keep_virtual = $ENV{KEEP_VIRTUAL};    # keep number of virt processors in RRD --> etc/.magic
  }
  else {
    $keep_virtual = 0;
  }

  if ( $step > 60 ) {
    $JUMP_DETECT = 10800;                  # 3 hours
  }
  if ( $type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000                  # 2 days + for daily graphs/feed
  }

  my $input_lpar = "$input-$type_sam";
  if ( $ENV{LPAR_LOAD_EXTERNAL} ) {
    if ( -f $ENV{LPAR_LOAD_EXTERNAL} ) {
      $input_lpar = $ENV{LPAR_LOAD_EXTERNAL};    # keep number of virt processors in RRD --> etc/.magic
    }
  }

  my $line      = "";
  my @rrd_exist = "";
  my @rmd_exist = "";
  my @rsd_exist = "";

  my @lpar_name = "";
  my @lpar_idle = "";
  my @lpar_time = "";
  my @lpar_jump = "";

  my $l_count_rmd   = 0;
  my $ltime_rmd     = 0;
  my @lpar_name_rmd = "";
  my @lpar_time_rmd = "";

  my $l_count_rsd   = 0;
  my $ltime_rsd     = 0;
  my @lpar_name_rsd = "";
  my @lpar_time_rsd = "";

  my $last_time   = "";
  my $error_once  = 0;
  my $error_count = 0;
  if (defined $json_configured && $json_configured == 1){
    my $perf_string = "lpars_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.lpars"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.lpars") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.lpars at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n" if $DEBUG;
      my $path = "$iostatdir$file";
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        print "no content in $path\n";
        next;
      }
      my $temp_ts;
      foreach my $arr_ts_sample (@{$content}){
        my $t = str2time( substr( $arr_ts_sample->[0], 0, 19 ) );
        my $lpar = $arr_ts_sample->[1];
        $lpar =~ s/\//\&\&1/g;
        $rrd = "$wrkdir/$managedname/$host/$lpar.rr$type_sam";
        if (!-e $rrd){
          my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time, "", "", $wrkdir, $lpar, $t, $keep_virtual );
          if ( $ret == 2 ) {
            next;
          }
        }
        my $curr_proc_units; my $entitled_cycles; my $capped_cycles; my $uncapped_cycles; my $mode; my $idle_proc_cycles;
        $curr_proc_units = $arr_ts_sample->[14] if defined $arr_ts_sample->[14];
        $curr_proc_units = $arr_ts_sample->[15] if (!defined $curr_proc_units);
        $entitled_cycles = $arr_ts_sample->[5];
        $capped_cycles = $arr_ts_sample->[3];
        $uncapped_cycles = $arr_ts_sample->[4];

        $mode = $arr_ts_sample->[7];
        $idle_proc_cycles = $arr_ts_sample->[6];
        #print "LPAR neg counters info: $lpar mode:$mode proc_units:$arr_ts_sample->[14] $arr_ts_sample->[15] entitled:$arr_ts_sample->[5] capped:$arr_ts_sample->[3] uncapped$arr_ts_sample->[4] idle:$idle_proc_cycles\n";
        if ($mode =~ m/^share_idle_/ || $mode=~ m/^keep_idle_/ ) {
          $capped_cycles = $capped_cycles - $idle_proc_cycles if ($capped_cycles >= $idle_proc_cycles);
        }

        eval {
          RRDp::cmd qq(last "$rrd" );
          $last_rec = RRDp::read;
        };
        if ($@) {
          #RRDp::error_mode = "catch";
          rrd_error( $@, $rrd );
          next;
        }
        chomp($$last_rec);
        my $last_update_rrd = $$last_rec;

        if ( $t > $last_update_rrd ) {
          $entitled_cycles = Math::BigInt->new($entitled_cycles);
          $capped_cycles = Math::BigInt->new($capped_cycles);
          $uncapped_cycles = Math::BigInt->new($uncapped_cycles);
          if (!(main::isdigit($curr_proc_units))){ $curr_proc_units = "U"; }
          if (!(main::isdigit($entitled_cycles))){ $entitled_cycles = "U"; }
          if (!(main::isdigit($capped_cycles))){ $capped_cycles = "U"; }
          if (!(main::isdigit($uncapped_cycles))){ $uncapped_cycles = "U"; }
          if ($curr_proc_units < 0 || $entitled_cycles < 0 || $capped_cycles < 0 || $uncapped_cycles < 0){
            my $capped_cycles_or = $capped_cycles + $idle_proc_cycles;
            main::error( "$host:$managedname : Not valid counters in lpars $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles \n Original line: $curr_proc_units:$entitled_cycles:$capped_cycles_or:$uncapped_cycles " . __FILE__ . ":" . __LINE__ );
            next;
          }
          RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles);
          eval {
            $answer    = RRDp::read;
          };
          if ($@){
            #rrd_error( $@, $rrd );
            next;
          }
        }
      }
=cut
      foreach my $timestamp (sort keys %{$content}){
        $temp_ts = $timestamp;
        foreach my $lpar (sort keys %{$content->{$timestamp}}){
          my $rrd_exist_ok  = 0;
          my $rrd_exist_row = 0;
          my $ltime = 0;
          my $memory    = $content->{$timestamp}{$lpar}{memory};
          my $processor = $content->{$timestamp}{$lpar}{processor};

          my $phys_run_mem = "";
          my $curr_io_entitled_mem ="";
          my $mapped_io_mem = "";
          my $curr_mem="";
          if (defined $memory->{phys_run_mem} && $memory->{phys_run_mem} ne ""){$phys_run_mem = $memory->{phys_run_mem};}
          else{$phys_run_mem = "U";}
          if (defined $memory->{curr_io_entitled_mem} && $memory->{curr_io_entitled_mem} ne ""){$curr_io_entitled_mem = $memory->{curr_io_entitled_mem};}
          else{$curr_io_entitled_mem = "U";}
          if (defined $memory->{mapped_io_mem} && $memory->{mapped_io_mem} ne ""){$mapped_io_mem = $memory->{mapped_io_mem};}
          else{$mapped_io_mem = "U";}
          if (defined $memory->{curr_mem} && $memory->{curr_mem} ne ""){$curr_mem = $memory->{curr_mem};}
          else{$curr_mem = "U";}

          my $mode="";
          my $idleProcCycles="";
          my $curr_proc_units="";
          my $utilizedUnCappedProcCycles="";
          my $utilizedCappedProcCycles="";
          my $curr_procs="";
          my $donatedProcCycles="";
          my $entitledProcCycles="";
          my $curr_sharing_mode="";
          my $mem_overage_cooperation="";
          if (defined $processor->{mode} && $processor->{mode} ne ""){$mode = $processor->{mode};}
          else{$mode = "U";}
          if (defined $processor->{idleProcCycles} && $processor->{idleProcCycles} ne ""){$idleProcCycles = $processor->{idleProcCycles};}
          else{$idleProcCycles = "U";}
          if (defined $processor->{curr_proc_units} && $processor->{curr_proc_units} ne ""){ $curr_proc_units = $processor->{curr_proc_units};}
          else{$curr_proc_units = "U";}
          if (defined $processor->{utilizedUnCappedProcCycles}&& $processor->{utilizedUnCappedProcCycles}ne""){$utilizedUnCappedProcCycles = $processor->{utilizedUnCappedProcCycles};}
          else{$utilizedUnCappedProcCycles = "U";}
          if (defined $processor->{utilizedCappedProcCycles} && $processor->{utilizedCappedProcCycles} ne ""){$utilizedCappedProcCycles = $processor->{utilizedCappedProcCycles};}
          else{$utilizedCappedProcCycles = "U";}
          if (defined $processor->{curr_procs} && $processor->{curr_procs} ne ""){$curr_procs = $processor->{curr_procs};}
          else{$curr_procs = "U";}
          if (defined $processor->{donatedProcCycles} && $processor->{donatedProcCycles} ne ""){$donatedProcCycles = $processor->{donatedProcCycles};}
          else{$donatedProcCycles = "U";}
          if (defined $processor->{entitledProcCycles} && $processor->{entitledProcCycles} ne ""){$entitledProcCycles = $processor->{entitledProcCycles};}
          else{$entitledProcCycles = "U";}
          if (defined $processor->{curr_sharing_mode} && $processor->{curr_sharing_mode} ne ""){$curr_sharing_mode = $processor->{curr_sharing_mode};}
          else{$curr_sharing_mode = "U";}
          if (defined $processor->{mem_overage_cooperation} && $processor->{mem_overage_cooperation} ne ""){$mem_overage_cooperation = $processor->{mem_overage_cooperation};}
          else{$mem_overage_cooperation = "U";}

          my $testing_out = "LPAR info: $lpar $timestamp $phys_run_mem $mode $idleProcCycles $curr_proc_units $utilizedUnCappedProcCycles $utilizedCappedProcCycles $curr_procs $donatedProcCycles $entitledProcCycles $curr_sharing_mode";
          if ( $mode =~ m/^share_idle_/ || $mode=~ m/^keep_idle_/ ) {
          #if ($mode eq "keep_idle_procs"){ # dedicated lpars showed 100% usage, this resolves the problem.
            $utilizedCappedProcCycles = $utilizedCappedProcCycles - $idleProcCycles;
          }

          my $ret = substr( $timestamp, 0, 1 );
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) );
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          # replace / by &&1, install-html.sh does the reverse thing
          $lpar =~ s/\//\&\&1/g;
          $rrd     = "$wrkdir/$managedname/$host/$lpar.rr$type_sam"; #m;

          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
             #my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time, "", "", $wrkdir, $lpar, $t, $keep_virtual );
              if ( $ret == 2 ) {
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
         if ($mode =~ m/shared/){


#    my $phys_run_mem = "";
#    my $curr_io_entitled_mem ="";
#    my $mapped_io_mem = "";
#    my $curr_mem="";


          if ($curr_mem eq '' || $phys_run_mem eq '' || $curr_io_entitled_mem eq '' || $mapped_io_mem eq '') {
            print "not defined some values\ncurr_mem:$curr_mem\nphys_run_mem:$phys_run_mem\ncurr_io_entitled_mem:$curr_io_entitled_mem\nmapped_io_mem:$mapped_io_mem\n";
          }
          else{
            #create rrd db if necessary
            # find out if rrd db exist, and place info to the array to do not check its existency every time
            my $rmd_exist_ok  = 0;
            my $rmd_exist_row = 0;
            $lpar =~ s/\//\&\&1/g;
            my $rmd = "$wrkdir/$managedname/$host/$lpar.rm$type_sam";
            if ( $rmd_exist_ok == 0 ) {
              $rmd_exist[$rmd_exist_row] = $lpar;
              my $ret = create_lpar_mem( $rmd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                return 1;    # RRD creation problem, skip whole load
              }
            } ##end if ( $rmd_exist_ok == ...)

            if ( $ltime_rmd == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0; 
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
              rrd_error( $@, $rrd );
              $rrd_exist_ok = 0; 
              next;
            }
            chomp($$last_rec);
            $ltime_rmd = $$last_rec;
          } ## end if ( $ltime == 0 )


            if ( $t > $ltime_rmd ) {
              $curr_mem = Math::BigInt->new($curr_mem);
              $phys_run_mem = Math::BigInt->new($phys_run_mem);
              $curr_io_entitled_mem = Math::BigInt->new($curr_io_entitled_mem);
              $mapped_io_mem = Math::BigInt->new($mapped_io_mem);
              $mem_overage_cooperation = Math::BigInt->new($mem_overage_cooperation);

              if (!(main::isdigit($curr_mem))){ $curr_mem = "U"; }
              if (!(main::isdigit($phys_run_mem))){ $phys_run_mem = "U"; }
              if (!(main::isdigit($curr_io_entitled_mem))){ $curr_io_entitled_mem = "U"; }
              if (!(main::isdigit($mapped_io_mem))){ $mapped_io_mem = "U"; }
              if (!(main::isdigit($mem_overage_cooperation))){ $mem_overage_cooperation = "U"; }

              my $datestring = localtime();
              print "Debug-001-$datestring-$datestring-$rmd $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_mem:$mem_overage_cooperation\n" if $DEBUG_REST_API;
              RRDp::cmd qq(update "$rmd" $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_mem:$mem_overage_cooperation);
              $last_time = $time;
              if ( $counter_ins == 0 ) {
                $counter_ins++;    # just to force update last.txt
              }
              eval {
                $answer    = RRDp::read;
              };
              if ($@){
              rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
              }
              if ( !$$answer eq '' && $$answer =~ m/ERROR/ ) {
                main::error(" $host:$managedname : $rmd : $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_mem:$mem_overage_cooperation : $line : $$answer");
                if ( $$answer =~ m/is not an RRD file/ ) {
                  ( my $err, my $file, my $txt ) = split( /'/, $$answer );
                  main::error("Removing as it seems to be corrupted: $file");
                  unlink("$file") || main::error( "Cannot rm $file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
                }
              } ## end if ( !$$answer eq '' &&...)

              # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
              $lpar_time_rmd[$l_count_rmd] = $t;
            } ## end if ( $t > $ltime )
            #} ## end if ( $t > $ltime_rmd )
          } #end else [if curr_mem eq '' || ....
         }#end if (mem mode == shared

          else{ #if $mem_m...        #when mem_mode is not shared
            if ( $curr_mem eq '' ) {
              #main::error("$host:$managedname : wrong mem input, dedicated mem defined but curr_mem is null : $line");
            }
            else{
              my $rsd_exist_ok  = 0;
              my $rsd_exist_row = 0;
              $lpar =~ s/\//\&\&1/g;
              my $rsd = "$wrkdir/$managedname/$host/$lpar.rs$type_sam";
              if (!(-e $rsd)){
                my $ret = create_lpar_mem_ded( $rsd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
                if ( $ret == 2 ) {
                  return 1;    # RRD creation problem, skip whole load
                }
              }
              else{
              eval {
                RRDp::cmd qq(last "$rsd");
                $last_rec = RRDp::read;
              };
              if ($@){
                rrd_error( $@, $rrd );
                $rrd_exist_ok = 0;
                next;
              }
              chomp($$last_rec);
              $ltime_rsd = $$last_rec;
              if ( $rsd_exist_ok == 0 ) {
                $rsd_exist[$rsd_exist_row] = $lpar;
                my $ret = create_lpar_mem_ded( $rsd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
                if ( $ret == 2 ) {
                  return 1;    # RRD creation problem, skip whole load
                }
              } ## end if ( $rsd_exist_ok == ...)
              if ( $t > $ltime_rsd ) {
                my $datestring = localtime();
                print "Debug-002-$datestring-$datestring-$rsd $t:$curr_mem\n" if $DEBUG_REST_API;
                if (!(main::isdigit($curr_mem))){ $curr_mem = "U"; }
                RRDp::cmd qq(update "$rsd" $t:$curr_mem);
                if ( $counter_ins == 0 ) {
                  $counter_ins++;    # just to force update last.txt
                }
                $last_time = $time;
                eval {
                  $answer    = RRDp::read;
                };
                if ($@){
                  $rrd_exist_ok = 0;
                  #next;
                }
                if (defined $answer && $answer ne ""){
                  if ( !$$answer eq '' && $$answer =~ m/ERROR/ ) {
                    main::error(" $host:$managedname : $rsd : $t:$curr_mem : $line : $$answer");
                    if ( $$answer =~ m/is not an RRD file/ ) {
                      ( my $err, my $file, my $txt ) = split( /'/, $$answer );
                      main::error("Removing as it seems to be corrupted: $file");
                      unlink("$file") || main::error( "Cannot rm $file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
                    }
                  } ## end if ( !$$answer eq '' &&...)
                }

                # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
                $lpar_time_rsd[$l_count_rsd] = $t;
              } ## end if ( $t > $ltime_rsd )
            }
           } ## end else (if $curr_mem eq '')
          }## end else [ if ( $mem_mode =~ m/shared/)]

          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
              rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            $entitledProcCycles = Math::BigInt->new($entitledProcCycles);
            $utilizedCappedProcCycles = Math::BigInt->new($utilizedCappedProcCycles);
            $utilizedUnCappedProcCycles = Math::BigInt->new($utilizedUnCappedProcCycles);
            my $datestring = localtime();
            print "Debug-003--$datestring-$rrd $t:$curr_proc_units:$entitledProcCycles:$utilizedCappedProcCycles:$utilizedUnCappedProcCycles\n" if $DEBUG_REST_API;
            if (!(main::isdigit($curr_proc_units))){ $curr_proc_units = "U"; }
            if (!(main::isdigit($entitledProcCycles))){ $entitledProcCycles = "U"; }
            if (!(main::isdigit($utilizedCappedProcCycles))){ $utilizedCappedProcCycles = "U"; }
            if (!(main::isdigit($utilizedUnCappedProcCycles))){ $utilizedUnCappedProcCycles = "U"; }
            RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$entitledProcCycles:$utilizedCappedProcCycles:$utilizedUnCappedProcCycles);
            $last_time = $timestamp;
            my $answer = RRDp::read;
            # update the time of last record
            $ltime = $t;
          } ## end if ( $t > $ltime && length...)
        } #end foreach my $lpar
      } #end foreach my $timestamp
=cut
      ##unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
      if (defined $file && defined $files[-1] && defined $files[-2]){
      if ($file eq $files[-1]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/lpars_perf1");
      }
      if ($file eq $files[-2]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/lpars_perf2");
      }
      }
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || main::error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || main::error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      open ($ltiph, ">", "$wrkdir/$managedname/$host/iostat/last_ts.lpars");
      print $ltiph "$temp_ts";
      close($ltiph);
    }
  }
  else{ #old, works when JSON is off in .magic
   open( FH, "< $input_lpar" ) || main::error( " Can't open $input_lpar : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
   my @lines = reverse <FH>;
   close(FH);

   foreach $line (@lines) {


    #print "$line";
    chomp($line);
    $time = "";
    my $lpar                       = "";
    my $lpar_id                    = "";
    my $curr_proc_units            = "";
    my $curr_procs                 = "";
    my $curr_sharing_mode          = "";
    my $entitled_cycles            = "";
    my $capped_cycles              = "";
    my $uncapped_cycles            = "";
    my $shared_cycles_while_active = "";
    my $mem_mode                   = "";
    my $curr_mem                   = "";
    my $phys_run_mem               = "";
    my $curr_io_entitled_mem       = "";
    my $mapped_io_entitled_mem     = "";
    my $mem_overage_cooperation    = "";
    my $idle_cycles                = 0;

    if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {

      # something wrong with the input data
      main::error("$host:$managedname : wrong input data in $host:$managedname:data:$input-$type_sam : $line");
      return 1;
    } ## end if ( $line =~ "HSCL" ||...)

    if ( $line =~ "An invalid parameter value was entered" ) {

      # something wrong with the input data
      main::error("$host:$managedname : wrong input data in $host:$managedname:data:$input-$type_sam : $line");
      next;
    } ## end if ( $line =~ "An invalid parameter value was entered")

    if ( $HMC == 1 ) {
      ( $time, $lpar, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles, $capped_cycles, $uncapped_cycles, $shared_cycles_while_active, $mem_mode, $curr_mem, $phys_run_mem, $curr_io_entitled_mem, $mapped_io_entitled_mem, $mem_overage_cooperation, $idle_cycles ) = split( /,/, $line );
    }
    if ( $IVM == 1 ) {
      ( $time, $lpar_id, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles, $capped_cycles, $uncapped_cycles, $shared_cycles_while_active, $mem_mode, $curr_mem, $phys_run_mem, $curr_io_entitled_mem, $mapped_io_entitled_mem, $mem_overage_cooperation ) = split( /,/, $line );
    }
    if ( $SDMC == 1 ) {
      ( $time, $lpar_id, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles, $capped_cycles, $uncapped_cycles, $mem_mode, $curr_mem, $phys_run_mem, $curr_io_entitled_mem, $mapped_io_entitled_mem, $mem_overage_cooperation ) = split( /,/, $line );
    }

    # print "001 $lpar : $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles $capped_cycles, $uncapped_cycles, $idle_cycles\n";
    # $curr_proc_units can be null for dedicated partitions so do not test it here!!!!
    if ( $curr_procs eq '' || $curr_sharing_mode eq '' || $entitled_cycles eq '' || $capped_cycles eq '' || $uncapped_cycles eq '' ) {

      # something wrong with input data, skipping it
      # it migh happen, here is en example : 05/03/2012 22:34:50,1,,,,,,
      next;
    } ## end if ( $curr_procs eq ''...)

    #print "$time $lpar \n";
    # Check whether the first character is a digit, if not then there is something wrong with the
    # input data
    my $ret = substr( $time, 0, 1 );

    #if (($ret =~ /\D/) || ( $lpar eq '' ))  {
    # do not put there $lpar as it might be NULL when the systems is down, seen it for memory
    if ( $ret =~ /\D/ ) {
      main::error("Wrong input data, file : $input-$type_sam : $line");

      # leave it as wrong input data
      if ( $type_sam =~ "d" ) {
        main::error("Migh be caused by freshly enabled new server and daily data is not yet collected, then it should disapear after  1 day");
      }
      if ( $type_sam =~ "h" ) {
        main::error("Migh be caused by freshly enabled new server and daily data is not yet collected, then it should disapear after  1 day");
      }
      main::error("$host:$managedname :Here is the content of the file");
      main::error("head -1/tail -1 \"$input-$type_sam\"");
      my $res = `head -1 \"$input-$type_sam\"`;
      chomp($res);
      main::error("$res");
      $res = `tail -1 \"$input-$type_sam\"`;
      chomp($res);
      main::error("$res");
      close(FH);
      return 1;
    } ## end if ( $ret =~ /\D/ )

    if ( $HMC == 0 ) {    # IVM translation ids to names
                          # this will have a problem whether a "," is inside lpar name
      foreach my $li (@lpar_trans) {
        chomp($li);
        ( my $id, my $name ) = split( /,/, $li );

        #print "---02 $li -- $id - $lpar_id\n";
        if ( $id == $lpar_id ) {
          $lpar = $name;
          last;
        }
      } ## end foreach my $li (@lpar_trans)
    } ## end if ( $HMC == 0 )

    if ( $lpar =~ m/IOR Collection LP/ ) {    #it is some trash, it exists time to tme, some IBM internal ...
      next;                                   #ignore it
    }
    if ( $lpar eq '' ) {
      next;                                   #again something wrong
    }

    # replace / by &&1, install-html.sh does the reverse thing
    $lpar =~ s/\//\&\&1/g;

    $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {

      # leave it as wrong input data
      main::error( "$host:$managedname :No valid lpar data time format got from HMC : $t : $line : " . __FILE__ . ":" . __LINE__ );
      next;                                   # next only, could  happen that there appears unix 0 time on the HMC after the upgrade, then just ignore it
    } ## end if ( length($t) < 10 )

    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );

      #print "$t $lpar\n";
      #print "Input data: $lpar\n";
    } ## end if ( $step == 3600 )
    if ( $lpar =~ m/\"/ ) {

      # LPAR cannot contain double quote, it is an illegal character in the lpar name, report it once and ignore it
      if ( $error_once == 0 ) {
        main::error( "$host:$managedname :LPAR cannot contain double quote, it is an illegal character in the lpar name: $lpar : $line : " . __FILE__ . ":" . __LINE__ );
      }
      $error_once++;
      next;
    } ## end if ( $lpar =~ m/\"/ )

    $rrd = "$wrkdir/$managedname/$host/$lpar.rr$type_sam";
    #print "RRDNAME = $lpar.rr$type_sam\n";

    #create rrd db if necessary
    # find out if rrd db exist, and place info to the array to do not check its existency every time
    my $rrd_exist_ok  = 0;
    my $rrd_exist_row = 0;
    foreach my $row (@rrd_exist) {
      $rrd_exist_row++;
      if ( $row =~ m/^$lpar$/ ) {
        $rrd_exist_ok = 1;
        last;
      }
    } ## end foreach my $row (@rrd_exist)
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time, $SSH, $hmc_user, $wrkdir, $lpar, $t, $keep_virtual );
      if ( $ret == 1 ) {

        # this lpar has been recently renamed, ignore it then
        next;
      }
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist[$rrd_exist_row] = $lpar;
    } ## end if ( $rrd_exist_ok == ...)

    # found out last record and save it
    # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
    my $l_count = 0;
    my $found   = -1;
    my $ltime;
    my $lpar_meta = quotemeta($lpar);
    foreach my $l (@lpar_name) {
      if ( $l =~ m/^$lpar_meta$/ ) {
        $found = $l_count;
        last;
      }
      $l_count++;
    } ## end foreach my $l (@lpar_name)
    if ( $found > -1 ) {
      $ltime   = $lpar_time[$found];
      $l_count = $found;
    }
    else {
      # find out last record in the db
      # as this makes it slowly to test it each time then it is done
      # once per a lpar for whole load and saved into the array

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
        rrd_error( $@, $rrd );
        if ( $rrd_exist[$rrd_exist_row] =~ m/^$lpar$/ ) {
          $rrd_exist[$rrd_exist_row] = "";
        }
        next;
      } ## end if ($@)
      chomp($$last_rec);
      $lpar_name[$l_count] = $lpar;
      $lpar_time[$l_count] = $$last_rec;
      $lpar_jump[$l_count] = 0;
      $lpar_idle[$l_count] = 0;
      $ltime               = $$last_rec;
    } ## end else [ if ( $found > -1 ) ]

    # when dedicated partitions then there is not set up $curr_proc_units as it is useless
    # I put curr_procs into curr_proc_units to make some gratphs for dedicated lpars
    if ( $curr_sharing_mode =~ m/^share_idle_/ || $curr_sharing_mode =~ m/^keep_idle_/ || length($curr_proc_units) == 0 ) {
      $curr_proc_units = $curr_procs;
      if ( defined($idle_cycles) && !$idle_cycles eq '' && $idle_cycles > 0 ) {

        # CPU lpars have reported idle cycles on new HMC firmwares --> use it for utilization
        $capped_cycles -= $idle_cycles;
        if ( $capped_cycles < 0 ) {

          # capped_cycles can be negative --> CPU dedicated LPARs after LPM might have more idle than capped -->
          # it is a big problem, only the solution is store initial big $idle counter and always use it for decrement of $idle
          # ideal solution would be storing $idle into rrd, but problem with compatability ... :(
          if ( $lpar_idle[$l_count] == 0 ) {
            $lpar_idle[$l_count] = get_lpar_idle_count( $wrkdir, $host, $managedname, $lpar_name[$l_count], $idle_cycles, "get" );
          }
          $capped_cycles = $capped_cycles + $lpar_idle[$l_count];
          if ( $capped_cycles < 0 ) {

            # might appear that it is still negative after several LPM, original saved $idle must be refreshed
            $capped_cycles = $capped_cycles - $lpar_idle[$l_count];    # return saved one
            $lpar_idle[$l_count] = get_lpar_idle_count( $wrkdir, $host, $managedname, $lpar_name[$l_count], $idle_cycles, "force" );
            $capped_cycles = $capped_cycles + $lpar_idle[$l_count];
          } ## end if ( $capped_cycles < ...)
          if ( $capped_cycles < 0 ) {

            # if still < 0 then something works bad, note error and skip it
            if ( $error_count == 0 ) {
              main::error( "counter < 0! :  $rrd $t:$curr_proc_units:$curr_procs:$entitled_cycles:$capped_cycles:$uncapped_cycles - $idle_cycles,$lpar_idle[$l_count], skipping LPAR $lpar_name[$l_count] " . __FILE__ . ":" . __LINE__ );
              $error_count++;
            }
            next;
          } ## end if ( $capped_cycles < ...)
        } ## end if ( $capped_cycles < ...)
      } ## end if ( defined($idle_cycles...))

      # no, no here, shared_syscles* modes containg right $capped_cycles data
      #if ( defined ($shared_cycles_while_active) && ! $shared_cycles_while_active eq '' &&  main::isdigit($shared_cycles_while_active) ) {
      #  $capped_cycles -= $shared_cycles_while_active; # only for LPARs in share_idle_procs_always mode
      #}
      $capped_cycles = $capped_cycles + 0;    #conversion to format understable for rrdtool
    } ## end if ( $curr_sharing_mode...)

    # when CPU dedicated LPARs and modes "share_idle*" then there is already capped shown correctly in data!
    #   --> then do not lower entitlement as this produce wrong numbers then
    # if $curr_proc_units == 0 then lpar is not running and it causing a problem with donated cycles
    #if ($curr_proc_units > 0) {
    #  # exclude POWER5 systems where $shared_cycles_while_active does not exist
    #  # it is for donation of dedicated CPU lpars
    #  if ($curr_sharing_mode =~ "share_idle_procs" || $curr_sharing_mode =~ "share_idle_procs_active" || \
    #      $curr_sharing_mode =~ "share_idle_procs_always" ) {
    #    if ( ! $shared_cycles_while_active eq '' ) {
    #      if ( $entitled_cycles < $shared_cycles_while_active ) {
    #         main::error ("$rrd $t:$entitled_cycles - $shared_cycles_while_active < 0 !!! ".__FILE__.":".__LINE__);
    #         next;
    #      }
    #      # necesary due to Perl behaviour whe it convert it to format X.YZ+eXY
    #      $entitled_cycles= $entitled_cycles - $shared_cycles_while_active;
    #      $entitled_cycles = Math::BigInt->new($entitled_cycles);
    #    }
    #  }
    #}

    if ( $t > $ltime && length($curr_proc_units) > 0 ) {

      #print "$lpar: $time $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles \n";
      if ( data_check( $entitled_cycles, $capped_cycles, $uncapped_cycles, $lpar, $host, $managedname ) == 0 ) {

        my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
        if ( $t > $jump_time ) {

          # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
          # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
          if ( $lpar_jump[$l_count] == 0 ) {
            $lpar_jump[$l_count] = 1;

            #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
            #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
            next;
          } ## end if ( $lpar_jump[$l_count...])

          # looks like it is ok as it is second timestap in a row
        } ## end if ( $t > $jump_time )
        $lpar_jump[$l_count] = 0;

        # It does not go there even when partition is switched off and counters are 0
        if ( $entitled_cycles < 0 || $uncapped_cycles < 0 || $capped_cycles < 0 ) {
          if ( $error_count == 0 ) {
            main::error( "counter < 0! :  $rrd $t:$curr_proc_units:$curr_procs:$entitled_cycles:$capped_cycles:$uncapped_cycles " . __FILE__ . ":" . __LINE__ );
            $error_count++;
          }
          next;
        } ## end if ( $entitled_cycles ...)

        # conversion from scientific X.YeYY format to usual decimal format
        #$curr_proc_units = $curr_proc_units + 0;
        #$curr_procs = $curr_procs + 0;
        #$entitled_cycles = $entitled_cycles + 0;
        #$capped_cycles = $capped_cycles + 0;
        #$uncapped_cycles = $uncapped_cycles + 0;
        # It does not work good (always!), use below one instead
        #$curr_proc_units = Math::BigInt->new($curr_proc_units); --> never use it for this, it is integer --> it cut everything behind decimal
        #$curr_procs      = Math::BigInt->new($curr_procs); --> never use it for this, it is integer --> it cut everything behind decimal
        $entitled_cycles = Math::BigInt->new($entitled_cycles);
        $capped_cycles   = Math::BigInt->new($capped_cycles);
        $uncapped_cycles = Math::BigInt->new($uncapped_cycles);
        if (!(main::isdigit($curr_proc_units))){ $curr_proc_units = "U"; }
        if (!(main::isdigit($curr_procs))){ $curr_procs = "U"; }
        if (!(main::isdigit($entitled_cycles))){ $entitled_cycles = "U"; }
        if (!(main::isdigit($capped_cycles))){ $capped_cycles = "U"; }
        if (!(main::isdigit($uncapped_cycles))){ $uncapped_cycles = "U"; }

        if ( $keep_virtual == 1 ) {

          # new one, DHL needs to keep virtual processors for accounting
          my $datestring = localtime();
          print "Debug-004a-$rrd $t:$curr_proc_units:$curr_procs:$entitled_cycles:$capped_cycles:$uncapped_cycles\n" if $DEBUG_REST_API;
          RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$curr_procs:$entitled_cycles:$capped_cycles:$uncapped_cycles);
        }
        else {
          # old way without storing number of virtual processors
          my $datestring = localtime();
          print "Debug-004b-$rrd $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles (- no curr_procs)\n" if $DEBUG_REST_API;
          RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles);
        }
        $answer    = RRDp::read;
        $last_time = $time;
        $counter_ins++;
        if ( !$$answer eq '' && $$answer =~ m/ERROR/ ) {
          main::error(" $host:$managedname : $rrd : $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles : $line : $$answer");
          if ( $$answer =~ m/is not an RRD file/ ) {
            ( my $err, my $file, my $txt ) = split( /'/, $$answer );
            main::error("Removing as it seems to be corrupted: $file");
            unlink("$file") || main::error( "Cannot rm $file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
          }
        } ## end if ( !$$answer eq '' &&...)

        # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
        $lpar_time[$l_count] = $t;
      } ## end if ( data_check( $entitled_cycles...))

      # memory should go through although switched off partition
      # sometimes (? when partition is halted??) it might have still allocated memory although it is off!!!

      #
      #  memory stuff
      #

      if ( !$mem_mode eq '' ) {
        if ( $mem_mode =~ m/shared/ ) {

          # AMS memory stuff only if it is activated
          if ( $curr_mem eq '' || $phys_run_mem eq '' || $curr_io_entitled_mem eq '' || $mapped_io_entitled_mem eq '' || $mem_overage_cooperation eq '' ) {

            #main::error ("$host:$managedname : wrong mem input, shared defined but some value is null : $line");
            #main::error ("$host:$managedname: future timestamp: $rrd");
            #print "$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation\n";
          } ## end if ( $curr_mem eq '' ||...)
          else {
            #create rrd db if necessary
            # find out if rrd db exist, and place info to the array to do not check its existency every time
            my $rmd_exist_ok  = 0;
            my $rmd_exist_row = 0;
            foreach my $row1 (@rmd_exist) {
              $rmd_exist_row++;
              if ( $row1 =~ m/^$lpar$/ ) {
                $rmd_exist_ok = 1;
                last;
              }
            } ## end foreach my $row1 (@rmd_exist)
            my $rmd = "$wrkdir/$managedname/$host/$lpar.rm$type_sam";
            if ( $rmd_exist_ok == 0 ) {
              $rmd_exist[$rmd_exist_row] = $lpar;
              my $ret = create_lpar_mem( $rmd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                return 1;    # RRD creation problem, skip whole load
              }
            } ## end if ( $rmd_exist_ok == ...)

            # found out last record and save it
            # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
            $l_count_rmd = 0;
            my $found_rmd = -1;
            my $lpar_meta = quotemeta($lpar);
            foreach my $l (@lpar_name_rmd) {
              if ( $l =~ m/^$lpar_meta$/ ) {
                $found_rmd = $l_count_rmd;
                last;
              }
              $l_count_rmd++;
            } ## end foreach my $l (@lpar_name_rmd)

            #print "RMD 01: $lpar $found_rmd - $t\n";
            if ( $found_rmd > -1 ) {
              $ltime_rmd   = $lpar_time_rmd[$found_rmd];
              $l_count_rmd = $found_rmd;
            }
            else {
              # find out last record in the db
              # as this makes it slowly to test it each time then it is done
              # once per a lpar for whole load and saved into the array

              # construction against crashing daemon Perl code when RRDTool error appears
              # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
              # construction is not too costly as it runs once per each load
              eval {
                RRDp::cmd qq(last "$rmd" );
                $last_rec = RRDp::read;
              };
              if ($@) {
               rrd_error( $@, $rmd );
                if ( $rmd_exist[$rmd_exist_row] =~ m/^$lpar$/ ) {
                  $rmd_exist[$rmd_exist_row] = "";
                }
                next;
              } ## end if ($@)
              chomp($$last_rec);
              $lpar_name_rmd[$l_count_rmd] = $lpar;
              $lpar_time_rmd[$l_count_rmd] = $$last_rec;
              $ltime_rmd                   = $$last_rec;

              #print "RMD 01: $lpar $ltime_rmd - $t\n";
            } ## end else [ if ( $found_rmd > -1 )]

            #print "RMD 02: $lpar $ltime_rmd - $t\n";

            if ( $t > $ltime_rmd ) {
              my $datestring = localtime();
              print "Debug-005-$datestring-$rmd $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation\n" if $DEBUG_REST_API;
              if (!(main::isdigit($curr_mem))){ $curr_mem = "U"; }
              if (!(main::isdigit($phys_run_mem))){ $phys_run_mem = "U"; }
              if (!(main::isdigit($curr_io_entitled_mem))){ $curr_io_entitled_mem = "U"; }
              if (!(main::isdigit($mapped_io_entitled_mem))){ $mapped_io_entitled_mem = "U"; }
              if (!(main::isdigit($mem_overage_cooperation))){ $mem_overage_cooperation = "U"; }
              RRDp::cmd qq(update "$rmd" $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation);
              $last_time = $time;
              if ( $counter_ins == 0 ) {
                $counter_ins++;    # just to force update last.txt
              }
              $answer = RRDp::read;
              if ( !$$answer eq '' && $$answer =~ m/ERROR/ ) {
                main::error(" $host:$managedname : $rmd : $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation : $line : $$answer");
                if ( $$answer =~ m/is not an RRD file/ ) {
                  ( my $err, my $file, my $txt ) = split( /'/, $$answer );
                  main::error("Removing as it seems to be corrupted: $file");
                  unlink("$file") || main::error( "Cannot rm $file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
                }
              } ## end if ( !$$answer eq '' &&...)

              # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
              $lpar_time_rmd[$l_count_rmd] = $t;
            } ## end if ( $t > $ltime_rmd )
          } ## end else [ if ( $curr_mem eq '' ||...)]
        } ## end if ( $mem_mode =~ m/shared/)
        else {
          # dedicated mode, just 1 item inside
          if ( $curr_mem eq '' ) {
            #main::error("$host:$managedname : wrong mem input, dedicated mem defined but curr_mem is null : $line");

            #print "$curr_mem\n";
          }
          else {
            #create rrd db if necessary
            # find out if rrd db exist, and place info to the array to do not check its existency every time
            my $rsd_exist_ok  = 0;
            my $rsd_exist_row = 0;
            foreach my $row1 (@rsd_exist) {
              $rsd_exist_row++;
              if ( $row1 =~ m/^$lpar$/ ) {
                $rsd_exist_ok = 1;
                last;
              }
            } ## end foreach my $row1 (@rsd_exist)
            $lpar =~ s/\//\&\&1/g ;
            my $rsd = "$wrkdir/$managedname/$host/$lpar.rs$type_sam";
            if ( $rsd_exist_ok == 0 ) {
              $rsd_exist[$rsd_exist_row] = $lpar;
              my $ret = create_lpar_mem_ded( $rsd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                return 1;    # RRD creation problem, skip whole load
              }
            } ## end if ( $rsd_exist_ok == ...)

            # found out last record and save it
            # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
            $l_count_rsd = 0;
            my $found_rsd = -1;
            my $lpar_meta = quotemeta($lpar);
            foreach my $l (@lpar_name_rsd) {
              if ( $l =~ m/^$lpar_meta$/ ) {
                $found_rsd = $l_count_rsd;

                #print "RSD 01: $lpar - $found_rsd - $lpar_meta\n";
                last;
              } ## end if ( $l =~ m/^$lpar_meta$/)
              $l_count_rsd++;
            } ## end foreach my $l (@lpar_name_rsd)

            #print "RSD 01: $lpar $found_rsd - $t\n";
            if ( $found_rsd > -1 ) {
              $ltime_rsd   = $lpar_time_rsd[$found_rsd];
              $l_count_rsd = $found_rsd;

              #print "RSD 02: $lpar $ltime_rsd - $found_rsd\n";
            } ## end if ( $found_rsd > -1 )
            else {
              # find out last record in the db
              # as this makes it slowly to test it each time then it is done
              # once per a lpar for whole load and saved into the array

              # construction against crashing daemon Perl code when RRDTool error appears
              # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
              # construction is not too costly as it runs once per each load
              eval {
                RRDp::cmd qq(last "$rsd" );
                $last_rec = RRDp::read;
              };
              if ($@) {
               rrd_error( $@, $rsd );
                if ( $rsd_exist[$rsd_exist_row] =~ m/^$lpar$/ ) {
                  $rsd_exist[$rsd_exist_row] = "";
                }
                next;
              } ## end if ($@)
              chomp($$last_rec);
              $lpar_name_rsd[$l_count_rsd] = $lpar;
              $lpar_time_rsd[$l_count_rsd] = $$last_rec;
              $ltime_rsd                   = $$last_rec;

              #print "RSD 03: $lpar $ltime_rsd - $$last_rec\n";
            } ## end else [ if ( $found_rsd > -1 )]

            #print "RSD 04: $lpar $ltime_rsd - $t\n";

            if ( $t > $ltime_rsd ) {
              my $datestring = localtime();
              print "Debug-006-$datestring-$rsd $t:$curr_mem\n" if $DEBUG_REST_API;
              if (!(main::isdigit($curr_mem))){ $curr_mem = "U"; }
              RRDp::cmd qq(update "$rsd" $t:$curr_mem);
              if ( $counter_ins == 0 ) {
                $counter_ins++;    # just to force update last.txt
              }
              $last_time = $time;
              $answer    = RRDp::read;
              if ( !$$answer eq '' && $$answer =~ m/ERROR/ ) {
                main::error(" $host:$managedname : $rsd : $t:$curr_mem : $line : $$answer");
                if ( $$answer =~ m/is not an RRD file/ ) {
                  ( my $err, my $file, my $txt ) = split( /'/, $$answer );
                  main::error("Removing as it seems to be corrupted: $file");
                  unlink("$file") || main::error( "Cannot rm $file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
                }
              } ## end if ( !$$answer eq '' &&...)

              # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
              $lpar_time_rsd[$l_count_rsd] = $t;
            } ## end if ( $t > $ltime_rsd )
          } ## end else [ if ( $curr_mem eq '' )]
        } ## end else [ if ( $mem_mode =~ m/shared/)]

      }    #memory

    } ## end if ( $t > $ltime && length...)
  } ## end foreach $line (@lines)
  } #end else (if json configured
  if ( $error_count > 1 ) {
    main::error( "error count  : $host:$managedname:lpar $error_count " . __FILE__ . ":" . __LINE__ );
  }
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:lpar $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data

sub load_data_pool_mem {
  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_pool, $no_time, $json_configured, $save_files) = @_;
  my @lpar_trans   = @{$trans_tmp};
  my $counter      = 0;
  my $counter_tot  = 0;
  my $counter_ins  = 0;
  my $rrd          = "";
  my $ltime        = 0;
  my $time         = "";
  my $rrd_exist_ok = 0;
  my $jump         = 0;
  my $last_time    = "";

  if ( $step > 60 ) {
    $JUMP_DETECT = 10800;    # 3 hours
  }
  if ( $type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000    # 2 days + for daily graphs/feed
  }

  if ( !-f "$input_pool-$type_sam" ) {
    print "updating RRD   : $host:$managedname:ams:$input_pool-$type_sam - no AMS file detected\n" if $DEBUG;
    return 0;
  }
  else {
    print "updating RRD   : $host:$managedname:ams:$input_pool-$type_sam - AMS\n" if $DEBUG;
  }

  if ($json_configured == 1){
    
  }
  else{
   open( FH, "< $input_pool-$type_sam" ) || main::error( " Can't open $input_pool-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
   my @lines = reverse <FH>;
   close(FH);
   foreach my $line (@lines) {
    chomp($line);

    if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {

      # something wrong with the input data
      # exceptionaly here also : No results were found as without AMS support it prints a lot of warnings
      if ( $line !~ m/No results were found/ ) {
        main::error("$host:$managedname : wrong input data in $host:$managedname:data:$input_pool-$type_sam : $line");
      }
      return 1;
    } ## end if ( $line =~ "HSCL" ||...)

    ( $time, my $curr_pool_mem, my $lpar_curr_io_entitled_mem, my $lpar_mapped_io_entitled_mem, my $lpar_run_mem, my $sys_firmware_pool_mem ) = split( /,/, $line );

    # Check whether first character is a digit, if not then there is something wrong with the
    # input data
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {

      # leave it as wrong input data
      main::error( "$host:$managedname : No valid cpu data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( $ret =~ /\D/ )
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {

      # leave it as wrong input data
      main::error( "$host:$managedname : No valid cpu data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }

    $rrd = "$wrkdir/$managedname/$host/mem-pool.rr$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_pool_mem( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    # find out last record in the db, do it just once
    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
      $jump  = 0;
    } ## end if ( $ltime == 0 )

    # print "last pool : $ltime  actuall: $t\n";
    # it updates only if time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime && length($curr_pool_mem) > 0 ) {

      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;

      $counter_ins++;
      my $datestring = localtime();
      print "Debug-007-$datestring-$rrd $t:$curr_pool_mem:$lpar_curr_io_entitled_mem:$lpar_mapped_io_entitled_mem:$lpar_run_mem:$sys_firmware_pool_mem\n" if $DEBUG_REST_API;
      if (!(main::isdigit($curr_pool_mem))){ $curr_pool_mem = "U"; }
      if (!(main::isdigit($lpar_curr_io_entitled_mem))){ $lpar_curr_io_entitled_mem = "U"; }
      if (!(main::isdigit($lpar_mapped_io_entitled_mem))){ $lpar_mapped_io_entitled_mem = "U"; }
      if (!(main::isdigit($lpar_run_mem))){ $lpar_run_mem = "U"; }
      if (!(main::isdigit($sys_firmware_pool_mem))){ $sys_firmware_pool_mem = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$curr_pool_mem:$lpar_curr_io_entitled_mem:$lpar_mapped_io_entitled_mem:$lpar_run_mem:$sys_firmware_pool_mem);
      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  }
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:ams $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_pool_mem

sub load_data_pool {
  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_pool, $no_time, $json_configured, $save_files ) = @_;
  my @lpar_trans       = @{$trans_tmp};
  my $counter          = 0;
  my $counter_tot      = 0;
  my $counter_ins      = 0;
  my $rrd              = "";
  my $rrd_max          = "";
  my $ltime            = 0;
  my $time             = "";
  my $rrd_exist_ok     = 0;
  my $rrd_exist_ok_max = 0;
  my $utime            = time() + 3600;
  my $jump             = 0;
  my $last_time        = "";

  if ( $step > 60 ) {
    $JUMP_DETECT = 10800;    # 3 hours
  }
  if ( $type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000    # 2 days + for daily graphs/feed
  }

  if (defined $json_configured && $json_configured == 1){
    my $perf_string = "pool_conf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.pool"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.pool") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.pool at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) ne "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      my $temp_ts;
      foreach my $timestamp (sort keys %{$content}){
        $temp_ts = $timestamp;
        my $assignedProcCycles = "";
        my $utilizedPoolCycles = "";
        my $borrowedPoolProcUnits = "";
        my $maxProcUnits = "";
        my $reservedPoolCycles = "";
        my $currAvailPoolProcUnits = "";
        my $availableProcUnits = "";

        if (defined $content->{$timestamp}{assignedProcCycles}){$assignedProcCycles = $content->{$timestamp}{assignedProcCycles};}
        else{$assignedProcCycles="U";}
        if (defined $content->{$timestamp}{utilizedPoolCycles}){$utilizedPoolCycles = $content->{$timestamp}{utilizedPoolCycles};}
        else{$utilizedPoolCycles="U";}
        if (defined $content->{$timestamp}{borrowedPoolProcUnits}){$borrowedPoolProcUnits = $content->{$timestamp}{borrowedPoolProcUnits};}
        else{$borrowedPoolProcUnits="U";}
        if (defined $content->{$timestamp}{maxProcUnits}){$maxProcUnits = $content->{$timestamp}{maxProcUnits};}
        else{$maxProcUnits="U";}
        if (defined $content->{$timestamp}{reservedPoolCycles}){$reservedPoolCycles = $content->{$timestamp}{reservedPoolCycles};}
        else{$reservedPoolCycles="U";}
        if (defined $content->{$timestamp}{currAvailPoolProcUnits}){$currAvailPoolProcUnits = $content->{$timestamp}{currAvailPoolProcUnits};}
        else{$currAvailPoolProcUnits="U";}
        if (defined $content->{$timestamp}{availableProcUnits}){$availableProcUnits = $content->{$timestamp}{availableProcUnits};}
        else{$availableProcUnits="U";}
        my $testing_out = "$assignedProcCycles $utilizedPoolCycles $borrowedPoolProcUnits $maxProcUnits $reservedPoolCycles";
        my $ret = substr( $timestamp, 0, 1 ); 
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) ); 
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
          $rrd     = "$wrkdir/$managedname/$host/pool.rr$type_sam"; #m;
          $rrd_max     = "$wrkdir/$managedname/$host/pool.xr$type_sam"; #m;





          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
              my $ret = create_rrd_pool( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                #print "parametry: $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time\n";
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
            if ( $rrd_exist_ok_max == 0 ) {
              my $ret = create_rrd_pool( $rrd_max, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                #print "parametry: $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time\n";
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok_max = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
             rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            $assignedProcCycles = Math::BigInt->new($assignedProcCycles);
            #$borrowedPoolProcUnits = Math::BigInt->new($borrowedPoolProcUnits);
            $utilizedPoolCycles = Math::BigInt->new($utilizedPoolCycles);
            #$maxProcUnits = Math::BigInt->new($maxProcUnits);
            my $maxProcUnits2 = 0;
            if (defined $borrowedPoolProcUnits && $borrowedPoolProcUnits ne ""){
              $maxProcUnits2 += $borrowedPoolProcUnits;
            }
            if (defined $maxProcUnits && $maxProcUnits ne ""){
              $maxProcUnits2 += $maxProcUnits;
            }

#            goo1: 8 = 3 + 5
#            goo2: 5.7
#            -5.7
            #print "goo1: $maxProcUnits2 = $maxProcUnits + $borrowedPoolProcUnits\n";
            #print "goo2: $availableProcUnits\n";
            #print "goo3: $maxProcUnits2 - $availableProcUnits = ". $maxProcUnits2 - $availableProcUnits . "\n";
            if ($availableProcUnits ne "U"){
              $maxProcUnits2 = $maxProcUnits2 - $availableProcUnits;
            }
            #print "updating $rrd from json files\n";
            if (!(main::isdigit($assignedProcCycles))){ $assignedProcCycles = "U"; }
            if (!(main::isdigit($utilizedPoolCycles))){ $utilizedPoolCycles = "U"; }
            if (!(main::isdigit($maxProcUnits2))){ $maxProcUnits2 = "U"; }
            if (!(main::isdigit($availableProcUnits))){ $availableProcUnits = "U"; }
            my $datestring = localtime();
            print "Debug-008-$datestring-$rrd $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits2:$availableProcUnits\n" if $DEBUG_REST_API;
            RRDp::cmd qq(update "$rrd" $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits2:$availableProcUnits);
            $last_time = $timestamp;
            my $answer = RRDp::read;


            print "Debug-008max-$rrd_max $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits2:$availableProcUnits\n" if $DEBUG_REST_API;
            RRDp::cmd qq(update "$rrd_max" $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits2:$availableProcUnits);
            my $answer_max = RRDp::read;


            # update the time of last record
            $ltime = $t;
          } ## end if ( $t > $ltime && length...)
        } #end foreach my $timestamp
        ##unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
        if (defined $file && defined $files[-2] && defined $files[-1]){
          if ($file eq $files[-1]){
            copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/pool_perf1");
          }
          if ($file eq $files[-2]){
            copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/pool_perf2");
          }
        }
        if ($save_files =~ /^-?\d+$/){
          if ($save_files == 0){
            unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
          }
        }
        else{
          if ($save_files ne $managedname){
            unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
          }
        }
        open ($ltiph, ">", "$wrkdir/$managedname/$host/iostat/last_ts.pool");
        print $ltiph "$temp_ts";
        close($ltiph);
      }
    }
  else{
  print "updating RRD   : $host:$managedname:pool:$input_pool-$type_sam\n" if $DEBUG;

  open( FH, "< $input_pool-$type_sam" ) || main::error( " Can't open $input_pool-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  my @lines = reverse <FH>;
  close(FH);
  foreach my $line (@lines) {
    chomp($line);

    if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {

      # something wrong with the input data
      main::error("$host:$managedname : wrong input data in $host:$managedname:data:$input_pool-$type_sam : $line");
      return 1;
    } ## end if ( $line =~ "HSCL" ||...)

    ( $time, my $total_pool_cycles, my $utilized_pool_cyc, my $configurable_pool_proc_units, my $borrowed_pool_proc_units, my $curr_avail_pool_proc_units) = split( /,/, $line );
    if (!defined $total_pool_cycles || $total_pool_cycles eq ""){$total_pool_cycles = "U";}
    if (!defined $utilized_pool_cyc || $utilized_pool_cyc eq ""){$utilized_pool_cyc = "U";}
    if (!defined $configurable_pool_proc_units || $configurable_pool_proc_units eq ""){$configurable_pool_proc_units = "U";}
    if (!defined $borrowed_pool_proc_units || $borrowed_pool_proc_units eq ""){$borrowed_pool_proc_units = "U";}
    if (!defined $curr_avail_pool_proc_units || $curr_avail_pool_proc_units eq ""){$curr_avail_pool_proc_units = "U";}
    # configurable_pool_proc_units: The number of processing units assigned to all shared processor partitions, rounded up to a whole processor.
    # replacing configurable_pool_proc_units with real number (not rounded), since 5.05-15
    if ( defined ($curr_avail_pool_proc_units) && ! $curr_avail_pool_proc_units eq '' ) {
      if ( main::isdigit ($curr_avail_pool_proc_units) && main::isdigit ($borrowed_pool_proc_units) && main::isdigit ($configurable_pool_proc_units)) {
        my $temp = $configurable_pool_proc_units + $borrowed_pool_proc_units - $curr_avail_pool_proc_units;
        $configurable_pool_proc_units = $temp;
        $borrowed_pool_proc_units = $curr_avail_pool_proc_units;
      }
    }

    # Check whether first character is a digit, if not then there is something wrong with the
    # input data
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {

      # leave it as wrong input data
      main::error( "$host:$managedname : No valid cpu data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( $ret =~ /\D/ )
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {

      # leave it as wrong input data
      main::error( "$host:$managedname : No valid cpu data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }

    $rrd     = "$wrkdir/$managedname/$host/pool.rr$type_sam";
    $rrd_max = "$wrkdir/$managedname/$host/pool.xr$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_pool( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    # create pool.xrm (rrdfile with RRA:MAX)
    if ( $rrd_exist_ok_max == 0 ) {
      my $ret_max = create_rrd_pool( $rrd_max, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret_max == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok_max = 1;
    } ## end if ( $rrd_exist_ok_max...)

    # find out last record in the db, do it just once
    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
    } ## end if ( $ltime == 0 )

    # print "last pool : $ltime  actuall: $t\n";
    # it updates only if time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime && length($total_pool_cycles) > 0 ) {

      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;

      $counter_ins++;

      #print "$counter_ins : $time $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units \n";
      $total_pool_cycles = Math::BigInt->new($total_pool_cycles);
      $utilized_pool_cyc = Math::BigInt->new($utilized_pool_cyc);
      my $datestring = localtime();
      print "Debug-009-$datestring-$rrd $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units\n" if $DEBUG_REST_API;
      if (!(main::isdigit($total_pool_cycles))){ $total_pool_cycles = "U"; }
      if (!(main::isdigit($utilized_pool_cyc))){ $utilized_pool_cyc = "U"; }
      if (!(main::isdigit($configurable_pool_proc_units))){ $configurable_pool_proc_units = "U"; }
      if (!(main::isdigit($borrowed_pool_proc_units))){ $borrowed_pool_proc_units = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units);
      $last_time = $time;
      my $answer = RRDp::read;

      # update pool.xrm
      print "Debug-010-$datestring-$rrd_max $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units\n" if $DEBUG_REST_API;
      RRDp::cmd qq(update "$rrd_max" $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units);
      my $answer_max = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  }
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:pool $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_pool

sub load_data_pool_sh {
  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_pool_sh, $SSH, $hmc_user, $pool_tmp, $pool_list_file, $no_time, $json_configured, $save_files ) = @_;
  my @lpar_trans          = @{$trans_tmp};
  my @pool_list           = @{$pool_tmp};
  my $counter             = 0;
  my $counter_tot         = 0;
  my $counter_ins         = 0;
  my $rrd                 = "";
  my $rrd_max             = "";
  my @shared_pool         = "";
  my $max_pool_units      = "";
  my $reserved_pool_units = "";
  my $time                = "";
  my @rrd_exist           = "";
  my $last_rec            = 0;
  my $last_time           = "";
  my $jump                = 0;

  my @pool_name = "";
  my @pool_time = "";
  my @pool_jump = "";

  if ( $step > 60 ) {
    $JUMP_DETECT = 10800;    # 3 hours
  }
  if ( $type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000    # 2 days + for daily graphs/feed
  }

  if ($json_configured == 1){
    print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : $host $managedname updating rrd poolsh\n" if $DEBUG;
    my $perf_string = "poolsh_conf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.poolsh"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.poolsh") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.poolsh at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) ne "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      foreach my $timestamp (sort keys %{$content}){
        foreach my $pool (keys %{$content->{$timestamp}}){
          my $utilizedPoolCycles = "";
          my $assignedProcCycles = "";
          my $borrowedPoolProcUnits = "";
          my $maxProcUnits = "";
          my $reservedPoolCycles="";
          my $id = "";
          my $ltime            = 0;
          my $rrd_exist_ok     = 0;
          my $rrd_exist_ok_max = 0;
          if (defined $content->{$timestamp}{$pool}{assignedProcCycles}){$assignedProcCycles = $content->{$timestamp}{$pool}{assignedProcCycles};}
          else{$assignedProcCycles="U";}
          if (defined $content->{$timestamp}{$pool}{utilizedPoolCycles}){$utilizedPoolCycles = $content->{$timestamp}{$pool}{utilizedPoolCycles};}
          else{$utilizedPoolCycles="U";}
          if (defined $content->{$timestamp}{$pool}{maxProcUnits}){$maxProcUnits = $content->{$timestamp}{$pool}{maxProcUnits};}
          else{$maxProcUnits="U";}
          if (defined $content->{$timestamp}{$pool}{borrowedPoolProcUnits}){$borrowedPoolProcUnits = $content->{$timestamp}{$pool}{borrowedPoolProcUnits};}
          else{$borrowedPoolProcUnits="U";}
          if (defined $content->{$timestamp}{$pool}{reservedPoolCycles}){$reservedPoolCycles = $content->{$timestamp}{$pool}{reservedPoolCycles};}
          else{$reservedPoolCycles=0;}
          if (defined $content->{$timestamp}{$pool}{id}){$id = $content->{$timestamp}{$pool}{id};}
          else{
            error("Missing id of shared pool at ". __FILE__.":".__LINE__);
            next; #shared pool without id is not possible
          }
          my $testing_out = "pool sh test: $id $assignedProcCycles $utilizedPoolCycles $maxProcUnits $borrowedPoolProcUnits";

          my $ret = substr( $timestamp, 0, 1 );
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) ); 
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          my $dirname_tmp = "$wrkdir/$managedname/$host";
          $rrd     = "$wrkdir/$managedname/$host/SharedPool$id.rr$type_sam"; #m;
          $rrd_max     = "$wrkdir/$managedname/$host/SharedPool$id.xr$type_sam"; #m;

          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
              my $ret = create_rrd_pool_shared( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                #print "parametry: $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time\n";
                #next; # muj test???? EDIT
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
            if ( $rrd_exist_ok_max == 0 ) {
              my $ret = create_rrd_pool_shared( $rrd_max, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                #print "parametry: $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time\n";
                #next; # muj test???? EDIT
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok_max = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
             rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            #RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
            if (!defined $reservedPoolCycles || $reservedPoolCycles eq ''){$reservedPoolCycles=0;}
            $utilizedPoolCycles = Math::BigInt->new($utilizedPoolCycles);
            $assignedProcCycles = Math::BigInt->new($assignedProcCycles);
            my $datestring = localtime();
            print "Debug-011-$datestring-$rrd $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits:$reservedPoolCycles\n" if $DEBUG_REST_API;
            if (!(main::isdigit($assignedProcCycles))){ $assignedProcCycles = "U"; }
            if (!(main::isdigit($utilizedPoolCycles))){ $utilizedPoolCycles = "U"; }
            if (!(main::isdigit($maxProcUnits))){ $maxProcUnits = "U"; }
            if (!(main::isdigit($reservedPoolCycles))){ $reservedPoolCycles = "U"; }
            RRDp::cmd qq(update "$rrd" $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits:$reservedPoolCycles);
            #print "1207 probehl update shpool $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits:$reservedPoolCycles\n";
            $last_time = $timestamp;
            my $answer;
            $answer = RRDp::read;
            print "Debug-011max-$rrd_max $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits:$reservedPoolCycles\n" if $DEBUG_REST_API;
            RRDp::cmd qq(update "$rrd_max" $t:$assignedProcCycles:$utilizedPoolCycles:$maxProcUnits:$reservedPoolCycles);
            $answer = RRDp::read;
            #update the time of last record
            $ltime = $t;
          } ## end if ( $t > $ltime && length...)
        }
      }
      if (defined $file && defined $files[-1] && defined $files[-2]){
        if ($file eq $files[-1]){
          copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/poolsh_perf1");
        }
        if ($file eq $files[-2]){
          copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/poolsh_perf2");
        }
      }
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
    }
  }
  else{
  print "updating RRD   : $host:$managedname:pool_sh:$input_pool_sh-$type_sam\n" if $DEBUG;
  # first check whether it supports more CPU pools (POWER6+), if not then return
  open( FH, "< $input_pool_sh-$type_sam" ) || main::error("Cannot open :$input_pool_sh-$type_sam") && return 0;
  while ( my $line = <FH> ) {
    chomp($line);
    if ( $line =~ "No results were found." ) {
      print "info           : $host:$managedname No shared CPU pools\n" if $DEBUG;
      close(FH);
      return 0;
    }
  } ## end while ( my $line = <FH> )
  close(FH);

  print "fetching HMC   : $host:$managedname shared pools\n" if $DEBUG;
  my $def_pool = `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r pool -m \\"$managedname\\" -F configurable_pool_proc_units,borrowed_pool_proc_units  --filter \"event_types=sample\""`;
  if ( !defined($def_pool) || $def_pool eq '' ) {
    print "info           : $host:$managedname Probably no shared CPU pools are supported or configured\n" if $DEBUG;
    return 0;
  }
  my $ret1 = substr( $def_pool, 0, 1 );
  if ( $ret1 =~ /\D/ ) {

    # leave it, it does not contain a digit, probably is there "No results were found"
    print "info           : $host:$managedname Probably no shared CPU pools are supported or configured\n" if $DEBUG;
    return 0;
  } ## end if ( $ret1 =~ /\D/ )
  my @def_pool_list = split( /,/, $def_pool );
  my $max_def_pool = $def_pool_list[0] + $def_pool_list[1];

  #print "Default pool : $max_def_pool $def_pool_list[0] $def_pool_list[1] \n";
  print "fetching HMC   : $host:$managedname shared pool list\n" if $DEBUG;
  @pool_list = `$SSH $hmc_user\@$host "export LANG=en_US; lshwres -r procpool  -m \\"$managedname\\" -F shared_proc_pool_id,max_pool_proc_units,curr_reserved_pool_proc_units,name"`;
  my @pool_list_no_gap = "";
  my $pool_indx        = 0;

  # create mapping table between pool id and alias name
  open( FP, "> $wrkdir/$managedname/$host/cpu-pools-mapping.txt" ) || main::error("Cannot open : $wrkdir/$managedname/cpu-pools-mapping.txt : $!");
  foreach my $pool (@pool_list) {
    if ( $pool =~ "HSCL" || $pool =~ "VIOSE0" ) {

      # something wrong with the input data
      main::error("$host:$managedname : wrong input data in $wrkdir/$managedname/$host/cpu-pools-mapping.txt : $pool");
      return 1;
    } ## end if ( $pool =~ "HSCL" ||...)

    if ( length($pool) > 1 ) {
      my @shared_p = split( /,/, $pool );

      # if there is not a digit than the server probably does not support shared CPU pools
      if ( $shared_p[0] =~ /\d/ ) {
        my $name = $shared_p[3];
        my $id   = $shared_p[0];
        if ( $id =~ "HSCL" || $name =~ "HSCL" ) {
          next;
        }

        # lshwres avoid pools with no reserved CPU cores --> means they cannot be used what causes the gap
        # and brings problems in further processing
        while ( $id > $pool_indx ) {
          $pool_list_no_gap[$pool_indx] = "$pool_indx,0,0,SharedPool$pool_indx";
          print FP "$pool_indx,SharedPool$pool_indx\n";
          $pool_indx++;
        }
        $pool_list_no_gap[$pool_indx] = $pool;
        $pool_indx++;
        print FP "$id,$name";

        #print "$id,$name";
      } ## end if ( $shared_p[0] =~ /\d/)
    } ## end if ( length($pool) > 1)
  } ## end foreach my $pool (@pool_list)
  close(FP);

  my $do_pool_agg = 0;
  open( FH, "< $input_pool_sh-$type_sam" ) || main::error("Cannot open input pool sh : $input_pool_sh-$type_sam : $!") && return 0;
  my @lines = reverse <FH>;
  close(FH);

  foreach my $line (@lines) {
    chomp($line);

    ( $time, my $shared_proc_pool_id, my $total_pool_cycles, my $utilized_pool_cyc ) = split( /,/, $line );

    if ( defined($shared_proc_pool_id) && !$shared_proc_pool_id eq '' && main::isdigit($shared_proc_pool_id) && $shared_proc_pool_id > 0 && $do_pool_agg == 0 ) {

      # get pools list for pool aggregated charts
      `$SSH $hmc_user\@$host "lshwres -r procpool -m \\"$managedname\\" -F shared_proc_pool_id,lpar_names" > "$wrkdir/$managedname/$host/$pool_list_file"`;
      $do_pool_agg = 1;
    } ## end if ( defined($shared_proc_pool_id...))

    #if ($shared_proc_pool_id > 0 ) {
    #   $do_pool_agg=1;
    # }

    # Check whether first character is a digit, if not then there is something wrong with the
    # input data
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {

      # leave it as wrong input data
      print "info           : $host:$managedname Probably no shared CPU pools are supported or configured\n" if $DEBUG;
      close(FH);
      return 0;
    } ## end if ( $ret =~ /\D/ )

    # only for shared pools, not for default pool (id=0)
    #if ( $shared_proc_pool_id) {
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {

      # leave it as wrong input data
      main::error( "$host:$managedname : No valid shared cpu pool data time format got from HMC : $t : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }

    $rrd     = "$wrkdir/$managedname/$host/SharedPool$shared_proc_pool_id.rr$type_sam";
    $rrd_max = "$wrkdir/$managedname/$host/SharedPool$shared_proc_pool_id.xr$type_sam";

    #create rrd db if necessary
    # find out if rrd db exist, and place info to the array to do not check its existency every time
    my $rrd_exist_ok     = 0;
    my $rrd_exist_ok_max = 0;
    my $rrd_exist_row    = 0;
    foreach my $row (@rrd_exist) {
      $rrd_exist_row++;
      if ( $row =~ m/^$shared_proc_pool_id$/ ) {    # from some reason must be string comparsion
        $rrd_exist_ok = 1;
        last;
      }
    } ## end foreach my $row (@rrd_exist)
    if ( $rrd_exist_ok == 0 ) {
      $rrd_exist[$rrd_exist_row] = $shared_proc_pool_id;
      my $ret = create_rrd_pool_shared( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;                                   # RRD creation problem, skip whole load
      }
    } ## end if ( $rrd_exist_ok == ...)

    # create .xrm
    if ( $rrd_exist_ok_max == 0 ) {
      my $ret_max = create_rrd_pool_shared( $rrd_max, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret_max == 2 ) {
        return 1;                                   # RRD creation problem, skip whole load
      }
    } ## end if ( $rrd_exist_ok_max...)

    # found out last record and save it
    # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
    my $l_count = 0;
    my $found   = -1;
    my $ltime;
    my $pool_meta = quotemeta($shared_proc_pool_id);
    foreach my $l (@pool_name) {
      if ( $l =~ m/^$pool_meta$/ ) {
        $found = $l_count;
        last;
      }
      $l_count++;
    } ## end foreach my $l (@pool_name)
    if ( $found > -1 ) {
      $ltime   = $pool_time[$found];
      $l_count = $found;
    }
    else {
      # find out last record in the db

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        if ( $rrd_exist[$rrd_exist_row] =~ m/^$shared_proc_pool_id$/ ) {
          $rrd_exist[$rrd_exist_row] = "";
        }
        next;
      } ## end if ($@)
      chomp($$last_rec);
      $pool_name[$l_count] = $shared_proc_pool_id;
      $pool_time[$l_count] = $$last_rec;
      $pool_jump[$l_count] = 0;
      $ltime               = $$last_rec;
    } ## end else [ if ( $found > -1 ) ]

    # print "last pool : $$last_rec  actuall: $t\n";
    # it updates only if time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $pool_time[$l_count] && length($total_pool_cycles) > 0 ) {
      if ($shared_proc_pool_id) {
        @shared_pool         = split( /,/, $pool_list_no_gap[$shared_proc_pool_id] );
        $max_pool_units      = $shared_pool[1];
        $reserved_pool_units = $shared_pool[2];
      }
      else {
        $max_pool_units      = $max_def_pool;
        $reserved_pool_units = $max_def_pool;
      }

      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $pool_jump[$l_count] == 0 ) {
          $pool_jump[$l_count] = 1;
          if ( $shared_proc_pool_id > 0 ) {

            # do not print out that message for SharedPool0 it probably does not exist if there are no shared pools defined
            #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
            #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          } ## end if ( $shared_proc_pool_id...)
          next;
        } ## end if ( $pool_jump[$l_count...])

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $pool_jump[$l_count] = 0;

      #print "$time $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units \n";
      if ( !$max_pool_units eq '' && !$reserved_pool_units eq '' ) {

        # can happen in certain circumstance that the last pool is deleted but then cannot be
        # found $max_pool_units and $reserved_pool_units
        $total_pool_cycles = Math::BigInt->new($total_pool_cycles);
        $utilized_pool_cyc = Math::BigInt->new($utilized_pool_cyc);
        my $datestring = localtime();
        print "Debug-012-$datestring-$rrd $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units\n" if $DEBUG_REST_API;
        if (!(main::isdigit($total_pool_cycles))){ $total_pool_cycles = "U"; }
        if (!(main::isdigit($utilized_pool_cyc))){ $utilized_pool_cyc = "U"; }
        if (!(main::isdigit($max_pool_units))){ $max_pool_units = "U"; }
        if (!(main::isdigit($reserved_pool_units))){ $reserved_pool_units = "U"; }
        RRDp::cmd qq(update "$rrd" $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units);
        $counter_ins++;
        $last_time = $time;
        my $answer = RRDp::read;

        print "Debug-012max-$rrd_max $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units\n" if $DEBUG_REST_API;
        RRDp::cmd qq(update "$rrd_max" $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units);
        my $answer_max = RRDp::read;

        $pool_time[$l_count] = $t;
      } ## end if ( !$max_pool_units ...)
    } ## end if ( $t > $pool_time[$l_count...])

    #}
  } ## end foreach my $line (@lines)
  }
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:pool_sh $counter_ins record(s)\n" if $DEBUG;
  }

  # moved to lpar2rrd.pl, a problem with yearly graphs
  #if ($do_pool_agg == 1) {
  # there are more CPU pools, will be created aggregated chart for each pool
  # download data now (list of lpars)
  #main::procpoolagg($host,$managedname);
  #}

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_pool_sh

sub load_data_mem {
  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_mem, $no_time, $json_configured, $save_files ) = @_;
  my @lpar_trans   = @{$trans_tmp};
  my $counter      = 0;
  my $counter_tot  = 0;
  my $counter_ins  = 0;
  my $rrd          = "";
  my $ltime        = 0;
  my $time         = "";
  my $rrd_exist_ok = 0;
  my $jump         = 0;
  my $last_time    = "";

  if ( $step > 60 ) {
    $JUMP_DETECT = 10800;    # 3 hours
  }
  if ( $type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000    # 2 days + for daily graphs/feed
  }

  if ($json_configured == 1){
    my $perf_string = "mem_conf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $wrkdir/$managedname/$host/iostat/ " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    my $last_ts_file = "$wrkdir/$managedname/$host/iostat/last_ts.mem";
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.mem"){
      open ($ltiph, "<", $last_ts_file) || main::error( "Cannot open file $last_ts_file at ".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) ne "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      foreach my $timestamp (sort keys %{$content}){
        if ($timestamp eq $saved_ts){next;}
        $temp_ts = $timestamp;
        my $availableMem = "";
        my $assignedMemToFirmware = "";
        my $configurableMem="";

        if (defined $content->{$timestamp}{availableMem}){$availableMem = $content->{$timestamp}{availableMem};}
        else{$availableMem="U";}
        if (defined $content->{$timestamp}{assignedMemToFirmware}){$assignedMemToFirmware = $content->{$timestamp}{assignedMemToFirmware};}
        else{$assignedMemToFirmware="U";}
        if (defined $content->{$timestamp}{configurableMem}){$configurableMem = $content->{$timestamp}{configurableMem};}
        else{$configurableMem="U";}
        my $testing_out = "mem test: $availableMem $assignedMemToFirmware $configurableMem\n";
        my $ret = substr( $timestamp, 0, 1 );
        if ( $ret =~ /\D/ ) {
          # leave it as wrong input data
          main::error( "$host:$managedname : No valid memory data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
          next;
        } ## end if ( $ret =~ /\D/ )
        my $t = str2time( substr( $timestamp, 0, 19 ) );
        if ( length($t) < 10 ) {
          # leave it as wrong input data
          main::error( "$host:$managedname : No valid memory data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
          next;
        } ## end if ( length($t) < 10 )
        if ( $step == 3600 ) {
          # Put on the last time possition "00"!!!
          substr( $t, 8, 2, "00" );
        }
        $rrd     = "$wrkdir/$managedname/$host/mem.rr$type_sam"; #m;

        #create rrd db if necessary
        if (!(-e $rrd)){
          if ( $rrd_exist_ok == 0 ) {
            my $ret = create_rrd_mem( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
            #my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time, "", "", $wrkdir, $lpar, $t, $keep_virtual );
            if ( $ret == 2 ) {
              #print "parametry: $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time\n";
              next; # muj test????
              #return 1;    # RRD creation problem, skip whole load
            }
            $rrd_exist_ok = 1; 
          }## end if ( $rrd_exist_ok == ...)
        } #end if (!(-e $rrd))
        if ( $ltime == 0 ) {

          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
            RRDp::cmd qq(last "$rrd" );
            $last_rec = RRDp::read;
          };
          if ($@) {
            #RRDp::error_mode = "catch";
           rrd_error( $@, $rrd );
            $rrd_exist_ok = 0;
            next;
          }
          chomp($$last_rec);
          $ltime = $$last_rec;
        } ## end if ( $ltime == 0 )

        # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
          if ( $t > $jump_time ) {

            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            if ( $jump == 0 ) {
              $jump = 1;
              #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
              #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
              next;
            } ## end if ( $jump == 0 )
            # looks like it is ok as it is second timestap in a row
          } ## end if ( $t > $jump_time )
          $jump = 0;
          $counter_ins++;
          #print "updating $rrd from json files\n";
          my $datestring = localtime();
          print "Debug-013-$datestring-$rrd $t:$availableMem:$configurableMem:$assignedMemToFirmware\n" if $DEBUG_REST_API;
          if (!(main::isdigit($availableMem))){ $availableMem = "U"; }
          if (!(main::isdigit($configurableMem))){ $configurableMem = "U"; }
          if (!(main::isdigit($assignedMemToFirmware))){ $assignedMemToFirmware = "U"; }
          RRDp::cmd qq(update "$rrd" $t:$availableMem:$configurableMem:$assignedMemToFirmware);
          $last_time = $timestamp;
          my $answer = RRDp::read;
          # update the time of last record
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      } #end foreach my $timestamp
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
    }
  }
  else{
  print "updating RRD   : $host:$managedname:mem:$input_mem-$type_sam\n" if $DEBUG;
  open( FH, "< $input_mem-$type_sam" ) || main::error( " Can't open $input-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  my @lines = reverse <FH>;
  close(FH);

  foreach my $line (@lines) {
    chomp($line);

    if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {

      # something wrong with the input data
      # do not alert for memory, this causing problems and logs a lot of errors but it is minor feature ...
      main::error("$host:$managedname : wrong input data in $host:$managedname:data:$input_mem-$type_sam : $line");
      return 1;
    } ## end if ( $line =~ "HSCL" ||...)

    ( $time, my $curr_avail_sys_mem, my $configurable_sys_mem, my $sys_firmware_mem ) = split( /,/, $line );

    if ( $curr_avail_sys_mem eq '' || $configurable_sys_mem eq '' || $sys_firmware_mem eq '' ) {

      # problem with data
      #main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_mem-$type_sam : $line");
      next;
    } ## end if ( $curr_avail_sys_mem...)

    # Check whether first character is a digit, if not then there is something wrong with the
    # input data
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {
      main::error( "$host:$managedname : No valid mem data got from HMC : $ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    }
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }

    $rrd = "$wrkdir/$managedname/$host/mem.rr$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_mem( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    # find out last record in the db
    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
    } ## end if ( $ltime == 0 )

    # print "last mem  : $ltime actuall: $t\n";
    # it updates only if time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime && length($curr_avail_sys_mem) > 0 ) {

      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;

      $counter_ins++;

      #print "++ 01 $time $t:$curr_avail_sys_mem \n";
      my $datestring = localtime();
      print "Debug-014-$datestring-$rrd $t:$curr_avail_sys_mem:$configurable_sys_mem:$sys_firmware_mem\n" if $DEBUG_REST_API;
      if (!(main::isdigit($curr_avail_sys_mem))){ $curr_avail_sys_mem = "U"; }
      if (!(main::isdigit($configurable_sys_mem))){ $configurable_sys_mem = "U"; }
      if (!(main::isdigit($sys_firmware_mem))){ $sys_firmware_mem = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$curr_avail_sys_mem:$configurable_sys_mem:$sys_firmware_mem);
      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  }
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:mem $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_mem

sub load_data_cod {
  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_cod, $no_time ) = @_;
  my @lpar_trans               = @{$trans_tmp};
  my $counter                  = 0;
  my $counter_tot              = 0;
  my $counter_ins              = 0;
  my $rrd                      = "";
  my $ltime                    = 0;
  my $time                     = "";
  my $rrd_exist_ok             = 0;
  my $jump                     = 0;
  my $last_time                = "";
  my $unreported_proc_min_last = 0;

  if ( $step > 60 ) {
    $JUMP_DETECT = 10800;    # 3 hours
  }
  if ( $type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000    # 2 days + for daily graphs/feed
  }

  if ( !-f "$input_cod-$type_sam" ) {
    print "CoD data load  : $host:$managedname:CoD:$input_cod-$type_sam - no input file found\n" if $DEBUG;
    return 1;
  }

  print "updating RRD   : $host:$managedname:CoD:$input_cod-$type_sam\n" if $DEBUG;
  open( FH, "< $input_cod-$type_sam" ) || main::error( " Can't open $input_cod-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  my @lines = reverse <FH>;
  close(FH);

  foreach my $line (@lines) {
    chomp($line);

    if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {

      # something wrong with the input data
      # do not alert for memory, this causing problems and logs a lot of errors but it is minor feature ...
      #main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_mem-$type_sam : $line");
      return 1;
    } ## end if ( $line =~ "HSCL" ||...)

    ( $time, my $used_proc_min, my $unreported_proc_min ) = split( /,/, $line );

    if ( !defined($used_proc_min) || !defined($unreported_proc_min) || $used_proc_min eq '' || $unreported_proc_min eq '' ) {

      # problem with data
      # main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_cod-$type_sam : $line");
      # ignore it quietly, old HMC v6 does not support Co
      next;
    } ## end if ( !defined($used_proc_min...))

    # Check whether first character is a digit, if not then there is something wrong with the
    # input data
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {
      main::error( "$host:$managedname : No valid cod data got from HMC : $ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    }
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }

    $rrd = "$wrkdir/$managedname/$host/cod.rr$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      if ( !-f "$rrd" ) {

        # check if it is realy first run or just first run for that input file
        $ltime = -1;
      }
      my $ret = create_rrd_cod( $rrd, $t - 60, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    # find out last record in the db
    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;

      # find out last value of unreported_proc_min
      my $l = localtime($$last_rec);

      # get LAST value from RRD
      #RRDp::cmd qq(fetch "$rrd" "MAX" "-s $$last_rec-$step" "-e $$last_rec-$step");
      RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_rec-$step" "-e $$last_rec-$step");
      my $row = RRDp::read;
      chomp($$row);
      my @row_arr = split( /\n/, $$row );
      my $m       = "";
      my $i       = 0;
      foreach $m (@row_arr) {
        chomp($m);
        $i++;
        if ( $i == 3 ) {
          my @m_arr = split( / /, $m );

          # go further ony if it is a digit (avoid it when NaNQ (== no data) is there)
          if ( $m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ ) {

            #print "m : $m\n" if $DEBUG ;
            #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;
            $unreported_proc_min_last = sprintf( "%d", $m_arr[2] );
          } ## end if ( $m_arr[1] =~ /\d/...)
        } ## end if ( $i == 3 )
      } ## end foreach $m (@row_arr)

      #print "001 $ltime -----  $l : $$last_rec : $$row : $time $unreported_proc_min_last \n";
    } ## end if ( $ltime == 0 )

    #print "002 $ltime -----  $time $unreported_proc_min_last \n";

    # print "last cod  : $ltime actuall: $t\n";
    # it updates only if time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime && length($used_proc_min) > 0 ) {

      # Do not use that for CoD, it is pretty normal here!!!
      #my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
      #if ( $t > $jump_time ) {
      #
      # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
      # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
      #if ( $jump == 0 ) {
      #  $jump = 1;
      #  main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
      #  main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
      #  next;
      #}
      # looks like it is ok as it is second timestap in a row
      #}
      #$jump = 0;

      # there has to be filled in data gaps
      #print "003 $time $t:$used_proc_min:$unreported_proc_min \n";
      while ( $t > ( $ltime + 60 ) ) {
        if ( $ltime == -1 ) {

          # initial CoD load with creation of rrd, skip it this time
          last;
        }
        $ltime = $ltime + 60;

        #print "004 $ltime:0:$unreported_proc_min_last  --- $t\n";
        RRDp::cmd qq(update "$rrd" $ltime:0:$unreported_proc_min_last);
        my $answer = RRDp::read;
      } ## end while ( $t > ( $ltime + 60...))

      $counter_ins++;
      RRDp::cmd qq(update "$rrd" $t:$used_proc_min:$unreported_proc_min);
      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime                    = $t;
      $unreported_proc_min_last = $unreported_proc_min;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:cod $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_cod

### SAME FUNCTION I HAVE TO USE TO LOAD DADA FROM JSONS ###########################

sub load_data_sriov{
  my $time = "";
  my $counter          = 0;
  my $counter_tot      = 0;
  my $counter_ins      = 0;
  my $rrd              = "";
  my $rrd_max          = "";
  my $utime            = time() + 3600;
  my $jump             = 0;
  my $last_time        = "";

  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_sriov, $no_time, $json_configured, $save_files ) = @_;
  if ($json_configured eq "1"){
    my $perf_string = "sriov_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.sriov"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.sriov") || main::error(  "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.sriov at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || $content eq "0" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      foreach my $sample (@{$content}){
        my $ts = $sample->[0];
        my $vios = $sample->[1];
        my $physicalLocation = $sample->[2];
        my $configurationType = $sample->[3];
        my $drcIndex = $sample->[4];
        my $droppedReceivedPackets = $sample->[5];
        my $droppedSentPackets = $sample->[6];
        my $errorIn = $sample->[7];
        my $errorOut = $sample->[8];
        my $physicalDrcIndex = $sample->[9];
        my $physicalPortId = $sample->[10];
        my $read = $sample->[11];
        my $io_read = $sample->[12];
        my $write = $sample->[13];
        my $io_write = $sample->[14];
        my $vnicDeviceMode = $sample->[14];
        my $t = str2time( substr( $ts, 0, 19 ) );

        (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
        $rrd = "$wrkdir/$managedname/$host/adapters/$short_physloc.rasr$type_sam";

        if (!-e ($rrd)){
          my $ret = create_rrd_sriov( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
          if ( $ret == 2 ) {
            next;
          }
        }
        my $last_rec;
        eval {
          RRDp::cmd qq(last "$rrd");
          $last_rec = RRDp::read;
        };
        if ($@) {
          rrd_error( $@, $rrd );
          next;
        }
        chomp($$last_rec);
        my $ltime = $$last_rec;
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          if (!(main::isdigit($read))){ $read = "U"; }
          if (!(main::isdigit($io_read))){ $io_read = "U"; }
          if (!(main::isdigit($io_write))){ $io_write = "U"; }
          if (!(main::isdigit($write))){ $write = "U"; }
          if (!(main::isdigit($droppedReceivedPackets))){ $droppedReceivedPackets = "U"; }
          if (!(main::isdigit($droppedSentPackets))){ $droppedSentPackets = "U"; }
          if (!(main::isdigit($errorIn))){ $errorIn = "U"; }
          if (!(main::isdigit($errorOut))){ $errorOut = "U"; }
          #print "updating $rrd from jsons\n";
          RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$droppedReceivedPackets:$droppedSentPackets:$errorIn:$errorOut);

          $last_time = $ts;
          my $answer = RRDp::read;
          # update the time of last record
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      }
      #$reversed_sriov->{$ts}{$lpar}{$physLoc}{configurationType} = $configurationType;
=cut
      foreach my $timestamp (sort keys %{$content}){
        foreach my $lpar (sort keys %{$content->{$timestamp}}){
          foreach my $physLoc (keys %{$content->{$timestamp}{$lpar}}){
          my $ltime            = 0;
          my $rrd_exist_ok     = 0;
          my $rrd_exist_ok_max = 0;
          my ($configurationType,$drcIndex,$droppedReceivedPackets,$droppedSentPackets,$errorIn,$errorOut,$physicalDrcIndex,$physicalPortId,$read ,$io_read,$write,$io_write,$vnicDeviceMode);
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{configurationType}){$configurationType = $content->{$timestamp}{$lpar}{$physLoc}{configurationType};}
          else {$configurationType = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{drcIndex}){$drcIndex = $content->{$timestamp}{$lpar}{$physLoc}{drcIndex};}
          else {$drcIndex = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{droppedReceivedPackets}){$droppedReceivedPackets = $content->{$timestamp}{$lpar}{$physLoc}{droppedReceivedPackets};}
          else {$droppedReceivedPackets = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{droppedSentPackets}){$droppedSentPackets = $content->{$timestamp}{$lpar}{$physLoc}{droppedSentPackets};}
          else {$droppedSentPackets = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{errorIn}){$errorIn = $content->{$timestamp}{$lpar}{$physLoc}{errorIn};}
          else {$errorIn = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{errorOut}){$errorOut = $content->{$timestamp}{$lpar}{$physLoc}{errorOut};}
          else {$errorOut = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{physicalDrcIndex}){$physicalDrcIndex = $content->{$timestamp}{$lpar}{$physLoc}{physicalDrcIndex};}
          else {$physicalDrcIndex = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{physicalPortId}){$physicalPortId = $content->{$timestamp}{$lpar}{$physLoc}{physicalPortId};}
          else {$physicalPortId = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{receivedBytes}){$read = $content->{$timestamp}{$lpar}{$physLoc}{receivedBytes};}
          else {$read = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{receivedPackets}){$io_read = $content->{$timestamp}{$lpar}{$physLoc}{receivedPackets};}
          else {$io_read = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{sentBytes}){$write = $content->{$timestamp}{$lpar}{$physLoc}{sentBytes};}
          else {$write = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{sentBytes}){$io_write = $content->{$timestamp}{$lpar}{$physLoc}{sentPackets};}
          else {$io_write = "U";}
          if (defined $content->{$timestamp}{$lpar}{$physLoc}{vnicDeviceMode}){$vnicDeviceMode = $content->{$timestamp}{$lpar}{$physLoc}{vnicDeviceMode};}
          else {$vnicDeviceMode = "U";}
          my $testing_out = "$lpar $physLoc $configurationType $drcIndex $droppedReceivedPackets $droppedSentPackets $errorIn $errorOut $physicalDrcIndex $physicalPortId, $read $io_read $write $io_write  $vnicDeviceMode\n";
        my $ret = substr( $timestamp, 0, 1 );
        if ( $ret =~ /\D/ ) {
          # leave it as wrong input data
          main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
          next;
        } ## end if ( $ret =~ /\D/ )
        my $t = str2time( substr( $timestamp, 0, 19 ) );
        if ( length($t) < 10 ) {
          # leave it as wrong input data
          main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
          next;
        } ## end if ( length($t) < 10 )
        if ( $step == 3600 ) {
          # Put on the last time possition "00"!!!
          substr( $t, 8, 2, "00" );
        }
        my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
        (undef,undef,my $short_physloc) = split ('\\.', $physLoc);
        $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.rasr$type_sam"; #m;
        if (!(-e $rrd)){
          if ( $rrd_exist_ok == 0 ) {
            my $ret = create_rrd_sriov2( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
            if ( $ret == 2 ) {
              #print "parametry: $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time\n";
              next; # muj test????
              #return 1;    # RRD creation problem, skip whole load
            }
            $rrd_exist_ok = 1;
          }## end if ( $rrd_exist_ok == ...)
        } #end if (!(-e $rrd))
        if ( $ltime == 0 ) {

          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
         # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
            RRDp::cmd qq(last "$rrd" );
            $last_rec = RRDp::read;
          };
          if ($@) {
           #RRDp::error_mode = "catch";
            rrd_error( $@, $rrd );
            $rrd_exist_ok = 0;
            next;
          }
          chomp($$last_rec);
          $ltime = $$last_rec;
        } ## end if ( $ltime == 0 )
        # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
          if ( $t > $jump_time ) {

            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            if ( $jump == 0 ) {
              $jump = 1; 
              #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
              #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
              next;
            } ## end if ( $jump == 0 )
            # looks like it is ok as it is second timestap in a row
          } ## end if ( $t > $jump_time )
          $jump = 0;
          $counter_ins++;
          #RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
          if (!(main::isdigit($read))){ $read = "U"; }
          if (!(main::isdigit($io_read))){ $io_read = "U"; }
          if (!(main::isdigit($io_write))){ $io_write = "U"; }
          if (!(main::isdigit($write))){ $write = "U"; }
          if (!(main::isdigit($droppedReceivedPackets))){ $droppedReceivedPackets = "U"; }
          if (!(main::isdigit($droppedSentPackets))){ $droppedSentPackets = "U"; }
          if (!(main::isdigit($errorIn))){ $errorIn = "U"; }
          if (!(main::isdigit($errorOut))){ $errorOut = "U"; }
          #print "updating $rrd from jsons\n";
          RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$droppedReceivedPackets:$droppedSentPackets:$errorIn:$errorOut);

          $last_time = $timestamp;
          my $answer = RRDp::read;
          # update the time of last record
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      } ##end foreach my physloc
    } ## end foreach my lpar
    } ## end foreach my timestamp
=cut

  if ($save_files =~ /^-?\d+$/){
    if ($save_files == 0){
      unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
    }
  }
  }
  }
  else{
    if (-e "$input_sriov-$type_sam"){
      open (FH, "< $input_sriov-$type_sam") || main::error( " Can't open $input_sriov-$type_sam : $!" . __FILE__ . ":" . __LINE__ );
    }
    else{
      #main::error( " File doesn't exist $input_sriov-$type_sam : $! " . __FILE__ . ":" . __LINE__ );
      return 1;
    }
    my @lines = <FH>;
    close(FH);
    foreach my $line (@lines) {
      my $ltime            = 0;
      my $rrd_exist_ok     = 0;
      my $rrd_exist_ok_max     = 0;
      chomp($line);
      ($time, my $lpar, my $physicalLocation, my $confType, my $drcIndex, my $droppedReceivedPackets, my $droppedSentPackets, my $errorIn, my $errorOut, my $physicalDrcIndex, my $physicalPortId,my $read, my $io_read, my $write, my $io_write , my $vnicDeviceMode) = split( /,/, $line );
      my $ret = substr( $time, 0, 1 );
      if ( $ret =~ /\D/ ) {
        # leave it as wrong input data
        main::error( "$host:$managedname : No valid sriov data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
        next;
      } ## end if ( $ret =~ /\D/ )
      my $t = str2time( substr( $time, 0, 19 ) );
      if ( length($t) < 10 ) {
        # leave it as wrong input data
        main::error( "$host:$managedname : No valid sriov data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
        next;
      } ## end if ( length($t) < 10 )
      if ( $step == 3600 ) {

        # Put on the last time possition "00"!!!
        substr( $t, 8, 2, "00" );
      }
      my $dirname_tmp = "$wrkdir/$managedname/$host/adapters/";
      (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
      $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.rasr$type_sam";

      #create rrd db if necessary
      if (!(-e $rrd)){
      if ( $rrd_exist_ok == 0 ) {
        my $ret = create_rrd_sriov2( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
        if ( $ret == 2 ) {
          return 1;    # RRD creation problem, skip whole load
        }
        $rrd_exist_ok = 1;
      } ## end if ( $rrd_exist_ok == ...)
      }

      if ( $ltime == 0 ) {

        # construction against crashing daemon Perl code when RRDTool error appears
        # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
        # construction is not too costly as it runs once per each load
        my $last_rec = 0;
        eval {
          RRDp::cmd qq(last "$rrd" );
          $last_rec = RRDp::read;
        };
        if ($@) {
          rrd_error( $@, $rrd );
          $rrd_exist_ok = 0;
          next;
        }
        chomp($$last_rec);
        $ltime = $$last_rec;
      } ## end if ( $ltime == 0 )

      # print "last sriov : $ltime  actuall: $t\n";
      # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
      if ( $t > $ltime ) { #&& length($vios_name) > 0 )
        my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
        if ( $t > $jump_time ) {

          # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
          # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
          if ( $jump == 0 ) {
            $jump = 1;

            #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
            #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
            next;
          } ## end if ( $jump == 0 )

          # looks like it is ok as it is second timestap in a row
        } ## end if ( $t > $jump_time )
        $jump = 0;
        $counter_ins++;

        #print "$counter_ins : $time $t:$promenne \n"    if (!(main::isdigit($read))){ $read = "U"; }
        if (!(main::isdigit($io_read))){ $io_read = "U"; }
        if (!(main::isdigit($io_write))){ $io_write = "U"; }
        if (!(main::isdigit($write))){ $write = "U"; }
        if (!(main::isdigit($read))){ $read = "U"; }
        if (!(main::isdigit($droppedReceivedPackets))){ $droppedReceivedPackets = "U"; }
        if (!(main::isdigit($droppedSentPackets))){ $droppedSentPackets = "U"; }
        if (!(main::isdigit($errorIn))){ $errorIn = "U"; }
        if (!(main::isdigit($errorOut))){ $errorOut = "U"; }
        RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$droppedReceivedPackets:$droppedSentPackets:$errorIn:$errorOut);
        $last_time = $time;
        my $answer = RRDp::read;

        # update the time of last record
        $ltime = $t;
      } ## end if ( $t > $ltime && length...)
    } ## end foreach my $line (@lines)
  } ##end else (if $jsonconfigured)

  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:sriov $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} # end sub load_data_sriov

sub load_data_lan{
  my $time = "";
  my $counter          = 0;
  my $counter_tot      = 0;
  my $counter_ins      = 0;
  my $rrd              = "";
  my $rrd_max          = "";
  my $utime            = time() + 3600;
  my $jump             = 0;
  my $last_time        = "";

  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp,$last_file,$input_adapters,$no_time, $json_configured,$save_files) = @_;
  if ($json_configured eq "1"){
    my $perf_string = "lan_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    ##001 PUVODNI CAST KODU ##
    ##open (FH, "< $input_file-$type_sam") || main::error( " Can't open $input_file-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    ##my @lines = reverse <FH>;
    ##close(FH);
    ## END 001###

    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.lan"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.lan") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.lan at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      foreach my $sample (@{$content}){
        (my $ts, my $vios_name, my $adapter_id, my $physicalLocation, my $type, my $io_read, my $io_write, my $read, my $write, my $dropped_packets) = ("U","U","U","U","U","U","U","U","U","U");
        $ts = $sample->[0];
        $vios_name = $sample->[1];
        $adapter_id = $sample->[2];
        $type = $sample->[3];
        $dropped_packets = $sample->[4];
        $io_write = $sample->[5];
        $io_read = $sample->[6];
        $write = $sample->[7];
        $read = $sample->[8];
        $physicalLocation = $sample->[9];
        my $t = str2time( substr( $ts, 0, 19 ) );

        (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
        $rrd = "$wrkdir/$managedname/$host/adapters/$short_physloc.ral$type_sam";

        if (!-e ($rrd)){
          my $ret = create_rrd_lan( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
          if ( $ret == 2 ) {
            next;
          }
        }
        my $last_rec;
        eval {
          RRDp::cmd qq(last "$rrd" );
          $last_rec = RRDp::read;
        };
        if ($@) {
          rrd_error( $@, $rrd );
          next;
        }
        chomp($$last_rec);
        my $ltime = $$last_rec;
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          if (!(main::isdigit($io_read))){ $io_read = "U"; }
          if (!(main::isdigit($read))){ $read = "U"; }
          if (!(main::isdigit($io_write))){ $io_write = "U"; }
          if (!(main::isdigit($write))){ $write = "U"; }
          if (!(main::isdigit($dropped_packets))){ $dropped_packets = "U"; }
          RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$dropped_packets);
          $last_time = $ts;
          my $answer = RRDp::read;
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      }
=cut
      foreach my $timestamp (sort keys %{$content}){
        if ($timestamp eq $saved_ts){next;}
        $temp_ts = $timestamp;
        foreach my $vios_name (keys %{$content->{$timestamp}}){
          foreach my $id (keys %{$content->{$timestamp}{$vios_name}}){
          my $physicalLocation = "";
          my $read = "0";
          my $io_read = "0";
          my $write = "0";
          my $io_write = "0";
          my $dropped_packets = "0";
          my $type = "";

          my $ltime            = 0;
          my $rrd_exist_ok     = 0;
          my $rrd_exist_ok_max = 0;
          if (defined $content->{$timestamp}{$vios_name}{$id}{physicalLocation}){$physicalLocation=$content->{$timestamp}{$vios_name}{$id}{physicalLocation};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{receivedBytesG}){$read=$content->{$timestamp}{$vios_name}{$id}{receivedBytesG};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{receivedPacketsG}){$io_read=$content->{$timestamp}{$vios_name}{$id}{receivedPacketsG};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{sentBytesG}){$write=$content->{$timestamp}{$vios_name}{$id}{sentBytesG};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{sentPacketsG}){$io_write=$content->{$timestamp}{$vios_name}{$id}{sentPacketsG};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{droppedPackets}){$dropped_packets=$content->{$timestamp}{$vios_name}{$id}{droppedPackets};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{type}){$type=$content->{$timestamp}{$vios_name}{$id}{type};}

          my $testing_out = "$timestamp $vios_name $id $physicalLocation $read $io_read $write $io_write $dropped_packets $type";
          my $ret = substr( $timestamp, 0, 1 );
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lan data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) );
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lan data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
          (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
          $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.ral$type_sam";

          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
              my $ret = create_rrd_lan( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
             rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # print "last adapter : $ltime  actuall: $t\n";
          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            #print "$counter_ins : $timestamp $t\n";
            if (!(main::isdigit($io_read))){ $io_read = "U"; }
            if (!(main::isdigit($io_write))){ $io_write = "U"; }
            if (!(main::isdigit($write))){ $write = "U"; }
            if (!(main::isdigit($read))){ $read = "U"; }
            if (!(main::isdigit($dropped_packets))){ $dropped_packets = "U"; }
            RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$dropped_packets);
            #RRDp::cmd qq(update "$rrd" $t:0:0:0:0);

            $last_time = $timestamp;
            my $answer = RRDp::read;
            # update the time of last record
            $ltime = $t;
          } ## end if ( $t > $ltime && length...)
        } #end foeach my $id
        } #end foreach my $vios_name
      } #end foreach my $timestamp
=cut
      open ($ltiph, ">", "$wrkdir/$managedname/$host/iostat/last_ts.lan");
      print $ltiph "$temp_ts";
      close($ltiph);
      if (defined $file && defined $files[-1] && defined $files[-2]){
        if ($file eq $files[-1]){
          copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/lan_perf1");
        }
        if ($file eq $files[-2]){
          copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/lan_perf2");
        }
      }
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || main::error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || main::error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
    } #end foreach my $file
  } #end if (json configured)
  else{
    if (-e "$input_adapters-$type_sam"){
      open (FH, "< $input_adapters-$type_sam") || main::error( " Can't open $input_adapters-$type_sam : $!" . __FILE__ . ":" . __LINE__ );
    }
    else{
      #main::error( " File doesn't exist $input_adapters-$type_sam : $! " . __FILE__ . ":" . __LINE__ );
      return 1;
    }
  my @lines = reverse <FH>;
  close(FH);
  foreach my $line (@lines) {
    my $ltime            = 0;
    my $rrd_exist_ok     = 0;
    my $rrd_exist_ok_max     = 0;
    #12/11/2017 12:11:30,vios-770,ent0,U78C0.001.DBJB578-P2-C1-T1,45548556957,51573237,13209643948,20294831,0,physical
    chomp($line);
    #print "$line\n";
    ( $time, my $vios_name, my $id, my $physicalLocation, my $read, my $io_read, my $write, my $io_write, my $droppedPackets, my $type) = split( /,/, $line );
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( $ret =~ /\D/ )
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }
    (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
    $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.ral$type_sam";
    my $dirname_tmp = "$wrkdir/$managedname/$host/adapters/";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_lan( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
    } ## end if ( $ltime == 0 )

    # print "last adapter : $ltime  actuall: $t\n";
    # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime ) { #&& length($vios_name) > 0 ) {
      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;
      $counter_ins++;

      #print "$counter_ins : $time $t:$promenne \n";
      if (!(main::isdigit($write))){ $write = "U"; }
      if (!(main::isdigit($io_write))){ $io_write = "U"; }
      if (!(main::isdigit($read))){ $read = "U"; }
      if (!(main::isdigit($io_read))){ $io_read = "U"; }
      if (!(main::isdigit($droppedPackets))){ $droppedPackets = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$droppedPackets);
      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)

  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:adapters $counter_ins record(s)\n" if $DEBUG;
  }
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_lan

=begin 
if ($json_configured eq "1"){
    my $perf_string = "lan_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    ##001 PUVODNI CAST KODU ##
    ##open (FH, "< $input_file-$type_sam") || main::error( " Can't open $input_file-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    ##my @lines = reverse <FH>;
    ##close(FH);
    ## END 001###

    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.lan"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.lan") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.lan at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      #print "path: $path\n";
      #print Dumper $content;
      #print "END end content lan json $path\n";
      if (!defined $content || $content eq "-1"){
        next;
      }
      my $temp_ts;
=cut


sub load_data_gpa {
  my $time              = "";
  my $counter           = 0;
  my $counter_tot       = 0;
  my $counter_ins       = 0;
  my $rrd               = "";
  my $rrd_max           = "";
  my $utime             = time() + 3600;
  my $jump              = 0;
  my $last_time         = "";

  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_gpa, $no_time, $json_configured, $save_files ) = @_;
  if ($json_configured eq "1"){
    my $perf_string = "gpa_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.gpa"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.gpa") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.gpa at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      foreach my $sample (@{$content}){
        (my $ts, my $vios_name, my $adapter_id, my $physicalLocation, my $type, my $io_read, my $io_write, my $read, my $write) = ("U","U","U","U","U","U","U","U","U");
        $ts = $sample->[0];
        $vios_name = $sample->[1];
        $adapter_id = $sample->[2];
        $physicalLocation = $sample->[3];
        $type = $sample->[4];
        $io_read = $sample->[5];
        $io_write = $sample->[6];
        $read = $sample->[7];
        $write = $sample->[8];
        my $t = str2time( substr( $ts, 0, 19 ) );

        (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
        $rrd = "$wrkdir/$managedname/$host/adapters/$short_physloc.rap$type_sam";

        if (!-e ($rrd)){
          my $ret = create_rrd_gpa( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
          if ( $ret == 2 ) {
            next;
          }
        }
        my $last_rec;
        eval {
          RRDp::cmd qq(last "$rrd" );
          $last_rec = RRDp::read;
        };
        if ($@) {
          rrd_error( $@, $rrd );
          next;
        }
        chomp($$last_rec);
        my $ltime = $$last_rec;
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          if (!(main::isdigit($io_read))){ $io_read = "U"; }
          if (!(main::isdigit($read))){ $read = "U"; }
          if (!(main::isdigit($io_write))){ $io_write = "U"; }
          if (!(main::isdigit($write))){ $write = "U"; }
          RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
          $last_time = $ts; 
          my $answer = RRDp::read;
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      }
=cut
      foreach my $timestamp (sort keys %{$content}){
        if ($timestamp eq $saved_ts){next;}
        $temp_ts = $timestamp;
        foreach my $vios_name (keys %{$content->{$timestamp}}){
        foreach my $id (keys %{$content->{$timestamp}{$vios_name}}){
          my $physicalLocation = "";
          my $read = "";
          my $io_read = "";
          my $write = "";
          my $io_write = "";
          my $dropped_packets = "";
          my $type = "";

          my $ltime            = 0;
          my $rrd_exist_ok     = 0;
          my $rrd_exist_ok_max = 0;
          if (defined $content->{$timestamp}{$vios_name}{$id}{physicalLocation}){$physicalLocation=$content->{$timestamp}{$vios_name}{$id}{physicalLocation};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{readBytesG}){$read=$content->{$timestamp}{$vios_name}{$id}{readBytesG};}else{$read="U";}
          if (defined $content->{$timestamp}{$vios_name}{$id}{numOfReadsG}){$io_read=$content->{$timestamp}{$vios_name}{$id}{numOfReadsG};}else{$io_read="U";}
          if (defined $content->{$timestamp}{$vios_name}{$id}{writeBytesG}){$write=$content->{$timestamp}{$vios_name}{$id}{writeBytesG};}else{$write="U";}
          if (defined $content->{$timestamp}{$vios_name}{$id}{numOfWritesG}){$io_write=$content->{$timestamp}{$vios_name}{$id}{numOfWritesG};}else{$io_write="U";}
          #if (defined $content->{$timestamp}{$vios_name}{$id}{droppedPackets}){$dropped_packets=$content->{$timestamp}{$vios_name}{$id}{droppedPackets};}
          if (defined $content->{$timestamp}{$vios_name}{$id}{type}){$type=$content->{$timestamp}{$vios_name}{$id}{type};}
          my $testing_out = "$timestamp $vios_name $id $physicalLocation $read $io_read $write $io_write $dropped_packets $type";
          #( $time, my $vios_name, my $id, my $physicalLocation, my $read, my $io_read, my $write, my $io_write, my $running_speed, my $type) = split( /,/, $line );
          my $ret = substr( $timestamp, 0, 1 );
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) );
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
          (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
          $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.rap$type_sam"; #m;

          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
              my $ret = create_rrd_gpa( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
              rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            if (!(main::isdigit($io_read))){ $io_read = "U"; }
            if (!(main::isdigit($read))){ $read = "U"; }
            if (!(main::isdigit($io_write))){ $io_write = "U"; }
            if (!(main::isdigit($write))){ $write = "U"; }
            RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);

            $last_time = $timestamp;
            my $answer = RRDp::read;
            # update the time of last record
            $ltime = $t;
           } ## end if ( $t > $ltime && length...)
          } #end foeach my $id
        } #end foreach my $vios_name
      } #end foreach my $timestamp
=cut
      ##unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
      if (defined $file && defined $files[-1] && defined $files[-2]){
      if ($file eq $files[-1]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/gpa_perf1");
      }
      if ($file eq $files[-2]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/gpa_perf2");
      }
      }
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      open ($ltiph, ">", "$wrkdir/$managedname/$host/iostat/last_ts.gpa");
      print $ltiph "$temp_ts";
      close($ltiph);
    } #end foreach my $file
  } #end if (json configured)
  else{
  if (-e "$input_gpa-$type_sam"){
    open (FH, "< $input_gpa-$type_sam") || main::error( " Can't open $input_gpa-$type_sam : $!" . __FILE__ . ":" . __LINE__ );
  }
  else{
    #main::error( " File doesn't exist $input_gpa-$type_sam : $! " . __FILE__ . ":" . __LINE__ );
    return 1;
  }
  my @lines = reverse <FH>;
  close(FH);
  foreach my $line (@lines) {
    my $ltime            = 0;
    my $rrd_exist_ok     = 0;
    my $rrd_exist_ok_max     = 0;
    chomp($line);
    ( $time, my $vios_name, my $id, my $physicalLocation, my $io_read, my $io_write, my $read, my $write) = split( /,/, $line );
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( $ret =~ /\D/ )
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }
    my $dirname_tmp = "$wrkdir/$managedname/$host/adapters/";
    (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
    $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.rap$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_gpa( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
        rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
    } ## end if ( $ltime == 0 )

    # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime ) { #&& length($vios_name) > 0 ) {
      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;
      $counter_ins++;

      #print "$counter_ins : $time $t:$promenne \n";


      #RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
      if (!(main::isdigit($io_read))){ $io_read = "U"; }
      if (!(main::isdigit($read))){ $read = "U"; }
      if (!(main::isdigit($io_write))){ $io_write = "U"; }
      if (!(main::isdigit($write))){ $write = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);



      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:fiber_channel_adapters $counter_ins record(s)\n" if $DEBUG;
  }
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_gpa

sub load_data_fcs {
  my $time = "";
  my $counter          = 0;
  my $counter_tot      = 0;
  my $counter_ins      = 0;
  my $rrd              = "";
  my $rrd_max          = "";
  my $utime            = time() + 3600;
  my $jump             = 0;
  my $last_time        = "";

  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_fcs, $no_time, $json_configured, $save_files ) = @_;
  if ($json_configured == 1){
    my $perf_string = "san_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ );

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.fcs"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.fcs") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.fcs at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    foreach my $file(@files){
      my $datestring = localtime();
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      my $temp_ts;
      foreach my $sample (@{$content}){
        my $ts = $sample->[0];
        my $lpar = $sample->[1];
        my $fcs = $sample->[2];
        my $loc = $sample->[3];
        my $io_read = $sample->[4];
        my $io_write = $sample->[5];
        my $read = $sample->[6];
        my $write = $sample->[7];
        my $running_speed = $sample->[8];
        my $wwpn = $sample->[9];
        my $t = str2time( substr( $ts, 0, 19 ) );
        (undef,undef,my $short_physloc) = split ('\\.', $loc);
        $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.ras$type_sam"; #m;
        if (!-e $rrd){
          my $ret = create_rrd_fcs( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
          if ( $ret == 2 ) {
            next;
          }
        }
        my $last_rec;
        eval {
          RRDp::cmd qq(last "$rrd" );
          $last_rec = RRDp::read;
        };
        if ($@) {
          rrd_error( $@, $rrd );
          next;
        }
        chomp($$last_rec);
        my $ltime = $$last_rec;
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          if (!(main::isdigit($io_read))){ $io_read = "U"; }
          if (!(main::isdigit($read))){ $read = "U"; }
          if (!(main::isdigit($io_write))){ $io_write = "U"; }
          if (!(main::isdigit($write))){ $write = "U"; }
          if (!(main::isdigit($running_speed))){ $running_speed = "U"; }
          RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$running_speed);
          $last_time = $ts;
          my $answer = RRDp::read;
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      }
=cut
      foreach my $timestamp (sort keys %{$content}){
        $temp_ts = $timestamp;
        foreach my $lpar (sort keys %{$content->{$timestamp}}){
          foreach my $id (keys %{$content->{$timestamp}{$lpar}}){
            my $ltime            = 0;
            my $rrd_exist_ok     = 0;
            my $rrd_exist_ok_max = 0;
            my $port = $content->{$timestamp}{$lpar}{$id};
            my $physicalLocation="";
            my $io_write="";
            my $io_read="";
            my $write="";
            my $read="";
            my $droppedPackets="";
            my $running_speed="";
            my $type="";
            my $testing_out;
            if (defined $port->{physicalLocation} && $port->{physicalLocation} ne ""){$physicalLocation = $port->{physicalLocation}; }else{$physicalLocation="U";}
            if (defined $port->{numOfWritesG} && $port->{numOfWritesG} ne ""){$io_write = $port->{numOfWritesG}; }else{$io_write="U";}
            if (defined $port->{writeBytesG} && $port->{writeBytesG} ne ""){$write = $port->{writeBytesG}; }else{$write="U";}
            if (defined $port->{readBytesG} && $port->{readBytesG} ne ""){$read = $port->{readBytesG}; }else{$read="U";}
            if (defined $port->{numOfReadsG} && $port->{numOfReadsG} ne ""){$io_read = $port->{numOfReadsG}; }else{$io_read="U";}
            if (defined $port->{type} && $port->{type} ne ""){$type = $port->{type}; }else{$type=0;}
            if (defined $port->{droppedPacketsG} && $port->{droppedPacketsG} ne ""){$droppedPackets = $port->{droppedPacketsG}; }else{$droppedPackets="U";}
            if (defined $port->{runningSpeedG} && $port->{runningSpeedG} ne ""){$running_speed = $port->{runningSpeedG}; }else{$running_speed="U";}
            $testing_out = "$lpar $id $physicalLocation $write $io_write $read $io_read $droppedPackets $type";
          my $ret = substr( $timestamp, 0, 1 );
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) );
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
          (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
          $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.ras$type_sam"; #m;

          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
              my $ret = create_rrd_fcs( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
              rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            #RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
            if (!(main::isdigit($io_read))){ $io_read = "U"; }
            if (!(main::isdigit($read))){ $read = "U"; }
            if (!(main::isdigit($io_write))){ $io_write = "U"; }
            if (!(main::isdigit($write))){ $write = "U"; }
            if (!(main::isdigit($running_speed))){ $running_speed = "U"; }
            RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$running_speed);
            $last_time = $timestamp;
            my $answer = RRDp::read;
            # update the time of last record
            $ltime = $t;
          } ## end if ( $t > $ltime && length...)
          } ##end foreach my $id
        } #end foreach my lpar
      }#end foreach my $timestamp
=cut
      ##unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
      if (defined $file && defined $files[-1] && defined $files[-2]){
      if ($file eq $files[-1]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/san_perf1");
      }
      if ($file eq $files[-2]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/san_perf2");
      }
      }
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      open ($ltiph, ">", "$wrkdir/$managedname/$host/iostat/last_ts.fcs");
      print $ltiph "$temp_ts";
      close($ltiph);
    }
  }
  else{
  if (-e "$input_fcs-$type_sam"){
    open (FH, "< $input_fcs-$type_sam") || main::error( " Can't open $input_fcs-$type_sam : $!" . __FILE__ . ":" . __LINE__ );
  }
  else{
    #main::error( " File doesn't exist $input_fcs-$type_sam : $! " . __FILE__ . ":" . __LINE__ );
    return 1;
  }
  my @lines = reverse <FH>;
  close(FH);
  foreach my $line (@lines) {
    my $ltime            = 0;
    my $rrd_exist_ok     = 0;
    my $rrd_exist_ok_max     = 0;
    #12/11/2017 12:11:30,vios-770,ent0,U78C0.001.DBJB578-P2-C1-T1,45548556957,51573237,13209643948,20294831,0,physical
    chomp($line);
    ( $time, my $vios_name, my $id, my $physicalLocation, my $io_read, my $io_write, my $read, my $write,  my $running_speed, my $type) = split( /,/, $line );
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( $ret =~ /\D/ )
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }
    my $dirname_tmp = "$wrkdir/$managedname/$host/adapters/";
    (undef,undef,my $short_physloc) = split ('\\.', $physicalLocation);
    $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.ras$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_fcs( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
       rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
    } ## end if ( $ltime == 0 )

    # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime ) { #&& length($vios_name) > 0 ) {
      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;
      $counter_ins++;

      #print "$counter_ins : $time $t:$promenne \n";
      if (!(main::isdigit($io_read))){ $io_read = "U"; }
      if (!(main::isdigit($read))){ $read = "U"; }
      if (!(main::isdigit($io_write))){ $io_write = "U"; }
      if (!(main::isdigit($write))){ $write = "U"; }
      if (!(main::isdigit($running_speed))){ $running_speed = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write:$running_speed);
      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  }
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:fiber_channel_adapters $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_fcs

sub load_data_json_lpars_all {
  my $time = "";
  my $counter          = 0;
  my $counter_tot      = 0;
  my $counter_ins      = 0;
  my $rrd              = "";
  my $rrd_max          = "";
  my $utime            = time() + 3600;
  my $jump             = 0;
  my $last_time        = "";

  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_file, $no_time,$grep_string,$json_configured, $save_files ) = @_;
  my $perf_string = $grep_string;
  #my $perf_string = "lpars_perf";
  my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
  opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

  my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
  my @files = reverse sort { lc $a cmp lc $b } @files_unsorted;
  ##001 PUVODNI CAST KODU ##
  ##open (FH, "< $input_file-$type_sam") || main::error( " Can't open $input_file-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  ##my @lines = reverse <FH>;
  ##close(FH);
  ## END 001###

  #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
  #foreach my $line (@lines) {
  foreach my $file(@files){
    my $datestring = localtime();
    print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
    my $path = "$iostatdir$file";
    my $content = read_json($path);
    if (!defined $content || $content eq "-1" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
      next;
    }
    foreach my $timestamp (reverse sort keys %{$content}){
      foreach my $lpar (sort keys %{$content->{$timestamp}}){
        my $curr_proc_units=0;
        my $curr_procs=0;
        my $phys_run_mem = 0;
        my $curr_io_entitled_mem = 0;
        my $mapped_io_mem = 0;
        my $entitledProcCycles=0;
        my $donatedProcCycles=0;
        my $mode=0;
        my $idleProcCycles=0;
        my $utilizedUnCappedProcCycles=0;
        my $utilizedCappedProcCycles=0;

        my $memory = $content->{$timestamp}{$lpar}{'memory'};
        if (defined $memory->{'curr_io_entitled_mem'}){$curr_io_entitled_mem = $memory->{'curr_io_entitled_mem'};}
        if (defined $memory->{'mapped_io_mem'}){$mapped_io_mem = $memory->{'mapped_io_mem'};}
        if (defined $memory->{'phys_run_mem'}){$phys_run_mem = $memory->{'phys_run_mem'};}

        my $processor = $content->{$timestamp}{$lpar}{'processor'};
        if (defined $processor->{'entitledProcCycles'}){$entitledProcCycles = $processor->{'entitledProcCycles'};}else{$entitledProcCycles="U"}
        if (defined $processor->{'donatedProcCycles'}){$donatedProcCycles = $processor->{'donatedProcCycles'};}else{$donatedProcCycles="U"}
        if (defined $processor->{'mode'}){$mode = $processor->{'mode'};}
        if (defined $processor->{'curr_procs'}){$curr_procs = $processor->{'curr_procs'};}else{$curr_procs="U"}
        if (defined $processor->{'curr_proc_units'}){$curr_proc_units = $processor->{'curr_proc_units'};}else{$curr_proc_units="U"}
        if (defined $processor->{'idleProcCycles'}){$idleProcCycles = $processor->{'idleProcCycles'};}else{$idleProcCycles="U"}
        if (defined $processor->{'utilizedUnCappedProcCycles'}){$utilizedUnCappedProcCycles = $processor->{'utilizedUnCappedProcCycles'};}else{$utilizedUnCappedProcCycles="U"}
        if (defined $processor->{'utilizedCappedProcCycles'}){$utilizedCappedProcCycles = $processor->{'utilizedCappedProcCycles'};}else{$utilizedCappedProcCycles="U"}

        ###( $time, $lpar, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles, $capped_cycles, $uncapped_cycles, $shared_cycles_while_active, $mem_mode, $curr_mem, $phys_ru     n_mem, $curr_io_entitled_mem, $mapped_io_entitled_mem, $mem_overage_cooperation, $idle_cycles ) = split( /,/, $line );
        #TU
        my $testing_out = "$timestamp, $lpar, $curr_proc_units, $curr_procs,$mode,$entitledProcCycles,$utilizedCappedProcCycles,$utilizedUnCappedProcCycles,'shared_cycles_while_active','m     em_mode','curr_mem',$phys_run_mem,$curr_io_entitled_mem,$mapped_io_mem,'mem_overage_cooperation',$idleProcCycles";

        my $ltime            = 0;
        my $rrd_exist_ok     = 0;
        my $rrd_exist_ok_max = 0;
        my $ret = substr( $timestamp, 0, 1 );
        if ( $ret =~ /\D/ ) {
          # leave it as wrong input data
          main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
          next;
        } ## end if ( $ret =~ /\D/ )
        my $t = str2time( substr( $timestamp, 0, 19 ) );
        if ( length($t) < 10 ) {
          # leave it as wrong input data
          main::error( "$host:$managedname : No valid lpars data got from HMC :$ret : $testing_out " . __FILE__ . ":" . __LINE__ );
          next;
        } ## end if ( length($t) < 10 )
        if ( $step == 3600 ) {
          # Put on the last time possition "00"!!!
          substr( $t, 8, 2, "00" );
        }
        my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
        $lpar =~ s/\//\&\&1/g ;
        $rrd     = "$wrkdir/$managedname/$host/$lpar.rrj"; #type_sam;

          #create rrd db if necessary
        if (!(-e $rrd)){
        if ( $rrd_exist_ok == 0 ) {
         #my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
         #my $ret = create_rrd( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time, $SSH, $hmc_user, $wrkdir, $lpar, $t, $keep_virtual );
          if ( $ret == 2 ) {
            next; # muj test????
            #return 1;    # RRD creation problem, skip whole load
          }
          $rrd_exist_ok = 1;
        } ## end if ( $rrd_exist_ok == ...)
        }

        if ( $ltime == 0 ) {

          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
            RRDp::cmd qq(last "$rrd" );
            $last_rec = RRDp::read;
          };
          if ($@) {
            #RRDp::error_mode = "catch";
           rrd_error( $@, $rrd );
            $rrd_exist_ok = 0;
            next;
          }
          chomp($$last_rec);
          $ltime = $$last_rec;
        } ## end if ( $ltime == 0 )

        # print "last adapter : $ltime  actuall: $t\n";
        # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime ) { #&& length($vios_name) > 0 ) {
          my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
          if ( $t > $jump_time ) {

            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            if ( $jump == 0 ) {
              $jump = 1;
              #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
              #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
              next;
            } ## end if ( $jump == 0 )
           # looks like it is ok as it is second timestap in a row
          } ## end if ( $t > $jump_time )
          $jump = 0;
          $counter_ins++;
          if (!(main::isdigit($curr_proc_units))){ $curr_proc_units = "U"; }
          if (!(main::isdigit($curr_procs))){ $curr_procs = "U"; }
          if (!(main::isdigit($entitledProcCycles))){ $entitledProcCycles = "U"; }
          if (!(main::isdigit($utilizedCappedProcCycles))){ $utilizedCappedProcCycles = "U"; }
          if (!(main::isdigit($utilizedUnCappedProcCycles))){ $utilizedUnCappedProcCycles = "U"; }
          RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$curr_procs:$entitledProcCycles:$utilizedCappedProcCycles:$utilizedUnCappedProcCycles);
          $last_time = $timestamp;
          my $answer = RRDp::read;
          # update the time of last record
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
        #} ## end foreach my $line (@lines)
      }
    }
    if ($save_files == 0){
      unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
    }
  }#end foreach my $file(@files)

  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:lpars $counter_ins record(s)\n" if $DEBUG;
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)
  return 0;
} ## end sub load_data_json_lpars


sub create_rrd_cod {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;

  #my $no_time_new = $no_time;
  my $no_time_new = $step_new;

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_cod : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_cod $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:-100000000000:100000000000"
          "RRA:AVERAGE:0.1:1:10000"
          "RRA:AVERAGE:0.1:24:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:-100000000000:100000000000"
          "RRA:AVERAGE:0.1:1:1825"
          "RRA:AVERAGE:0.1:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_cod : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_cod $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:-100000000000:100000000000"
          "RRA:AVERAGE:0.1:1:$one_minute_sample"
          "RRA:AVERAGE:0.1:24:$one_hour_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $one_hour_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:-100000000000:100000000000"
          "RRA:AVERAGE:0.1:1:$one_minute_sample"
          "RRA:AVERAGE:0.1:60:$one_hour_sample"
          "RRA:AVERAGE:0.1:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $one_hour_sample, $one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_cod

sub create_lpar_mem_ded {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_lpar_mem_ded $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:1825"
          "RRA:AVERAGE:0.5:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
                                              #print "0000 $one_minute_sample - $five_mins_sample - $one_hour_sample - $five_hours_sample - $one_day_sample\n";
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_lpar_mem_ded $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        #print "++ $rrd $start_time $step_new\n";
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
          "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem, $one_day_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_lpar_mem_ded

# AMS memory
sub create_lpar_mem {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_lpar_mem $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:1825"
          "RRA:AVERAGE:0.5:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
                                              #print "0000 $one_minute_sample - $five_mins_sample - $one_hour_sample - $five_hours_sample - $one_day_sample\n";
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_lpar_mem $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        #print "++ $rrd $start_time $step_new\n";
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
          "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem, $one_day_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_lpar_mem

sub create_rrd_pool_mem {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;

      # keep 5y 1 day averages, and 5y 7 day averages
      touch("create_rrd_pool_mem $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
          "RRA:AVERAGE:0.5:1:1825"
          "RRA:AVERAGE:0.5:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;

      # keep 30 days of 1m sample interval and then averages
      # 5h averages for 6m, 1day averages for 3y
      touch("create_rrd_pool_mem $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
          "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem, $one_day_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_pool_mem

sub create_rrd_pool {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  if ( $rrd =~ /\.xr$type_sam$/ ) {
    $rra_average = "MAX";
  }

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;

      # keep 5y 1 day averages, and 5y 7 day averages
      touch("create_rrd_pool $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:10000"
          "RRA:$rra_average:0.5:6:1500"
          "RRA:$rra_average:0.5:24:1000"
          "RRA:$rra_average:0.5:288:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:1825"
          "RRA:$rra_average:0.5:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;

      # keep 30 days of 1m sample interval and then averages
      # 5h averages for 6m, 1day averages for 3y
      touch("create_rrd_pool $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:6:$five_mins_sample"
          "RRA:$rra_average:0.5:24:$one_hour_sample"
          "RRA:$rra_average:0.5:288:$five_hours_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample, $one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_pool

sub create_rrd_pool_shared {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  if ( $rrd =~ /\.xr$type_sam$/ ) {
    $rra_average = "MAX";
  }

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "cr_rrd_pool_sh : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;

      # keep 5y 1 day averages, and 5y 7 day averages
      touch("create_rrd_pool_shared $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:10000"
          "RRA:$rra_average:0.5:6:1500"
          "RRA:$rra_average:0.5:24:1000"
          "RRA:$rra_average:0.5:288:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:1825"
          "RRA:$rra_average:0.5:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "cr_rrd_pool_sh : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;

      # keep 30 days of 1m sample interval and then averages
      # 5h averages for 6m, 1day averages for 3y
      touch("create_rrd_pool_shared $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:6:$five_mins_sample"
          "RRA:$rra_average:0.5:24:$one_hour_sample"
          "RRA:$rra_average:0.5:288:$five_hours_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample, $one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_pool_shared

sub create_rrd_mem {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  # actual memory limit is 1000TB
  # this can be easily even online updated by
  # find $HOMELPAR/data -name "mem.rr*" -exec rrdtool tune {} --maximum curr_avail_mem:1000000000 \;

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_mem : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_mem $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:1000000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:100000000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:1000000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:100000000000"
          "RRA:AVERAGE:0.5:1:1825"
          "RRA:AVERAGE:0.5:7:260"
        );
        if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_mem : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_mem $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:1000000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:100000000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:1000000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:100000000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
          "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
        if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample_mem, $five_mins_sample_mem, $one_hour_sample_mem, $five_hours_sample_mem, $one_day_sample_mem") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_mem

sub create_rrd_fcs {

  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  #if ( $rrd =~ /\.xr$type_sam$/ ) {
  #  $rra_average = "MAX";
  #}
  #print "rrd:$rrd\nstart_time:$start_time\ncounter_tot:$counter_tot\nstep:$step\ntype_sam:$type_sam\nDebug:$DEBUG\nhost:$host\nmanagedname:$managedname\nno_time:$no_time\nact_time:$act_time\nstep_new:$step_new\nno_time_new:$no_time_new\n\n";
  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!
  #12/12/2017 06:34:00,vios-770,ent4,U9117.MMC.44K8102-V1-C4-T1,15641245826,18814533,45077532734,48129562,0,virtual
  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_fcs : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_fcs $rrd");
      if ( $step == 3600 ) { 
        #receivedBytes = read; receivedPackets=io_read; sentbytes=write;
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:running_speed:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:running_speed:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_fcs : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_fcs $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:running_speed:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:running_speed:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_fcs

=cut
sub create_rrd_sriov{

  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  #if ( $rrd =~ /\.xr$type_sam$/ ) {
  #  $rra_average = "MAX";
  #}
  #print "rrd:$rrd\nstart_time:$start_time\ncounter_tot:$counter_tot\nstep:$step\ntype_sam:$type_sam\nDebug:$DEBUG\nhost:$host\nmanagedname:$managedname\nno_time:$no_time\nact_time:$act_time\nstep_new:$step_new\nno_time_new:$no_time_new\n\n";
  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!
  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_sriov : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_sriov $rrd");
      if ( $step == 3600 ) { 
        #receivedBytes = read; receivedPackets=io_read; sentbytes=write;
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_in:GAUGE:$no_time_new:0:50000000"
          "DS:drop_out:GAUGE:$no_time_new:0:50000000"
          "DS:error_i:GAUGE:$no_time_new:0:50000000"
          "DS:error_o:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_in:GAUGE:$no_time_new:0:50000000"
          "DS:drop_out:GAUGE:$no_time_new:0:50000000"
          "DS:error_i:GAUGE:$no_time_new:0:50000000"
          "DS:error_o:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_lan : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_lan $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_in:GAUGE:$no_time_new:0:50000000"
          "DS:drop_out:GAUGE:$no_time_new:0:50000000"
          "DS:error_i:GAUGE:$no_time_new:0:50000000"
          "DS:error_o:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:droped_i:GAUGE:$no_time_new:0:50000000"
          "DS:droped_o:GAUGE:$no_time_new:0:50000000"
          "DS:error_in:GAUGE:$no_time_new:0:50000000"
          "DS:error_out:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_sriov
=cut

sub create_rrd_sriov2 {

  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;




#$ts,$lpar,$physLoc,$configurationType,$drcIndex,$droppedReceivedPackets,$droppedSentPackets,$errorIn,$errorOut,$physicalDrcIndex,$physicalPortId,$receivedBytes,$receivedPackets,$sentBytes,$sentPackets,$vnicDeviceMode


  my $rra_average = "AVERAGE";
  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!
  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_fcs : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_fcs $rrd");
      if ( $step == 3600 ) { 
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_i:GAUGE:$no_time_new:0:50000000"
          "DS:drop_o:GAUGE:$no_time_new:0:50000000"
          "DS:error_in:GAUGE:$no_time_new:0:50000000"
          "DS:error_out:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
         RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_i:GAUGE:$no_time_new:0:50000000"
          "DS:drop_o:GAUGE:$no_time_new:0:50000000"
          "DS:error_in:GAUGE:$no_time_new:0:50000000"
          "DS:error_out:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_fcs : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_fcs $rrd");
      if ( $step == 3600 ) {
         RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_i:GAUGE:$no_time_new:0:50000000"
          "DS:drop_o:GAUGE:$no_time_new:0:50000000"
          "DS:error_in:GAUGE:$no_time_new:0:50000000"
          "DS:error_out:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
         RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drop_i:GAUGE:$no_time_new:0:50000000"
          "DS:drop_o:GAUGE:$no_time_new:0:50000000"
          "DS:error_in:GAUGE:$no_time_new:0:50000000"
          "DS:error_out:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_sriov2



sub create_rrd_lan {

  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  #if ( $rrd =~ /\.xr$type_sam$/ ) {
  #  $rra_average = "MAX";
  #}
  #print "rrd:$rrd\nstart_time:$start_time\ncounter_tot:$counter_tot\nstep:$step\ntype_sam:$type_sam\nDebug:$DEBUG\nhost:$host\nmanagedname:$managedname\nno_time:$no_time\nact_time:$act_time\nstep_new:$step_new\nno_time_new:$no_time_new\n\n";
  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!
  #12/12/2017 06:34:00,vios-770,ent4,U9117.MMC.44K8102-V1-C4-T1,15641245826,18814533,45077532734,48129562,0,virtual
  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_lan : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_lan $rrd");
      if ( $step == 3600 ) { 
        #receivedBytes = read; receivedPackets=io_read; sentbytes=write;
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:dropped_packets:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:dropped_packets:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
=cut
 RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:drc_index:GAUGE:$no_time_new:0:50000000"
          "DS:dropped_received_packets:GAUGE:$no_time_new:0:50000000"
          "DS:dropped_sent_packets:GAUGE:$no_time_new:0:50000000"
          "DS:error_in:GAUGE:$no_time_new:0:50000000"
          "DS:error_out:GAUGE:$no_time_new:0:50000000"
          "DS:physical_drc_index:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
=cut
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_lan : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_lan $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:dropped_packets:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "DS:dropped_packets:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_lan

sub create_rrd_json_lpars {
  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  #if ( $rrd =~ /\.xr$type_sam$/ ) {
  #  $rra_average = "MAX";
  #}
  #print "rrd:$rrd\nstart_time:$start_time\ncounter_tot:$counter_tot\nstep:$step\ntype_sam:$type_sam\nDebug:$DEBUG\nhost:$host\nmanagedname:$managedname\nno_time:$no_time\nact_time:$act_time\nstep_new:$step_new\nno_time_new:$no_time_new\n\n";
  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!
  #12/12/2017 06:34:00,vios-770,ent4,U9117.MMC.44K8102-V1-C4-T1,15641245826,18814533,45077532734,48129562,0,virtual
  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_json_lpars : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_json_lpars $rrd");
      if ( $step == 3600 ) { 
        #receivedBytes = read; receivedPackets=io_read; sentbytes=write;
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:c_proc_un:GAUGE:$no_time_new:0:50000000"
          "DS:vir_procs:GAUGE:$no_time_new:0:50000000"
          "DS:en_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:ca_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:un_cycles:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:c_proc_un:GAUGE:$no_time_new:0:50000000"
          "DS:vir_procs:GAUGE:$no_time_new:0:50000000"
          "DS:en_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:ca_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:un_cycles:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_lpar : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_json_lpars $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:c_proc_un:GAUGE:$no_time_new:0:50000000"
          "DS:vir_procs:GAUGE:$no_time_new:0:50000000"
          "DS:en_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:ca_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:un_cycles:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:c_proc_un:GAUGE:$no_time_new:0:50000000"
          "DS:vir_procs:GAUGE:$no_time_new:0:50000000"
          "DS:en_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:ca_cycles:GAUGE:$no_time_new:0:50000000"
          "DS:un_cycles:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_json_lpars

sub create_rrd_gpa {

  my $rrd         = shift;
  my $start_time  = shift;
  my $counter_tot = shift;
  my $step        = shift;
  my $type_sam    = shift;
  my $DEBUG       = shift;
  my $host        = shift;
  my $managedname = shift;
  my $no_time     = shift;
  my $act_time    = shift;
  my $step_new    = $step;
  my $no_time_new = $no_time;

  my $rra_average = "AVERAGE";
  #if ( $rrd =~ /\.xr$type_sam$/ ) {
  #  $rra_average = "MAX";
  #}
  #print "rrd:$rrd\nstart_time:$start_time\ncounter_tot:$counter_tot\nstep:$step\ntype_sam:$type_sam\nDebug:$DEBUG\nhost:$host\nmanagedname:$managedname\nno_time:$no_time\nact_time:$act_time\nstep_new:$step_new\nno_time_new:$no_time_new\n\n";
  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!
  #12/12/2017 06:34:00,vios-770,ent4,U9117.MMC.44K8102-V1-C4-T1,15641245826,18814533,45077532734,48129562,0,virtual
  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_gpa : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_gpa $rrd");
      if ( $step == 3600 ) { 
        #receivedBytes = read; receivedPackets=io_read; sentbytes=write;
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( not -f $rrd ) {
      load_retentions( $step, $act_time );    # load data retentions
      print "create_rrd_gpa : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd_fcs $rrd");
      if ( $step == 3600 ) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end if ( $step == 3600 )
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:read:GAUGE:$no_time_new:0:50000000"
          "DS:io_read:GAUGE:$no_time_new:0:50000000"
          "DS:write:GAUGE:$no_time_new:0:50000000"
          "DS:io_write:GAUGE:$no_time_new:0:50000000"
          "RRA:$rra_average:0.5:1:$one_minute_sample"
          "RRA:$rra_average:0.5:5:$five_mins_sample"
          "RRA:$rra_average:0.5:60:$one_hour_sample"
          "RRA:$rra_average:0.5:300:$five_hours_sample"
          "RRA:$rra_average:0.5:1440:$one_day_sample"
        );
        if ( !Xorux_lib::create_check("file: $rrd,$one_minute_sample,$five_mins_sample,$one_hour_sample,$five_hours_sample,$one_day_sample") ) {
          main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
          RRDp::end;
          RRDp::start "$rrdtool";
          return 2;
        } ## end if ( !Xorux_lib::create_check...)
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd_gpa

sub create_rrd {
  my $rrd          = shift;
  my $start_time   = shift;
  my $counter_tot  = shift;
  my $step         = shift;
  my $type_sam     = shift;
  my $DEBUG        = shift;
  my $host         = shift;
  my $managedname  = shift;
  my $no_time      = shift;
  my $act_time     = shift;
  my $SSH          = shift;
  my $hmc_user     = shift;
  my $wrkdir       = shift;
  my $lpar         = shift;
  my $time_rec     = shift;
  my $keep_virtual = shift;
  my $step_new     = $step;
  my $no_time_new  = $no_time;

  $start_time = 1400000000;    # something old enough, do not use  passed $start_time!!!!

  my $ret = recent_rename( $host, $managedname, $lpar, $wrkdir, $DEBUG, $time_rec, $act_time );
  if ( $ret == 1 ) {

    # this lpar has been recently renamed, do not create rrdtool files
    return 1;
  }

  if ( $type_sam =~ "d" ) {
    if ( not -f $rrd ) {       # do it once more, rename could create it
      $step_new    = 86400;
      $no_time_new = 200000;
      print "create_rrd_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd $rrd");
      if ( $step == 3600 ) {
        if ( $keep_virtual == 1 ) {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:10000"
              "RRA:AVERAGE:0.5:6:1500"
              "RRA:AVERAGE:0.5:24:1000"
              "RRA:AVERAGE:0.5:288:1000"
            );
          if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end if ( $keep_virtual == ...)
        else {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:10000"
              "RRA:AVERAGE:0.5:6:1500"
              "RRA:AVERAGE:0.5:24:1000"
              "RRA:AVERAGE:0.5:288:1000"
            );
          if ( !Xorux_lib::create_check("file: $rrd, 10000, 1500, 1000, 1000") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end else [ if ( $keep_virtual == ...)]
      } ## end if ( $step == 3600 )
      else {
        if ( $keep_virtual == 1 ) {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:1825"
              "RRA:AVERAGE:0.5:7:260"
            );
          if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end if ( $keep_virtual == ...)
        else {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:1825"
              "RRA:AVERAGE:0.5:7:260"
            );
          if ( !Xorux_lib::create_check("file: $rrd, 1825, 260") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end else [ if ( $keep_virtual == ...)]
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end if ( $type_sam =~ "d" )
  else {
    rename_lpar( $host, $managedname, $lpar, $act_time, $SSH, $hmc_user, $wrkdir, $DEBUG, $time_rec );
    if ( not -f $rrd ) {    # do it once more, rename could create it

      load_retentions( $step, $act_time );    # load data retentions
                                              #print "0000 $one_minute_sample - $five_mins_sample - $one_hour_sample - $five_hours_sample - $one_day_sample\n";
      print "create_rrd_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch("create_rrd $rrd");
      touch_LPM("create_rrd LPM $rrd");       # force to run LPM search in install-html.sh
      if ( $step == 3600 ) {
        if ( $keep_virtual == 1 ) {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:$one_minute_sample"
              "RRA:AVERAGE:0.5:6:$five_mins_sample"
              "RRA:AVERAGE:0.5:24:$one_hour_sample"
              "RRA:AVERAGE:0.5:288:$five_hours_sample"
            );
          if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );

            #RRDp::end;
            #RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end if ( $keep_virtual == ...)
        else {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:$one_minute_sample"
              "RRA:AVERAGE:0.5:6:$five_mins_sample"
              "RRA:AVERAGE:0.5:24:$one_hour_sample"
              "RRA:AVERAGE:0.5:288:$five_hours_sample"
            );
          if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end else [ if ( $keep_virtual == ...)]
      } ## end if ( $step == 3600 )
      else {
        #print "++ $rrd $start_time $step_new - $no_time_new \n";
        if ( $keep_virtual == 1 ) {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:$one_minute_sample"
              "RRA:AVERAGE:0.5:5:$five_mins_sample"
              "RRA:AVERAGE:0.5:60:$one_hour_sample"
              "RRA:AVERAGE:0.5:300:$five_hours_sample"
              "RRA:AVERAGE:0.5:1440:$one_day_sample"
            );
          if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample, $one_day_sample") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end if ( $keep_virtual == ...)
        else {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
              "RRA:AVERAGE:0.5:1:$one_minute_sample"
              "RRA:AVERAGE:0.5:5:$five_mins_sample"
              "RRA:AVERAGE:0.5:60:$one_hour_sample"
              "RRA:AVERAGE:0.5:300:$five_hours_sample"
              "RRA:AVERAGE:0.5:1440:$one_day_sample"
            );
          if ( !Xorux_lib::create_check("file: $rrd, $one_minute_sample, $five_mins_sample, $one_hour_sample, $five_hours_sample, $one_day_sample") ) {
            main::error( "unable to create $rrd : at " . __FILE__ . ": line " . __LINE__ );
            RRDp::end;
            RRDp::start "$rrdtool";
            return 2;
          } ## end if ( !Xorux_lib::create_check...)
        } ## end else [ if ( $keep_virtual == ...)]
      } ## end else [ if ( $step == 3600 ) ]
    } ## end if ( not -f $rrd )
  } ## end else [ if ( $type_sam =~ "d" )]
  return 0;
} ## end sub create_rrd

# workaround for situation when during LPM move
# those counters appears all 0 on the targed systems what causes
# huge peak in the graph

sub data_check {
  my $ent         = shift;
  my $cap         = shift;
  my $uncap       = shift;
  my $lpar        = shift;
  my $host        = shift;
  my $managedname = shift;

  if ( $ent eq '' ) {
    main::error("$host:$managedname:$lpar : ent is NULL, ignoring the line");
    return 1;
  }
  if ( $cap eq '' ) {
    main::error("$host:$managedname:$lpar : cap is NULL, ignoring the line");
    return 1;
  }
  if ( $uncap eq '' ) {
    main::error("$host:$managedname:$lpar : uncap is NULL, ignoring the line");
    return 1;
  }
  if ( $ent == 0 && $cap == 0 && $uncap == 0 ) {

    #main::error ("$host:$managedname:$lpar : LPM issue: $ent:$cap:$uncap - fixed, continue ...");
    return 1;
  }
  return 0;
} ## end sub data_check

sub touch {
  my $text = shift;

  my $version    = "$ENV{version}";
  my $basedir    = $ENV{INPUTDIR};
  my $new_change = "$basedir/tmp/$version-run";
  my $host       = $ENV{HMC};
  my $DEBUG      = $ENV{DEBUG};

  if ( !-f $new_change ) {
    `touch $new_change`;    # say install_html.sh that there was any change
    if ( $text eq '' ) {
      print "touch          : $host $new_change\n" if $DEBUG;
    }
    else {
      print "touch          : $host $new_change : $text\n" if $DEBUG;
    }
  } ## end if ( !-f $new_change )

  return 0;
} ## end sub touch

################################
# SDMC
################################

sub sdmc_procpool_load {
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $host        = shift;
  my $ivmy        = shift;
  my $ivmm        = shift;
  my $ivmd        = shift;
  my $ivmh        = shift;
  my $ivmmin      = shift;
  my $managedname = shift;
  my $out_file    = shift;
  my $type_sam    = shift;
  my $timerange   = shift;

  #return 1;

  if ( $type_sam =~ "d" ) {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r procpool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,shared_proc_pool_id,total_pool_cycles,utilized_pool_cycles  --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }
  else {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r procpool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,shared_proc_pool_id,total_pool_cycles,utilized_pool_cycles "|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }

  return 1;
} ## end sub sdmc_procpool_load

sub sdmc_cod_load {
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $host        = shift;
  my $ivmy        = shift;
  my $ivmm        = shift;
  my $ivmd        = shift;
  my $ivmh        = shift;
  my $ivmmin      = shift;
  my $managedname = shift;
  my $out_file    = shift;
  my $type_sam    = shift;
  my $loadhours   = shift;

  #print "**** COD load switched off\n";
  #return 1;

  if ( $type_sam =~ "d" ) {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r all --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,used_proc_min,unreported_proc_min --filter \"event_types=utility_cod_proc_usage\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }
  else {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r all --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,used_proc_min,unreported_proc_min --filter \"event_types=utility_cod_proc_usage\" "|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }

  return 1;
} ## end sub sdmc_cod_load

sub sdmc_pool_load {
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $host        = shift;
  my $ivmy        = shift;
  my $ivmm        = shift;
  my $ivmd        = shift;
  my $ivmh        = shift;
  my $ivmmin      = shift;
  my $managedname = shift;
  my $out_file    = shift;
  my $type_sam    = shift;
  my $loadhours   = shift;

  #return 1;

  if ( $type_sam =~ "d" ) {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r pool  --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units  --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }
  else {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r pool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units"|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }

  return 1;
} ## end sub sdmc_pool_load

sub sdmc_lpar_load {
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $host        = shift;
  my $ivmy        = shift;
  my $ivmm        = shift;
  my $ivmd        = shift;
  my $ivmh        = shift;
  my $ivmmin      = shift;
  my $managedname = shift;
  my $out_file    = shift;
  my $type_sam    = shift;
  my $loadhours   = shift;
  my $lpars       = shift;    # for alerting, just get selectively data for particular lpars
  my $mem_params  = shift;

  #return 1;

  if ( $type_sam =~ "d" ) {
    if ( $lpars eq '' ) {
      `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params"|egrep -iv "Could not create directory|known hosts" > $out_file`;
    }
    else {
      `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params  --filter \\\\\\"lpar_names=$lpars\\\\\\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
    }
  } ## end if ( $type_sam =~ "d" )
  else {
    if ( $lpars eq '' ) {
      `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params"|egrep -iv "Could not create directory|known hosts" > $out_file`;
    }
    else {
      `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params --filter \\\\\\"lpar_names=$lpars\\\\\\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
    }
  } ## end else [ if ( $type_sam =~ "d" )]

  return 1;
} ## end sub sdmc_lpar_load

sub sdmc_pool_mem_load {
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $host        = shift;
  my $ivmy        = shift;
  my $ivmm        = shift;
  my $ivmd        = shift;
  my $ivmh        = shift;
  my $ivmmin      = shift;
  my $managedname = shift;
  my $out_file    = shift;
  my $type_sam    = shift;
  my $loadhours   = shift;

  if ( $type_sam =~ "d" ) {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r mempool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,curr_pool_mem,lpar_curr_io_entitled_mem,lpar_mapped_io_entitled_mem,lpar_run_mem,sys_firmware_pool_mem --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }
  else {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r mempool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,curr_pool_mem,lpar_curr_io_entitled_mem,lpar_mapped_io_entitled_mem,lpar_run_mem,sys_firmware_pool_mem "|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }

  return 1;
} ## end sub sdmc_pool_mem_load

sub sdmc_sys_load {
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $host        = shift;
  my $ivmy        = shift;
  my $ivmm        = shift;
  my $ivmd        = shift;
  my $ivmh        = shift;
  my $ivmmin      = shift;
  my $managedname = shift;
  my $out_file    = shift;
  my $type_sam    = shift;
  my $loadhours   = shift;

  if ( $type_sam =~ "d" ) {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r sys --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,curr_avail_sys_mem,configurable_sys_mem,sys_firmware_mem --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }
  else {
    `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r sys --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,curr_avail_sys_mem,configurable_sys_mem,sys_firmware_mem "|egrep -iv "Could not create directory|known hosts" > $out_file`;
  }

  return 1;
} ## end sub sdmc_sys_load

sub smdc_touch {
  my $SDMC        = shift;
  my $wrkdir      = shift;
  my $managedname = shift;
  my $host        = shift;
  my $act_time    = shift;

  if ( $SDMC == 1 ) {
    if ( !-f "$wrkdir/$managedname/$host/SDMC" ) {
      open( FH, "> $wrkdir/$managedname/$host/SDMC" ) || main::error( " Can't create $wrkdir/$managedname/$host/IVM : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      print FH "SDMC\n";
      close(FH);
    }
  } ## end if ( $SDMC == 1 )
  else {
    if ( -f "$wrkdir/$managedname/$host/SDMC" ) {
      unlink("$wrkdir/$managedname/$host/SDMC");
    }
  }

  return 1;
} ## end sub smdc_touch

################################
# End of SDMC
################################

sub load_retentions {
  my $step     = shift;
  my $act_time = shift;
  my $basedir  = $ENV{INPUTDIR};

  # standards
  $one_minute_sample = 86400;
  $five_mins_sample  = 25920;
  $one_hour_sample   = 4320;
  $five_hours_sample = 1734;
  $one_day_sample    = 1080;

  $one_minute_sample_mem = 86400;
  $five_mins_sample_mem  = 25920;
  $one_hour_sample_mem   = 4320;
  $five_hours_sample_mem = 1734;
  $one_day_sample_mem    = 1080;

  if ( !-f "$basedir/etc/retention.cfg" ) {

    # standard retentions in place
    return 0;
  }

  # extra retentions are specifiled in $basedir/etc/retention.cfg
  open( FH, "< $basedir/etc/retention.cfg" ) || main::error("Can't read from: $basedir/etc/retention.cfg: $!");

  my @lines = <FH>;
  foreach my $line (@lines) {
    chomp($line);

    # MEM
    if ( $line =~ m/^1min/ && $line =~ m/MEM/ ) {
      ( my $trash, $one_minute_sample_mem ) = split( /:/, $line );
      next;
    }
    if ( $line =~ m/^5min/ && $line =~ m/MEM/ ) {
      ( my $trash, $five_mins_sample_mem ) = split( /:/, $line );
      next;
    }
    if ( $line =~ m/^60min/ && $line =~ m/MEM/ ) {
      ( my $trash, $one_hour_sample_mem ) = split( /:/, $line );
      next;
    }
    if ( $line =~ m/^300min/ && $line =~ m/MEM/ ) {
      ( my $trash, $five_hours_sample_mem ) = split( /:/, $line );
      next;
    }
    if ( $line =~ m/^1440min/ && $line =~ m/MEM/ ) {
      ( my $trash, $one_day_sample_mem ) = split( /:/, $line );
      next;
    }

    # CPU
    if ( $line =~ m/^1min/ ) {
      ( my $trash, $one_minute_sample ) = split( /:/, $line );
    }
    if ( $line =~ m/^5min/ ) {
      ( my $trash, $five_mins_sample ) = split( /:/, $line );
    }
    if ( $line =~ m/^60min/ ) {
      ( my $trash, $one_hour_sample ) = split( /:/, $line );
    }
    if ( $line =~ m/^300min/ ) {
      ( my $trash, $five_hours_sample ) = split( /:/, $line );
    }
    if ( $line =~ m/^1440min/ ) {
      ( my $trash, $one_day_sample ) = split( /:/, $line );
    }
  } ## end foreach my $line (@lines)

  close(FH);

  $step              = $step / 60;
  $one_minute_sample = $one_minute_sample / $step;
  $five_mins_sample  = $five_mins_sample / $step;
  $one_hour_sample   = $one_hour_sample / $step;
  $five_hours_sample = $five_hours_sample / $step;
  $one_day_sample    = $one_day_sample / $step;

  $one_minute_sample_mem = $one_minute_sample_mem / $step;
  $five_mins_sample_mem  = $five_mins_sample_mem / $step;
  $one_hour_sample_mem   = $one_hour_sample_mem / $step;
  $five_hours_sample_mem = $five_hours_sample_mem / $step;
  $one_day_sample_mem    = $one_day_sample_mem / $step;
  return 1;
} ## end sub load_retentions

sub basename {
  my $full = shift;
  my $out  = "";

  # basename without direct function
  my @base = split( /\//, $full );
  foreach my $m (@base) {
    $out = $m;
  }

  return $out;
} ## end sub basename

sub rename_lpar {
  my $host        = shift;
  my $managedname = shift;
  my $lpar        = shift;
  my $act_time    = shift;
  my $SSH         = shift;
  my $hmc_user    = shift;
  my $wrkdir      = shift;
  my $DEBUG       = shift;
  my $time_rec    = shift;
  my $serial      = "";
  my $lpar_slash  = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;
  # do not use it! it might corrupt data by renaming wrong lpars after LPM, 5.05-1 -PH
  return 1;

  if ( $rename_once == 0 ) {

    # do it only once per a server
    @rename = `$SSH $hmc_user\@$host "lssyscfg -m \\"$managedname\\" -r lpar -F name,logical_serial_num" 2>&1`;
  }
  $rename_once = 1;

  # new lpar has been detected here, found its serial and check whether any already existing lpar has it
  foreach my $line (@rename) {
    chomp($line);
    ( my $name, my $serial_new ) = split( /,/, $line );
    if ( $name =~ m/^$lpar_slash$/ ) {
      $serial = $serial_new;
      last;
    }
  } ## end foreach my $line (@rename)

  if ( $serial eq '' ) {

    #main::error("$host:$managedname:$lpar have not been found serial, ignore that if that lpar has been recently renamed");
    # --> error message is confusing ... do not print it at all
    return 0;
  } ## end if ( $serial eq '' )

  # now go through all cpu-cfg-$lpar and search serial
  my $tstamp      = 0;
  my $lpar_recent = "";
  my $lpar_old    = "";
  foreach my $cfg (<"$wrkdir/$managedname/$host/cpu.cfg-*">) {
    open( FHCPU, "< $cfg" ) || main::error( " Can't open $cfg : $! " . __FILE__ . ":" . __LINE__ ) && next;
    my @lines = <FHCPU>;

    #print "001 $cfg $serial\n";
    $lpar_old = $cfg;
    $lpar_old =~ s/^.*cpu\.cfg-//;

    foreach my $line (@lines) {
      chomp($line);
      if ( $line =~ m/logical_serial_num/ && $line =~ m/\>$serial\</ ) {

        #print "002 $lpar_old\n";

        # find out a lpar with the last record --> this one was most probably used before rename last time
        if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrm" ) {

          #print "003 $lpar_old $lpar\n";
          RRDp::cmd qq(last "$wrkdir/$managedname/$host/$lpar_old.rrm" );
          my $last_rec = RRDp::read;
          chomp($$last_rec);
          if ( $$last_rec > $tstamp ) {

            #print "004 $wrkdir/$managedname/$host/$lpar_old.rrm $$last_rec $tstamp\n";
            $tstamp      = $$last_rec;
            $lpar_recent = $lpar_old;
          } ## end if ( $$last_rec > $tstamp)
        } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrm")
        if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrh" ) {
          RRDp::cmd qq(last "$wrkdir/$managedname/$host/$lpar_old.rrh" );
          my $last_rec = RRDp::read;
          chomp($$last_rec);
          if ( $$last_rec > $tstamp ) {

            #print "004 $wrkdir/$managedname/$host/$lpar_old.rrh $$last_rec $tstamp\n";
            $tstamp      = $$last_rec;
            $lpar_recent = $lpar_old;
          } ## end if ( $$last_rec > $tstamp)
        } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrh")
      } ## end if ( $line =~ m/logical_serial_num/...)
    } ## end foreach my $line (@lines)
  } ## end foreach my $cfg (<"$wrkdir/$managedname/$host/cpu.cfg-*">)
  $lpar_old = $lpar_recent;

  if ( $lpar_old =~ m/^$lpar$/ ) {
    return 1;    # actual lpar has most recent data, keep it as it is
  }

  if ( !$lpar_recent eq '' ) {
    # Temporary -PH to debug an issue after LPM
    print STDERR "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : $serial\n" if $DEBUG;
    return 1;

    print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash\n" if $DEBUG;
    touch("lpar rename $host:$managedname: $lpar");

    # place lpar name and time spamp into rename.tmp file
    # there will not be created for 10minutes since then timestap a lpar with the same name
    # problem after a rename is that during next run there appear a few record with the originl lpar and
    #  new rrdtool files are created altough they should not --> problem with aggregated graphs (lpar & mem)
    my $rename_tmp = "$wrkdir/$managedname/$host/rename.tmp";
    open( FR, ">> $rename_tmp" ) || main::error( " Can't open $rename_tmp : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FR "$time_rec:$lpar_old\n";
    close(FR);

    # at first find out last used if there is found more same serial (some rename in the past)
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrm" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rrm" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rrm --> $lpar.rrm-old\n" if $DEBUG;
        rename( "$wrkdir/$managedname/$host/$lpar.rrm", "$wrkdir/$managedname/$host/$lpar.rrm-old" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar.rrm $wrkdir/$managedname/$host/$lpar.rrm-old: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rrm\n" if $DEBUG;
      rename( "$wrkdir/$managedname/$host/$lpar_old.rrm", "$wrkdir/$managedname/$host/$lpar.rrm" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar_old.rrm $wrkdir/$managedname/$host/$lpar.rrm: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrm")
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrd" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rrd" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rrd --> $lpar.rrd-old\n" if $DEBUG;
        rename( "$wrkdir/$managedname/$host/$lpar.rrd", "$wrkdir/$managedname/$host/$lpar.rrd-old" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar.rrd $wrkdir/$managedname/$host/$lpar.rrd-old: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rrd\n" if $DEBUG;
      rename( "$wrkdir/$managedname/$host/$lpar_old.rrd", "$wrkdir/$managedname/$host/$lpar.rrd" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar_old.rrd $wrkdir/$managedname/$host/$lpar.rrd: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrd")
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrh" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rrh" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rrh --> $lpar.rrh-old\n" if $DEBUG;
        rename( "$wrkdir/$managedname/$host/$lpar.rrh", "$wrkdir/$managedname/$host/$lpar.rrh-old" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar.rrh $wrkdir/$managedname/$host/$lpar.rrh-old: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rrh\n" if $DEBUG;
      rename( "$wrkdir/$managedname/$host/$lpar_old.rrh", "$wrkdir/$managedname/$host/$lpar.rrh" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar_old.rrh $wrkdir/$managedname/$host/$lpar.rrh: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrh")
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rmm" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rmm" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rmm --> $lpar.rmm-old\n" if $DEBUG;
        rename( "$wrkdir/$managedname/$host/$lpar.rmm", "$wrkdir/$managedname/$host/$lpar.rmm-old" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar.rmm $wrkdir/$managedname/$host/$lpar.rmm-old: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rmm\n" if $DEBUG;
      rename( "$wrkdir/$managedname/$host/$lpar_old.rmm", "$wrkdir/$managedname/$host/$lpar.rmm" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar_old.rmm $wrkdir/$managedname/$host/$lpar.rmm: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rmm")
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rsm" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rsm" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rsm --> $lpar.rsm-old\n" if $DEBUG;
        rename( "$wrkdir/$managedname/$host/$lpar.rsm", "$wrkdir/$managedname/$host/$lpar.rsm-old" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar.rsm $wrkdir/$managedname/$host/$lpar.rsm-old: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rsd\n" if $DEBUG;
      rename( "$wrkdir/$managedname/$host/$lpar_old.rsm", "$wrkdir/$managedname/$host/$lpar.rsm" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar_old.rsm $wrkdir/$managedname/$host/$lpar.rsm: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rsm")
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rsd" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rsd" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rsd --> $lpar.rsd-old\n" if $DEBUG;
        rename( "$wrkdir/$managedname/$host/$lpar.rsd", "$wrkdir/$managedname/$host/$lpar.rsd-old" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar.rsd $wrkdir/$managedname/$host/$lpar.rsd-old: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rsd\n" if $DEBUG;
      rename( "$wrkdir/$managedname/$host/$lpar_old.rsd", "$wrkdir/$managedname/$host/$lpar.rsd" ) || main::error( " Cannot mv $wrkdir/$managedname/$host/$lpar_old.rsd $wrkdir/$managedname/$host/$lpar.rsd: $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    } ## end if ( -f "$wrkdir/$managedname/$host/$lpar_old.rsd")

    # here delete LPM stuff, it will be recreated during next run for proper lpar names
    foreach my $lpm (<"$wrkdir/$managedname/$host/$lpar_old=====*=====*rrk">) {
      my $file_link = readlink("$lpm");
      print "LPAR rename lpm: $host:$managedname: $lpar_old --> $lpar_slash : $lpm --> $file_link\n" if $DEBUG;
      unlink("$file_link");
      unlink("$lpm");
    } ## end foreach my $lpm (<"$wrkdir/$managedname/$host/$lpar_old=====*=====*rrk">)
    foreach my $lpm (<"$wrkdir/$managedname/$host/$lpar_old=====*=====*rrl">) {
      my $file_link = readlink("$lpm");
      print "LPAR rename lpm: $host:$managedname: $lpar_old --> $lpar_slash : $lpm --> $file_link\n" if $DEBUG;
      unlink("$file_link");
      unlink("$lpm");
    } ## end foreach my $lpm (<"$wrkdir/$managedname/$host/$lpar_old=====*=====*rrl">)
  } ## end if ( !$lpar_recent eq ...)

  #else {
  #  print "LPAR rename    : $host:$managedname: $lpar:$serial has not been found for rename\n" if $DEBUG ;
  #}

  return 1;
} ## end sub rename_lpar

sub recent_rename {
  my $host          = shift;
  my $managedname   = shift;
  my $lpar          = shift;
  my $wrkdir        = shift;
  my $DEBUG         = shift;
  my $time_rec      = shift;
  my $act_time      = shift;
  my $RENAME_PERIOD = 600;     # if there is detected same lpar name 10 minutes after a rename then it is ignored

  my $rename_tmp = "$wrkdir/$managedname/$host/rename.tmp";
  if ( !-f "$rename_tmp" ) {
    return 0;
  }

  #print "001 $rename_tmp $lpar\n";

  open( FR, "< $rename_tmp" ) || main::error( " Can't open $rename_tmp : $!" . __FILE__ . ":" . __LINE__ ) && return 0;

  my @lines = <FR>;
  close(FR);
  foreach my $line (@lines) {
    chomp($line);
    ( my $time, my $lpar_act ) = split( /:/, $line );

    #print "002 $line $time - $lpar_act - $lpar - ($time + $RENAME_PERIOD) > $time_rec\n";
    if ( $lpar_act eq '' ) {
      next;    # some trash
    }
    if ( $lpar_act =~ m/^$lpar$/ && ( $time + $RENAME_PERIOD ) > $time_rec ) {
      print "rename ignore  : $host:$managedname:$lpar : rename period ignore : ($time + $RENAME_PERIOD) > $time_rec\n" if $DEBUG;
      return 1;
    }
  } ## end foreach my $line (@lines)

  return 0;
} ## end sub recent_rename

sub rrd_error {
  my $err_text = shift;
  my $rrd_file = shift;
  my $basedir  = $ENV{INPUTDIR};
  my $tmpdir   = "$basedir/tmp";
  if ( defined $ENV{TMPDIR_LPAR} ) {
    $tmpdir = $ENV{TMPDIR_LPAR};
  }

  chomp($err_text);

  if ( ! -f "$rrd_file" ) {
    return 0;
  }

  if ( ! -s "$rrd_file" ) {
    # fila has 0 size, remove it directly
    main::error("file $rrd_file has zero size, removing it");
    unlink("$rrd_file") || main::error("Cannot rm $rrd_file : $!" . __FILE__ . ":" . __LINE__ );
    return 0;
  }

  # Since 5.06: remove rrd file only if these errors appear:
  # ERROR: fetching cdp from rra at-
  # ERROR: reading the cookie off-
  # ERROR: short read while reading header rrd->stat_head
  # ERROR: mmaping file

  # Ignore everything else like to do not remove live data by a mistake
  # ERROR: This RRD was created on another architecture

  if ( $err_text =~ m/ERROR:/ && ( $err_text =~ m/mmaping file/ || $err_text =~ m/fetching cdp from rra/ || $err_text =~ m/reading the cookie off/ || $err_text =~ m/short read while reading header/ )) {
    # copy of the corrupted file into "save" place and remove the original one
    my $hmc_dir = dirname($rrd_file);
    my $server_dir = dirname($hmc_dir);
    my $server = basename($server_dir);
    my $all_save_path = "$tmpdir/$server";
    if ( ! -d "$all_save_path" ) {
      mkdir( "$all_save_path", 0755 ) || main::error( " Cannot mkdir $all_save_path: $!" . __FILE__ . ":" . __LINE__ );
    }
    copy( "$rrd_file", "$all_save_path/" ) || main::error("Cannot: cp $rrd_file $all_save_path/: $!" . __FILE__ . ":" . __LINE__ );

    unlink("$rrd_file") || main::error("Cannot rm $rrd_file : $!" . __FILE__ . ":" . __LINE__ );
    main::error("$err_text, moving it into: $all_save_path/");
  }
  else {
    main::error("$err_text"); # do no6t place here file & row because it is already in the message
  }
  return 0;
} ## end subrrd_error


sub touch_LPM {
  my $text = shift;

  my $version    = "$ENV{version}";
  my $basedir    = $ENV{INPUTDIR};
  my $new_change = "$basedir/tmp/$version-LPM";
  my $host       = $ENV{HMC};
  my $DEBUG      = $ENV{DEBUG};

  if ( !-f $new_change ) {
    `touch $new_change`;    # say install_html.sh that there was any change
    if ( $text eq '' ) {
      print "touch          : $host $new_change\n" if $DEBUG;
    }
    else {
      print "touch          : $host $new_change : $text\n" if $DEBUG;
    }
  } ## end if ( !-f $new_change )

  return 0;
} ## end sub touch_LPM

# it return idle cycles_init from $lpar_name-idle.txt or saves it and returns original one
sub get_lpar_idle_count {
  my $wrkdir      = shift;
  my $host        = shift;
  my $managedname = shift;
  my $lpar_name   = shift;
  my $cycles_init = shift;
  my $type        = shift;

  my $file_idle = "$wrkdir/$managedname/$host/$lpar_name-idle.txt";

  if ( $type =~ m/force/ ) {

    # do not get anything from file, save actual one
    open( FHLT, "> $file_idle" ) || main::error( " Can't open $file_idle : $! " . __FILE__ . ":" . __LINE__ ) && return $cycles_init;
    print FHLT "$cycles_init";
    close(FHLT);
    return $cycles_init;
  } ## end if ( $type =~ m/force/)

  if ( !-f $file_idle ) {
    open( FHLT, "> $file_idle" ) || main::error( " Can't open $file_idle : $! " . __FILE__ . ":" . __LINE__ ) && return $cycles_init;
    print FHLT "$cycles_init";
    close(FHLT);
  }
  else {
    open( FHLT, "< $file_idle" ) || main::error( " Can't open $file_idle : $! " . __FILE__ . ":" . __LINE__ ) && return $cycles_init;
    my @lines = <FHLT>;
    close(FHLT);
    foreach my $line (@lines) {
      chomp($line);
      $cycles_init = $line;
      last;
    }
  } ## end else [ if ( !-f $file_idle ) ]

  return $cycles_init;
} ## end sub get_lpar_idle_count

#opens and load the json content from .json file, store it to hash and returns it.
sub read_json{
  my $src=shift;
  if ($src =~ /.json.swp/){
    print "Found swap file, ignoring it. $src\n";
    return -1;
  }
  if (!defined $src || $src eq ""){
    print "Path to json file(\"$src\") not defined, can't read it in function read_json()\n";
    return -1;
  }
  my $read;
  my $rawcfg;       # helper for file reading
  # read from JSON file
  if ( open( CFG, "$src" ) ) {
    local $/ = undef;    # required for re-read of encode_json pretty output
    $rawcfg = <CFG>;
    if ($rawcfg) {
      eval{
        $read = JSON::decode_json($rawcfg);
      };
      if($@){
        #print "ERROR? Is this json file? $src\n You have probably opened some json file, this means nothing";
        main::error("Decoding of $src unsuccessful. File:".__FILE__.":".__LINE__);
        unlink($src);
        return -1;
      }
    }
    close CFG;
  }
  else {
    print "cannot open json file \"$src\" in read_json function, probably doesn't exist\n";
    # error handling
  }
  return $read;
}

sub load_data_hea {
  my $time              = "";
  my $counter           = 0;
  my $counter_tot       = 0;
  my $counter_ins       = 0;
  my $rrd               = "";
  my $rrd_max           = "";
  my $utime             = time() + 3600;
  my $jump              = 0;
  my $last_time         = "";

  my ( $managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file, $input_hea, $no_time, $json_configured, $save_files ) = @_;
  if ($json_configured eq "1"){
    my $perf_string = "hea_perf";
    my $iostatdir = "$wrkdir/$managedname/$host/iostat/";
    opendir( DIR, $iostatdir ) || main::error( "directory does not exists : $iostatdir " . __FILE__ . ":" . __LINE__ ) && return 0;

    my @files_unsorted = grep( /$perf_string/, readdir(DIR) );
    my @files = sort { lc $a cmp lc $b } @files_unsorted;
    #cyklus prochazejici json file po timestamp -> cyklus proch. json file po lparech (ziskam stejnou lajnu)
    my $ltiph;
    my $saved_ts;
    my $temp_ts;
    if (-e "$wrkdir/$managedname/$host/iostat/last_ts.hea"){
      open ($ltiph, "<", "$wrkdir/$managedname/$host/iostat/last_ts.hea") || main::error( "Cannot open file $wrkdir/$managedname/$host/iostat/last_ts.hea at".__LINE__);
      $saved_ts = readline($ltiph);
      close($ltiph);
    }
    else{
      $saved_ts = "not_defined";
    }
    if (!@files){
      return;
    }
    foreach my $file(@files){
      print "Rest API       " . strftime("%FT%H:%M:%S", localtime(time)) . "        : inserting $host $managedname $file to rrd files\n"  if $DEBUG;
      my $path = "$iostatdir$file";
      if (!(-e $path)){
        next;
      }
      #$content = HASH(###);
      my $content = read_json($path);
      if (!defined $content || $content eq "-1" || ref($content) eq "HASH"){
        print "$file is not valid : $content\n";
        unlink($path);
        next;
      }
      my $temp_ts;
      foreach my $sample (@{$content}){
        my $ts = $sample->[0];
        my $t = str2time( substr( $ts, 0, 19 ) );
        my $physicalLocation = $sample->[1];
        my $read = $sample->[2];
        my $io_read = $sample->[3];
        my $write = $sample->[4];
        my $io_write = $sample->[5];
        (undef, undef, my $short_physloc) = split ("\\.", $physicalLocation);
        $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.rah$type_sam"; #m;
        if (!-e $rrd){
          my $ret = create_rrd_gpa( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
        }
        my $last_rec;
        eval {
          RRDp::cmd qq(last "$rrd" );
          $last_rec = RRDp::read;
        };
        if ($@) {
          rrd_error( $@, $rrd );
          next;
        }
        chomp($$last_rec);
        my $ltime = $$last_rec;
        if ( $t > $ltime ) { #&& length($vios_name) > 0 )
          if (!(main::isdigit($io_read))){ $io_read = "U"; }
          if (!(main::isdigit($read))){ $read = "U"; }
          if (!(main::isdigit($io_write))){ $io_write = "U"; }
          if (!(main::isdigit($write))){ $write = "U"; }
          RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
          $last_time = $ts;
          my $answer = RRDp::read;
          $ltime = $t;
        } ## end if ( $t > $ltime && length...)
      }
=cut
      foreach my $timestamp (sort keys %{$content}){
        $temp_ts = $timestamp;
        if ($timestamp eq $saved_ts){next;}
        $temp_ts = $timestamp;
        foreach my $physicalLocation (keys %{$content->{$timestamp}}){
          my $read = "";
          my $io_read = "";
          my $write = "";
          my $io_write = "";

          my $ltime            = 0;
          my $rrd_exist_ok     = 0;
          my $rrd_exist_ok_max = 0;

          if (defined $content->{$timestamp}{$physicalLocation}{receivedBytesG}){$read=$content->{$timestamp}{$physicalLocation}{receivedBytesG};}
          if (defined $content->{$timestamp}{$physicalLocation}{receivedPacketsG}){$io_read=$content->{$timestamp}{$physicalLocation}{receivedPacketsG};}
          if (defined $content->{$timestamp}{$physicalLocation}{sentBytesG}){$write=$content->{$timestamp}{$physicalLocation}{sentBytesG};}
          if (defined $content->{$timestamp}{$physicalLocation}{sentPacketsG}){$io_write=$content->{$timestamp}{$physicalLocation}{sentPacketsG};}

          #my $testing_out = "$timestamp $vios_name $id $physicalLocation $read $io_read $write $io_write $dropped_packets $type";
          #( $time, my $vios_name, my $id, my $physicalLocation, my $read, my $io_read, my $write, my $io_write, my $running_speed, my $type) = split( /,/, $line );
          my $ret = substr( $timestamp, 0, 1 );
          if ( !defined $timestamp || $timestamp eq ""){next;}
          if ( $ret =~ /\D/ ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid heAdapters data got from HMC :$ret " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( $ret =~ /\D/ )
          my $t = str2time( substr( $timestamp, 0, 19 ) );
          if ( length($t) < 10 ) {
            # leave it as wrong input data
            main::error( "$host:$managedname : No valid heAdapters data got from HMC :$ret " . __FILE__ . ":" . __LINE__ );
            next;
          } ## end if ( length($t) < 10 )
          if ( $step == 3600 ) {
            # Put on the last time possition "00"!!!
            substr( $t, 8, 2, "00" );
          }
          my $dirname_tmp = "$wrkdir/$managedname/$host/iostat/";
          (undef, undef, my $short_physloc) = split ("\\.", $physicalLocation);
          $rrd     = "$wrkdir/$managedname/$host/adapters/$short_physloc.rah$type_sam"; #m;

          #create rrd db if necessary
          if (!(-e $rrd)){
            if ( $rrd_exist_ok == 0 ) {
              my $ret = create_rrd_gpa( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
              if ( $ret == 2 ) {
                next; # muj test????
                #return 1;    # RRD creation problem, skip whole load
              }
              $rrd_exist_ok = 1;
            }## end if ( $rrd_exist_ok == ...)
          } #end if (!(-e $rrd))
          if ( $ltime == 0 ) {

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            my $last_rec = 0;
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;
            };
            if ($@) {
              #RRDp::error_mode = "catch";
              rrd_error( $@, $rrd );
              $rrd_exist_ok = 0;
              next;
            }
            chomp($$last_rec);
            $ltime = $$last_rec;
          } ## end if ( $ltime == 0 )

          # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $ltime ) { #&& length($vios_name) > 0 )
            my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {

              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $jump == 0 ) {
                $jump = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              } ## end if ( $jump == 0 )
              # looks like it is ok as it is second timestap in a row
            } ## end if ( $t > $jump_time )
            $jump = 0;
            $counter_ins++;
            if (!(main::isdigit($read))){ $read = "U"; }
            if (!(main::isdigit($io_read))){ $io_read = "U"; }
            if (!(main::isdigit($write))){ $write = "U"; }
            if (!(main::isdigit($io_write))){ $io_write = "U"; }
            RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);

            $last_time = $timestamp;
            my $answer = RRDp::read;
            # update the time of last record
            $ltime = $t;
           } ## end if ( $t > $ltime && length...)
          } #end foeach my $physLocaltion
      } #end foreach my $timestamp
=cut
      ##unlink ($path) || print("Cannot delete file $path ". __FILE__. ":". __LINE__);
      if (defined $file && defined $files[-1] && defined $files[-2]){
      if ($file eq $files[-1]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/hea_perf1");
      }
      if ($file eq $files[-2]){
        copy ($path, "$ENV{INPUTDIR}/tmp/$managedname/hea_perf2");
      }
      }
      if ($save_files =~ /^-?\d+$/){
        if ($save_files == 0){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      else{
        if ($save_files ne $managedname){
          unlink($path) || error ("Cannot unlink $path in ".__FILE__.":".__LINE__);
        }
      }
      open ($ltiph, ">", "$wrkdir/$managedname/$host/iostat/last_ts.hea");
      print $ltiph "$temp_ts";
      close($ltiph);
    } #end foreach my $file
  } #end if (json configured)
  else{
  return; # HEA is loaded from separated cron job or Rest API, no in-m file is supported
  open (FH, "< $input_hea-$type_sam") || main::error( " Can't open $input_hea-$type_sam : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
  my @lines = reverse <FH>;
  close(FH);
  foreach my $line (@lines) {
    my $ltime            = 0;
    my $rrd_exist_ok     = 0;
    my $rrd_exist_ok_max     = 0;
    chomp($line);
    ( $time, my $vios_name, my $id, my $physicalLocation, my $io_read, my $io_write, my $read, my $write) = split( /,/, $line );
    my $ret = substr( $time, 0, 1 );
    if ( $ret =~ /\D/ ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( $ret =~ /\D/ )
    my $t = str2time( substr( $time, 0, 19 ) );
    if ( length($t) < 10 ) {
      # leave it as wrong input data
      main::error( "$host:$managedname : No valid adapters data got from HMC :$ret : $line " . __FILE__ . ":" . __LINE__ );
      next;
    } ## end if ( length($t) < 10 )
    if ( $step == 3600 ) {

      # Put on the last time possition "00"!!!
      substr( $t, 8, 2, "00" );
    }
    my $dirname_tmp = "$wrkdir/$managedname/$host/adapters/";
    $rrd     = "$wrkdir/$managedname/$host/adapters/$physicalLocation.rap$type_sam";

    #create rrd db if necessary
    if ( $rrd_exist_ok == 0 ) {
      my $ret = create_rrd_gpa( $rrd, $t, $counter_tot, $step, $type_sam, $DEBUG, $host, $managedname, $no_time, $act_time );
      if ( $ret == 2 ) {
        return 1;    # RRD creation problem, skip whole load
      }
      $rrd_exist_ok = 1;
    } ## end if ( $rrd_exist_ok == ...)

    if ( $ltime == 0 ) {

      # construction against crashing daemon Perl code when RRDTool error appears
      # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
      # construction is not too costly as it runs once per each load
      my $last_rec = 0;
      eval {
        RRDp::cmd qq(last "$rrd" );
        $last_rec = RRDp::read;
      };
      if ($@) {
        rrd_error( $@, $rrd );
        $rrd_exist_ok = 0;
        next;
      }
      chomp($$last_rec);
      $ltime = $$last_rec;
    } ## end if ( $ltime == 0 )

    # it updates only ifl time is newer and there is the data (fix for situation that the data is missing)
    if ( $t > $ltime ) { #&& length($vios_name) > 0 ) {
      my $jump_time = $ltime + $JUMP_DETECT;    #set time for sudden jump detection (15mins)
      if ( $t > $jump_time ) {

        # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
        # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
        if ( $jump == 0 ) {
          $jump = 1;

          #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
          #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
          next;
        } ## end if ( $jump == 0 )

        # looks like it is ok as it is second timestap in a row
      } ## end if ( $t > $jump_time )
      $jump = 0;
      $counter_ins++;

      #print "$counter_ins : $time $t:$promenne \n";


      #RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);
      if (!(main::isdigit($read))){ $read = "U"; }
      if (!(main::isdigit($io_read))){ $io_read = "U"; }
      if (!(main::isdigit($write))){ $write = "U"; }
      if (!(main::isdigit($io_write))){ $io_write = "U"; }
      RRDp::cmd qq(update "$rrd" $t:$read:$io_read:$write:$io_write);



      $last_time = $time;
      my $answer = RRDp::read;

      # update the time of last record
      $ltime = $t;
    } ## end if ( $t > $ltime && length...)
  } ## end foreach my $line (@lines)
  if ( $counter_ins > 0 ) {
    print "inserted       : $host:$managedname:fiber_channel_adapters $counter_ins record(s)\n" if $DEBUG;
  }
  }

  # write down timestamp of last record
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG;
    open( FHLT, "> $wrkdir/$managedname/$host/$last_file" ) || main::error( " Can't open $wrkdir/$managedname/$host/$last_file : $!" . __FILE__ . ":" . __LINE__ ) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  } ## end if ( $type_sam !~ "d" ...)

  return 0;
} ## end sub load_data_hea
